Package: MEDIPS
Type: Package
Title: DNA IP-seq data analysis
Version: 1.64.0
Date: 2020-02-15
Author: Lukas Chavez, Matthias Lienhard, Joern Dietrich, Isaac Lopez Moyado
Maintainer: Lukas Chavez <lukaschavez@ucsd.edu>
Description: MEDIPS was developed for analyzing data derived from
        methylated DNA immunoprecipitation (MeDIP) experiments followed
        by sequencing (MeDIP-seq). However, MEDIPS provides functionalities for the analysis of any kind of quantitative
        sequencing data (e.g. ChIP-seq, MBD-seq, CMS-seq and others)
        including calculation of differential coverage between groups
        of samples and saturation and correlation analysis.
License: GPL (>=2)
LazyLoad: yes
Depends: R (>= 3.0), BSgenome, Rsamtools
Imports: GenomicRanges, Biostrings, graphics, gtools, IRanges, methods,
        stats, utils, edgeR, DNAcopy, biomaRt, rtracklayer,
        preprocessCore
Suggests: BSgenome.Hsapiens.UCSC.hg19, MEDIPSData, BiocStyle
biocViews: DNAMethylation, CpGIsland, DifferentialExpression,
        Sequencing, ChIPSeq, Preprocessing, QualityControl,
        Visualization, Microarray, Genetics, Coverage,
        GenomeAnnotation, CopyNumberVariation, SequenceMatching
NeedsCompilation: no
Packaged: 2026-04-28 23:06:41 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/MEDIPS
git_branch: RELEASE_3_23
git_last_commit: 0101639
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28

##########
#Function to plot the results of the sequence coverage analysis.
##########
##Input:	A seqCoverage result object.
##Param:	seqCoverageObj, main (characrter), type (pie | hist), cov.level
##Output:	Plot
##Modified:	11/10/2011
##Author:	Lukas Chavez

MEDIPS.plotSeqCoverage <-
function(seqCoverageObj=NULL, main=NULL, type="pie", cov.level = c(0,1,2,3,4,5), t="Inf"){
	
	if(is.null(seqCoverageObj)){stop("Must specify a coverage object.")}

	cov.res=	seqCoverageObj$cov.res
	numberPos=	length(cov.res)	
	pattern=	seqCoverageObj$pattern
	numberReads=	seqCoverageObj$numberReads
	numberReadsWO=	seqCoverageObj$numberReadsWO
	
	if(is.null(main)){main = paste("Total number of ", pattern, "'s: ", numberPos, sep="") }
	
	sub = paste(numberReadsWO, " of ", numberReads, " reads (", round((numberReadsWO/numberReads*100), digits=2) , "%) do not cover a pattern", sep="")
 	
	if(type=="pie"){
	
		cat("Creating summary...\n")
		results = NULL
		for(i in 1:length(cov.level)){
			if(i==1){
				results = c(results, length(cov.res[cov.res<=cov.level[i]]))
			}
			else{
				results = c(results, length(cov.res[cov.res>cov.level[i-1] & cov.res<=cov.level[i]]))
			}
		}
		results = c(results, length(cov.res[cov.res>cov.level[length(cov.level)]]))	
		
		#Set the labels for the output plot
		labels = NULL
		for(i in 1:length(cov.level)){
			if(i==1){
				labels = c(labels, paste("<=", cov.level[i], "x (", round((results[i]/numberPos)*100, digits=2), "%)", sep=""))
			}
			else{
				labels = c(labels, paste(cov.level[i-1]+1, "-", cov.level[i], "x (", round((results[i]/numberPos)*100, digits=2), "%)", sep=""))
		 	}
		}
		labels = c(labels, paste(">", cov.level[length(cov.level)], "x (", round((results[length(results)]/numberPos)*100, digits=2), "%)", sep=""))
			
	
		#Set the colors for the output plot
		col = NULL
		for(i in 1:(length(cov.level))){	
			if(i==1){col="red"}
			if(i==2){col=c(col,"green")}
			if(i==3){col=c(col,"blue")}
			if(i==4){col=c(col,"orange")}
			if(i==5){col=c(col,"brown")}
			if(i>5){col=c(col,"darkgrey")}
		}
		##Plot	
		pie(
			results, 
			labels=labels, 
			col=col, 
			main=main,
			sub=sub
		)
	}
	else if(type=="hist"){
		hist(cov.res[cov.res<=t], 
			main=main,
			sub=sub
		)
	}
	else{stop("Plot type not supported.")}
	
}

##########################################################################
##Creates MEDIPS SET of type S4 from input data (i.e. aligned short reads)
##########################################################################
##Input:	bam file or tab (|) separated txt file "chr | start | stop  | strand"
##Param:	[path]+file name, extend, shift, window_size, BSgenome, uniq, chr.select
##Output:	MEDIPS SET
##Requires:	gtools, BSgenome
##Modified:	22/4/2015
##Author:	Lukas Chavez, Matthias Lienhard, Isaac Lopez Moyado

MEDIPS.createSet <-
function (file = NULL, extend = 0, shift = 0, window_size = 300, 
    BSgenome = NULL, uniq = 1e-3, chr.select = NULL, paired = F, 
    sample_name = NULL, isSecondaryAlignment = FALSE, simpleCigar=TRUE) 
{
    if (is.null(BSgenome)) {
        stop("Must specify a BSgenome library.")
    }
    if (is.null(file)) {
        stop("Must specify a bam or txt file.")
    }
    fileName = unlist(strsplit(file, "/"))[length(unlist(strsplit(file, 
        "/")))]
    path = paste(unlist(strsplit(file, "/"))[1:(length(unlist(strsplit(file, 
        "/")))) - 1], collapse = "/")
    if (path == "") {
        path = getwd()
    }
    dataset = getBSgenome(BSgenome)
    if (is.null(chr.select)) {
        cat("All chromosomes in the reference BSgenome will be processed:\n")
        chr.select = seqnames(dataset)
        print(chr.select)
    }
    else {
        if (sum(!chr.select %in% seqnames(dataset)) != 0) {
            cat("The requested chromosome(s)", chr.select[!chr.select %in% 
                seqnames(dataset)], "are not available in the BSgenome reference. Chromosomes available in the BSgenome reference:", 
                seqnames(dataset), "\n")
            stop("Please check chromosome names.")
        }
    }
    if (length(chr.select) > 1) {
        chr.select = mixedsort(unique(chr.select))
    }
    if (!fileName %in% dir(path)) {
        stop(paste("File", fileName, " not found in", path, sep = " "))
    }
    ext = strsplit(fileName, ".", fixed = T)[[1]]
    if (ext[length(ext)] %in% c("gz", "zip", "bz2")) 
        ext = ext[-length(ext)]
    if (ext[length(ext)] %in% c("wig", "bw", "bigwig")) {
        MEDIPSsetObj = getMObjectFromWIG(fileName, path, chr.select, 
            BSgenome)
    }
    else {
        if (!paired) {
            GRange.Reads = getGRange(fileName, path, extend, 
                shift, chr.select, dataset, uniq, isSecondaryAlignment = isSecondaryAlignment, simpleCigar=simpleCigar)
        }
        else {
            GRange.Reads = getPairedGRange(fileName, path, extend, 
                shift, chr.select, dataset, uniq, isSecondaryAlignment = isSecondaryAlignment, simpleCigar=simpleCigar)
        }
        chr_lengths = as.numeric(seqlengths(dataset)[chr.select])
        no_chr_windows = ceiling(chr_lengths/window_size)
        supersize_chr = cumsum(no_chr_windows)
        Granges.genomeVec = MEDIPS.GenomicCoordinates(supersize_chr, 
            no_chr_windows, chr.select, chr_lengths, window_size)
        
        cat("Calculating short read coverage at genome wide windows...\n")
        overlap = countOverlaps(Granges.genomeVec, GRange.Reads)
        datachr = unique(seqlevels(GRange.Reads))
       
        if (sum(!chr.select %in% datachr) != 0) {
            cat("Please note, no data in the alignment file for chromosome(s):", 
                chr.select[!chr.select %in% datachr], "\n")
        }
       
        if (is.null(sample_name)) {
            sample_name = fileName
        }

        MEDIPSsetObj = new("MEDIPSset", sample_name = sample_name, 
            path_name = path, genome_name = BSgenome, number_regions = length(GRange.Reads), 
            chr_names = chr.select, chr_lengths = chr_lengths, 
            genome_count = overlap, extend = extend, shifted = shift, 
            window_size = window_size, uniq = uniq)
    }
    return(MEDIPSsetObj)
}

##########################################################################
##Function takes a MEDIPSset and COUPLINGSet object, and performs linear regression
##########################################################################
##Input:	MEDIPS SET and COUPLING SET
##Param:	MSet, CSet, input [T | F]
##Output:	List of calibration curve and linear regression results
##Modified:	1/09/2015
##Author:	Lukas Chavez

###############
##Function takes a MEDIPSset object, calculates the calibration curve and the parameters intercept and slope.
###############
MEDIPS.calibrationCurve <- function(MSet=NULL, CSet=NULL, input=FALSE){
	
	signal=		genome_count(MSet)
	coupling=	genome_CF(CSet)	
	maxCoup = floor(max(coupling)*0.8)
				
	cat("Calculating calibration curve...\n")			
	mean_signal = NULL
	coupling_level = NULL
	
	count_decrease_steps = 0
	max_signal_index = NULL

	first = TRUE
	n_coupling = 0

	for(i in 1:(maxCoup+1)){		

		#Test if coupling level is non-empty (can happen for ROIs)
		if(length(signal[coupling==i-1])>0){

			n_coupling = n_coupling + 1
			mean_signal = c(mean_signal, mean(signal[coupling==i-1], trim=0.1))
			coupling_level = c(coupling_level, i-1)
		
			##Test if mean_signal decreases
			if(!first){

				if(is.null(max_signal_index) & mean_signal[n_coupling]<mean_signal[n_coupling-1]){				
					count_decrease_steps=count_decrease_steps+1
					if(count_decrease_steps==3){
						max_signal_index=n_coupling-3		
					}
				}
				else if(is.null(max_signal_index) & mean_signal[n_coupling]>=mean_signal[n_coupling-1]){
					count_decrease_steps=0
				}	
			}
			else{
				first = FALSE
			}
		} 
		else{
			cat(paste("Skipping coupling level ", i, " (no data).\n", sep=""))
		}						
	}

	if(!input & is.null(max_signal_index)){stop("The dependency of coverage signals on sequence pattern (e.g. CpG) densities is different than expected. No linear model can be build, please check the calibration plot by providing the MSet object at ISet.")}
				
 	if(!input){
		##Linear curve by linear least squares regression
		##################
		cat("Performing linear regression...\n")
			
		fit=lm(mean_signal[1:max_signal_index] ~ coupling_level[1:max_signal_index])
		intercept=fit$coefficients[[1]]
		slope=fit$coefficients[[2]]
		cat(paste("Intercept:", intercept, "\n"))
		cat(paste("Slope:", slope, "\n"))
	}
	else{
		intercept=NA
		slope=NA
	}	
	gc()
	return(list(mean_signal=mean_signal, coupling_level=coupling_level, max_index=max_signal_index, intercept=intercept, slope=slope))
}

##########################################################################
##Function calcuates CNV via DNAcopy for two groups of INPUT SETs
##########################################################################
##Input:	Two groups of INPUT SETs
##Param:	base, rpkm.input, nISets1, nISets2
##Output:	results of CNV analysis
##Requires:	DNAcopy
##Modified:	11/22/2011
##Author:	Lukas Chavez, Joern Dietrich

MEDIPS.cnv = function(base=base, rpkm.input=NULL, nISets1=NULL, nISets2=NULL)
{
	if(nISets1>1){
		control.input.mean = rowMeans(rpkm.input[,1:nISets1])
	}
	else{
		control.input.mean = rpkm.input[,1]
	}
	
	if(nISets2>1){
                treat.input.mean = rowMeans(rpkm.input[,(nISets1+1):ncol(rpkm.input)])
        }
        else{
		treat.input.mean = rpkm.input[,nISets1+1]
       	}


	log2ratios.inputs = log2(control.input.mean/treat.input.mean)
	cnv.ID = "ISets.mean"
	
	nperm=10000
	alpha=0.01 
	max.ones=floor(nperm*alpha)+1
	default.DNAcopy.bdry=DNAcopy::getbdry(nperm=10000, eta=0.05,max.ones=max.ones)
  	CNA.object <- DNAcopy::CNA(log2ratios.inputs, base[,1], floor((base[,2]+base[,3])/2), data.type="logratio", sampleid=cnv.ID, presorted=TRUE)
	
	smoothed.CNA.object <- DNAcopy::smooth.CNA(CNA.object)
	
	segment.smoothed.CNA.object <- DNAcopy::segment(smoothed.CNA.object, verbose=2,sbdry = default.DNAcopy.bdry)				
	
	cnv.combined = cbind(segment.smoothed.CNA.object$segRows$startRow,
						 segment.smoothed.CNA.object$segRows$endRow, 
						 segment.smoothed.CNA.object$output$seg.mean)
	rm(CNA.object, smoothed.CNA.object, segment.smoothed.CNA.object, control.input.mean, treat.input.mean, log2ratios.inputs)
	gc()
	
	return(cnv.combined)
}

##########################################################################
##Function to add results from CNV analysis 
##########################################################################
##Input:	Result matrix and input sets 
##Param:	ISet1,ISet2,results,uniq,chr,cnv.Frame
##Output:	List of annotation matrix 
##Requires:	BSgenome,DNAcopy
##Modified:	11/22/2011
##Author:	Joern Dietrich
MEDIPS.addCNV<-function(ISet1, ISet2, results, cnv.Frame=1000){

	nISets1 = length(ISet1)	
	nISets2 = length(ISet2)	
	
	if(!is.list(ISet1)) ISet1=c(ISet1)
	if(!is.list(ISet2)) ISet2=c(ISet2)
	
	cnv.rpkm.input=NULL
	
	for(i in 1:nISets1){
		file=paste(path_name(ISet1[[i]]),sample_name(ISet1[[i]]),sep="/");
		tmp.cnv = MEDIPS.createSet(file=file, 
				BSgenome=genome_name(ISet1[[i]]), 
				chr.select=chr_names(ISet1[[i]]),
				extend=extend(ISet1[[i]]),
				shift=shifted(ISet1[[i]]), 
				uniq=uniq(ISet1[[i]]), 
				window_size=cnv.Frame)
		
		cnv.rpkm.input = cbind(cnv.rpkm.input, ((genome_count(tmp.cnv)*10^9)/(cnv.Frame*number_regions(tmp.cnv))))	
	}
	
	for(i in 1:nISets2){
		file=paste(path_name(ISet2[[i]]),sample_name(ISet2[[i]]),sep="/");
		tmp.cnv = MEDIPS.createSet(file=file, 
				BSgenome=genome_name(ISet2[[i]]),
				chr.select=chr_names(ISet2[[i]]), 
				extend=extend(ISet2[[i]]), 
				shift=shifted(ISet2[[i]]),
				uniq=uniq(ISet2[[i]]), 
				window_size=cnv.Frame)
		
		cnv.rpkm.input = cbind(cnv.rpkm.input, ((genome_count(tmp.cnv)*10^9)/(cnv.Frame*number_regions(tmp.cnv))))	
	}
							           							           
	no_chr_windows = ceiling(chr_lengths(tmp.cnv)/cnv.Frame)
	supersize_chr = cumsum(no_chr_windows)
	cvn.GRanges.genome = MEDIPS.GenomicCoordinates(supersize_chr, no_chr_windows, chr_names(tmp.cnv), chr_lengths(tmp.cnv), cnv.Frame)
	base = data.frame(chr=as.vector(seqnames(cvn.GRanges.genome)), start=start(cvn.GRanges.genome), stop=end(cvn.GRanges.genome), stringsAsFactors=F)
	
	cat(paste("CNV analysis...\n", sep=" "))
	cnv.combined = MEDIPS.cnv(base=base, rpkm.input=cnv.rpkm.input, nISets1=nISets1, nISets2=nISets2)
	
	dummy.results = matrix(ncol=1, nrow=(nrow(base)))
	for(i in 1:nrow(cnv.combined)){
		dummy.results[cnv.combined[i,1]:cnv.combined[i,2]] = cnv.combined[i,3]		
	}
	colnames(dummy.results)="CNV"
    	dummy.results=cbind(dummy.results, base)
	
	results=MEDIPS.setAnnotation(results, dummy.results, cnv=T)
	
	rm(dummy.results)	
	gc()
	
	return(results)
}

##########################################################################
##Function calculates genome wide methylation signals for each provided set and
##calculates differential coverage between groups of MEDIPS SETs (if provided) and
##calculates CNV scores between groups of INPUT SETs (if provided)
##########################################################################
##Input:	Groups of MEDIPS and INPUT SETs
##Param:	MSet1, MSet2, CSet, ISet1, ISet2, chr, p.adj, diff.method, minRowSum, norm
##Output:	Result table
##Requires:	DNAcopy
##Modified:	04/02/2015
##Author:	Lukas Chavez

MEDIPS.meth = function(
		MSet1 = NULL, 
		MSet2 = NULL, 
		CSet = NULL, 
		ISet1 = NULL, 
		ISet2 = NULL, 
		chr = NULL, 
		p.adj="bonferroni", 
		diff.method="edgeR", 
		CNV=FALSE,
		MeDIP=FALSE,
		minRowSum=10,
		diffnorm="tmm"
		)
{
	nMSets1 = length(MSet1)	
	nMSets2 = length(MSet2)	
	nISets1 = length(ISet1)	
	nISets2 = length(ISet2)	
	if(is.list(CSet)) CSet=CSet[[1]]
	if(!is.list(MSet1)) MSet1=c(MSet1)
	if(!is.list(MSet2)) MSet2=c(MSet2)
	if(!is.list(ISet1)) ISet1=c(ISet1)
	if(!is.list(ISet2)) ISet2=c(ISet2)
	
	##Proof of correctness
	#######################
	if(MeDIP){
		if(class(CSet)!="COUPLINGset"){stop("You have to state a COUPLINGset object!")}
	}

	controlSet = MSet1[[1]]

	for(i in 1:nMSets1){
		if(class(MSet1[[i]])!="MEDIPSset" & class(MSet1[[i]])!="MEDIPSroiSet"){stop("You have to state a MEDIPSset or MEDIPSroiSet object!")}
		if(length(genome_count(MSet1[[i]]))!=length(genome_count(controlSet)))stop("MEDIPSset/MEDIPSroiSet objects are of different length!")
	}
	if(!is.null(MSet2)){
    		for(i in 1:nMSets2){
			if(class(MSet2[[i]])!="MEDIPSset" & class(MSet2[[i]])!="MEDIPSroiSet"){stop("You have to state a MEDIPSset or MEDIPSroiSet object!")}
			if(length(genome_count(MSet2[[i]]))!=length(genome_count(controlSet)))stop("MEDIPSset/MEDIPSroiSet objects are of different length!")
    		}
	}	
	if(!is.null(ISet1)){
		for(i in 1:nISets1){
			if(class(ISet1[[i]])!="MEDIPSset" & class(ISet1[[i]])!="MEDIPSroiSet"){stop("You have to state a MEDIPSset or MEDIPSroiSet object!")}
			if(length(genome_count(ISet1[[i]]))!=length(genome_count(controlSet)))stop("MEDIPSset/MEDIPSroiSet objects are of different length!")
		}
	}
	if(!is.null(ISet2)){
		for(i in 1:nISets2){
			if(class(ISet2[[i]])!="MEDIPSset" & class(ISet2[[i]])!="MEDIPSroiSet"){stop("You have to state a MEDIPSset or MEDIPSroiSet object!")}
			if(length(genome_count(ISet2[[i]]))!=length(genome_count(controlSet)))stop("MEDIPSset/MEDIPSroiSet objects are of different length!")
		}
	}


	##Data preparation
	###################
	##Calculate genomic coordinates
	##################################
	if(class(controlSet)=="MEDIPSset"){
		window_size = window_size(controlSet)
		no_chr_windows = ceiling(chr_lengths(controlSet)/window_size(controlSet))
		supersize_chr = cumsum(no_chr_windows)	
		GRanges.genome = MEDIPS.GenomicCoordinates(supersize_chr, no_chr_windows, chr_names(controlSet), chr_lengths(controlSet), window_size(controlSet))
	}
	else if(class(controlSet)=="MEDIPSroiSet"){
		GRanges.genome = rois(controlSet)
		window_size=as.numeric(width(GRanges.genome))
	} 
	
	##Create data frame for all genomic windows and MEDIPS SETs
	if(MeDIP){
		base = data.frame(chr=as.vector(seqnames(GRanges.genome)), start=start(GRanges.genome), stop=end(GRanges.genome), CF=genome_CF(CSet), stringsAsFactors=F)
	}
	else{
		base = data.frame(chr=as.vector(seqnames(GRanges.genome)), start=start(GRanges.genome), stop=end(GRanges.genome), stringsAsFactors=F)
	}

	rm(controlSet)
	gc()

	counts.medip = NULL
	rpkm.medip = NULL
	rms = NULL	
	counts.input = NULL
	rpkm.input = NULL
	
	##Add counts
	if(!is.null(MSet1)){
		for(i in 1:nMSets1){
			cat(paste("Preprocessing MEDIPS SET ", i, " in MSet1...\n", sep=""))
			counts.medip = cbind(counts.medip, MSet1=genome_count(MSet1[[i]]))
			rpkm.medip = cbind(rpkm.medip, round(((genome_count(MSet1[[i]])*10^9)/(window_size*number_regions(MSet1[[i]]))), digits=2))
			if(MeDIP){
				ccObj = MEDIPS.calibrationCurve(MSet=MSet1[[i]], CSet=CSet, input=F)
				rms = cbind(rms, MEDIPS.rms(MSet1[[i]], CSet, ccObj=ccObj))
			}		
		}
	}	
	if(!is.null(MSet2)){
		 for(i in 1:nMSets2){
			cat(paste("Preprocessing MEDIPS SET ", i, " in MSet2...\n", sep=""))
			counts.medip = cbind(counts.medip, MSet2=genome_count(MSet2[[i]]))
			rpkm.medip = cbind(rpkm.medip, round(((genome_count(MSet2[[i]])*10^9)/(window_size*number_regions(MSet2[[i]]))), digits=2))
			if(MeDIP){
				ccObj = MEDIPS.calibrationCurve(MSet=MSet2[[i]], CSet=CSet, input=F)
				rms = cbind(rms, MEDIPS.rms(MSet2[[i]], CSet, ccObj=ccObj))
			}
	  	 }
	}	
	if(!is.null(ISet1)){		
		for(i in 1:nISets1){
			cat(paste("Preprocessing INPUT SET ", i, " in ISet1...\n", sep=""))
			counts.input = cbind(counts.input, ISet1=genome_count(ISet1[[i]]))
			rpkm.input = cbind(rpkm.input, round(((genome_count(ISet1[[i]])*10^9)/(window_size*number_regions(ISet1[[i]]))), digits=2))
		   }
	}	
	if(!is.null(ISet2)){
		for(i in 1:nISets2){
			cat(paste("Preprocessing INPUT SET ", i, " in ISet2...\n", sep=""))
			counts.input = cbind(counts.input, ISet2=genome_count(ISet2[[i]]))
			rpkm.input = cbind(rpkm.input, round(((genome_count(ISet2[[i]])*10^9)/(window_size*number_regions(ISet2[[i]]))), digits=2))
		 	}
	}		
	
	##Extract data for selected chromosome
	#######################################
	if(!is.null(chr)){
		fi=base[,1]%in%chr
		
		cat("Extracting data for", chr, "...\n", sep=" ")
		if(length(fi)==0){stop("Stated chromosome does not exist in the COUPLING SET.")}
		if(!is.null(counts.medip)){
			counts.medip = counts.medip[fi,]
			rpkm.medip = rpkm.medip[fi,]
			rms = rms[fi,]
		}
		if(!is.null(counts.input)){
			counts.input = counts.input[fi,]
			rpkm.input = rpkm.input[fi,]
		}
		base = base[fi,]
		cat(nrow(base), "windows on", chr, "\n",sep=" ")		
	}
	
	##Set colnames and transform to data.frames
	############################################
	col.names.count = NULL
	col.names.rpkm = NULL
	col.names.rms = NULL
	if(nMSets1!=0){
		for(i in 1:nMSets1){
			col.names.count = c(col.names.count, paste(sample_name(MSet1[[i]]), ".counts", sep=""))
			col.names.rpkm = c(col.names.rpkm, paste(sample_name(MSet1[[i]]), ".rpkm", sep=""))
			if(MeDIP){
				col.names.rms = c(col.names.rms, paste(sample_name(MSet1[[i]]), ".rms", sep=""))
			}
		}		
	}
	if(nMSets2!=0){
		for(i in 1:nMSets2){
			col.names.count = c(col.names.count, paste(sample_name(MSet2[[i]]), ".counts", sep=""))
			col.names.rpkm = c(col.names.rpkm, paste(sample_name(MSet2[[i]]), ".rpkm", sep=""))
			if(MeDIP){
				col.names.rms = c(col.names.rms, paste(sample_name(MSet2[[i]]), ".rms", sep=""))
			}
		}		
	}
	if(nMSets1!=0 | nMSets2!=0){
		
		counts.medip = data.frame(counts.medip)
		colnames(counts.medip) = col.names.count
		rpkm.medip =  data.frame(rpkm.medip)
		colnames(rpkm.medip) = 	col.names.rpkm
		if(MeDIP){
			rms = data.frame(rms)
			colnames(rms) = col.names.rms
		}
	}		
	
	col.names.count.input = NULL
	col.names.rpkm.input = NULL
	if(nISets1!=0){
		for(i in 1:nISets1){
			col.names.count.input = c(col.names.count.input, paste(sample_name(ISet1[[i]]), ".counts", sep=""))
			col.names.rpkm.input = c(col.names.rpkm.input, paste(sample_name(ISet1[[i]]), ".rpkm", sep=""))
		}		
	}
	if(nISets2!=0){
		for(i in 1:nISets2){
			col.names.count.input = c(col.names.count.input, paste(sample_name(ISet2[[i]]), ".counts", sep=""))
			col.names.rpkm.input = c(col.names.rpkm.input, paste(sample_name(ISet2[[i]]), ".rpkm", sep=""))
		}		
	}
	
	if(nISets1!=0 | nISets2!=0){		
		
		counts.input = data.frame(counts.input)
		colnames(counts.input) = 	col.names.count.input
		rpkm.input = data.frame(rpkm.input)	
		colnames(rpkm.input) = 		col.names.rpkm.input
	}
		
	
	##If two groups of MEDIPS SETs are given 
	##calculate differential coverage
	##################################
	if(!is.null(MSet1) & !is.null(MSet2)){
		cat(paste("Differential coverage analysis...\n", sep=" "))
		
		##Correct for test selection if necessary
		if((nMSets1<3 | nMSets2<3) & diff.method=="ttest"){
			stop("Method 'ttest' is not valid for less than 3 replicates per group. Method 'edgeR' can be applied in this case.")
		}		
		
		if(diff.method=="edgeR"){
			
			if(diffnorm=="rpkm" | diffnorm=="rms"){
				stop("rpkm and rms normalization are not available for the edgeR mode. Here, differential enrichment is performed on the count data. Please set diffnorm to tmm or quantile.\n")
			}
			
			##Extract number of reads per sample
			if(!is.null(MSet1)){
				n.r.M1 = NULL
				for(i in 1:nMSets1){
					n.r.M1 = c(n.r.M1, number_regions(MSet1[[i]]))		
				}
			}	
			if(!is.null(MSet2)){
		 		n.r.M2 = NULL
		 		for(i in 1:nMSets2){
					n.r.M2 = c(n.r.M2, number_regions(MSet2[[i]]))	
	  	 		}
			}	

			#Quantile normalization
			if(diffnorm=="quantile"){
				cat("Performing quantile normalization on sequencing counts. Please note, the returned counts - but not the returned rpkm values - will be quantile normalized.\n")
				counts.medip.coln = colnames(counts.medip)				
				counts.medip = preprocessCore::normalize.quantiles(as.matrix(counts.medip), copy=FALSE)	
				counts.medip <- round(counts.medip)
				colnames(counts.medip) = counts.medip.coln
			}
		
			diff.results.list = MEDIPS.diffMeth(base=base, values=counts.medip, diff.method="edgeR", nMSets1=nMSets1, nMSets2=nMSets2, p.adj=p.adj, n.r.M1=n.r.M1, n.r.M2=n.r.M2, MeDIP=MeDIP, minRowSum=minRowSum, diffnorm=diffnorm)
		}
		else if(diff.method=="ttest"){

			if(diffnorm=="quantile" | diffnorm=="tmm"){
				stop("Quantile and TMM normalization are not available for the t-test mode. Please chose edgeR or set diffnorm to rpkm or rms.\n")
			}

			if(diffnorm=="rpkm"){
				diff.results.list = MEDIPS.diffMeth(base=base, values=rpkm.medip, diff.method="ttest", nMSets1=nMSets1, nMSets2=nMSets2, p.adj=p.adj, MeDIP=MeDIP, minRowSum=minRowSum)
			}
			else if(diffnorm=="rms"){
				if(MeDIP){
					diff.results.list = MEDIPS.diffMeth(base=base, values=rms, diff.method="ttest", nMSets1=nMSets1, nMSets2=nMSets2, p.adj=p.adj, MeDIP=MeDIP, minRowSum=minRowSum)
				}
				else{
					stop("Invalid specification for parameter diffnorm because parameter MeDIP is FALSE (no rms values have been calculated).")
				}
			}
			else{
				stop("Unknown specification for parameter diffnorm.")
			}
		}
		else{stop("Selected method for calculating differential coverage not supported")}
		
		cat("Please note, log2 ratios are reported as log2(MSet1/MSet2).\n")
		diff.results = diff.results.list$diff.results
		diff.index = diff.results.list$diff.index
				
		rm(diff.results.list)
		gc()
	
	}
	else{
		cat("No differential coverage will be calculated- only one group of MEDIPS SETs given.\n")
	}
	
	##If two groups of INPUT SETs are given 
	##calculate CNV on mean per set
	##################################
	if(CNV){
		if(!is.null(ISet1) & !is.null(ISet2)){
			cat(paste("CNV analysis...\n", sep=" "))		
			cnv.combined = MEDIPS.cnv(base=base, rpkm.input=rpkm.input, nISets1=nISets1, nISets2=nISets2)
		}
		else{
			cat("Cannot perform CNV analysis- please specify two groups of INPUT SETs!\n")
		}
	}
	
	##Create results table	
	##################################
	cat(paste("Creating results table...\n", sep=" "))
	if(!is.null(counts.medip)){
		if(MeDIP){
			results = data.frame(base, counts.medip, rpkm.medip, rms, stringsAsFactors=F)
		}
		else{
			results = data.frame(base, counts.medip, rpkm.medip, stringsAsFactors=F)
		}
	}
	if(!is.null(counts.input)){
		if(!is.null(counts.medip))
		{
			results = data.frame(results, counts.input, rpkm.input, stringsAsFactors=F)
		}
		else{
			results = data.frame(base, counts.input, rpkm.input, stringsAsFactors=F)
		}
	}
	
	##Add mean counts, rpkm, rms columns
	set1idx=1:(nMSets1)
	counts.mean.C=numeric(dim(counts.medip)[1])
	rpkm.mean.C=numeric(dim(rpkm.medip)[1])
	for (i in set1idx){
		counts.mean.C=counts.mean.C+counts.medip[,i]
		rpkm.mean.C=rpkm.mean.C+rpkm.medip[,i]
	}
	counts.mean.C=counts.mean.C/nMSets1
	rpkm.mean.C=rpkm.mean.C/nMSets1
	if(MeDIP){
		rms.mean.C =numeric(dim(rms)[1])
		for (i in set1idx){
			rms.mean.C=rms.mean.C+rms[,i]
		}
		rms.mean.C=rms.mean.C/nMSets1
		results = data.frame(results, MSets1.counts.mean=counts.mean.C, MSets1.rpkm.mean=rpkm.mean.C, MSets1.rms.mean=rms.mean.C, stringsAsFactors=F)
		rm(counts.mean.C,rpkm.mean.C,set1idx,rms.mean.C)
	}
	else{
		results = data.frame(results, MSets1.counts.mean=counts.mean.C, MSets1.rpkm.mean=rpkm.mean.C, stringsAsFactors=F)
		rm(counts.mean.C,rpkm.mean.C,set1idx)
	}

	if(nMSets2>0){
		set2idx=(nMSets1+1):(nMSets1+nMSets2)
		counts.mean.T=numeric(dim(counts.medip)[1])
		rpkm.mean.T=numeric(dim(rpkm.medip)[1])
		for (i in set2idx){
			counts.mean.T=counts.mean.T+counts.medip[,i]
			rpkm.mean.T=rpkm.mean.T+rpkm.medip[,i]
		}	
		counts.mean.T=counts.mean.T/nMSets2
		rpkm.mean.T=rpkm.mean.T/nMSets2

		if(MeDIP){
			rms.mean.T =numeric(dim(rms)[1])
			for (i in set2idx){
				rms.mean.T=rms.mean.T+rms[,i]
			}
			rms.mean.T=rms.mean.T/nMSets2
			results = data.frame(results, MSets2.counts.mean=counts.mean.T, MSets2.rpkm.mean=rpkm.mean.T, MSets2.rms.mean=rms.mean.T, stringsAsFactors=F)
			rm(counts.mean.T,rpkm.mean.T,set2idx,rms.mean.T)
		}
		else{
			results = data.frame(results, MSets2.counts.mean=counts.mean.T, MSets2.rpkm.mean=rpkm.mean.T, stringsAsFactors=F)
			rm(counts.mean.T,rpkm.mean.T,set2idx)
		}
	}

	if(nISets1>1){
		setI1idx=1:(nISets1)
		counts.input.mean.C = counts.input[,setI1idx[1]]
		rpkm.input.mean.C = rpkm.input[,setI1idx[1]]
		for (i in setI1idx[-1]){
		  counts.input.mean.C =counts.input.mean.C+counts.input[,i]
		  rpkm.input.mean.C =rpkm.input.mean.C+rpkm.input[,i]
		}
		counts.input.mean.C =counts.input.mean.C/nISets1
		rpkm.input.mean.C =rpkm.input.mean.C/nISets1
		results = data.frame(results, ISets1.counts.mean=counts.input.mean.C, ISets1.rpkm.mean=rpkm.input.mean.C, stringsAsFactors=F)
		rm(counts.input.mean.C,rpkm.input.mean.C,setI1idx)
	}
	if(nISets2>1){
		setI2idx=(nISets1+1):(nISets1+nISets2)
		counts.input.mean.T = counts.input[,setI2idx[1]]
		rpkm.input.mean.T = rpkm.input[,setI2idx[1]]
		for (i in setI2idx[-1]){
		  counts.input.mean.T =counts.input.mean.T+counts.input[,i]
		  rpkm.input.mean.T =rpkm.input.mean.T+rpkm.input[,i]
		}
		counts.input.mean.T =counts.input.mean.T/nISets2
		rpkm.input.mean.T =rpkm.input.mean.T/nISets2

		results = data.frame(results, ISets2.counts.mean=counts.input.mean.T, ISets2.rpkm.mean=rpkm.input.mean.T, stringsAsFactors=F)
		rm(counts.input.mean.T,rpkm.input.mean.T,setI2idx)
	}
	
	if(MeDIP){rm(base, counts.medip, rpkm.medip, rms, counts.input, rpkm.input)}
	else{rm(base, counts.medip, rpkm.medip, counts.input, rpkm.input)}
	gc()
	
	##Add diff.meth results
	if(nMSets1!=0 & nMSets2!=0){
		cat(paste("Adding differential coverage results...\n", sep=" "))
		dummy.results = matrix(ncol=ncol(diff.results), nrow=nrow(results))
		
		if(diff.method=="edgeR"){
			c.names = colnames(diff.results)
			diff.results <- matrix(unlist(diff.results), ncol=ncol(diff.results), byrow=FALSE)
			colnames(diff.results)=c.names
			rm(c.names)
		}
		
		dummy.results[diff.index,] = diff.results
		colnames(dummy.results)=colnames(diff.results)		
		results = data.frame(results, dummy.results, stringsAsFactors=F)
			
		rm(diff.results, dummy.results, diff.index)
		gc()
	}
	
	##Add CNV results
	if(!is.null(ISet1) & !is.null(ISet2)){
		if(CNV){
			cat(paste("Adding CNV results...\n", sep=" "))
			dummy.results = matrix(ncol=1, nrow=(nrow(results)))
			for(i in 1:nrow(cnv.combined)){
				dummy.results[cnv.combined[i,1]:cnv.combined[i,2]] = cnv.combined[i,3]		
			}
		colnames(dummy.results)="CNV.log2.ratio"
		results = data.frame(results, dummy.results, stringsAsFactors=F)
		
		rm(dummy.results)	
		gc()
		}
	}
	
	rownames(results) = seq(1, nrow(results))
    	gc()
	return(results)
		
}

##########################################################################
##Function calculates density of C's, G's, and CpGs in the given sequences as well as in the reference genome
##Returns CpG enrichment values for the given sequences.
##########################################################################
##Input:	bam file or tab (|) separated txt file "chr | start | stop  | strand"
##Param:	BSgenome, pattern (character), chromosomes, shift, extend
##Output:	CpGenrich results object
##Requires:	BSgenome, Biostrings, GenomicRanges, MEDIPS.Bam2GRanges, MEDIPS.txt2Granges, MEDIPS.GenomicCoordinates
##Modified:	05/21/2020
##Author:	Joern Dietrich, Lukas Chavez


MEDIPS.CpGenrich <-function(file=NULL, BSgenome=NULL, extend=0, shift=0, uniq=1e-3, chr.select=NULL, paired=F){

	## Proof correctness....
	if(is.null(BSgenome)){stop("Must specify a BSgenome library.")}
	
	## Read region file		
	fileName=unlist(strsplit(file, "/"))[length(unlist(strsplit(file, "/")))]
	path=paste(unlist(strsplit(file, "/"))[1:(length(unlist(strsplit(file, "/"))))-1], collapse="/") 
	if(path==""){path=getwd()}		
	if(!fileName%in%dir(path)){stop(paste("File", fileName, " not found in", path, sep =" "))}	

	dataset = getBSgenome(BSgenome)	

	if(!paired){GRange.Reads = getGRange(fileName, path, extend, shift, chr.select, dataset, uniq)}
	else{GRange.Reads = getPairedGRange(fileName, path, extend, shift, chr.select, dataset, uniq)}
	
	## Sort chromosomes
	if(length(unique(seqlevels(GRange.Reads)))>1){chromosomes=mixedsort(unique(seqlevels(GRange.Reads)))}
	if(length(unique(seqlevels(GRange.Reads)))==1){chromosomes=unique(seqlevels(GRange.Reads))}
	
	## Get chromosome lengths for all chromosomes within data set.
	cat(paste("Loading chromosome lengths for ",BSgenome, "...\n", sep=""))		

	chr_lengths=as.numeric(seqlengths(dataset)[chromosomes])

	ranges(GRange.Reads) <- restrict(ranges(GRange.Reads),+1)
	
	##Calculate CpG density for regions
	total=length(chromosomes)
	cat("Calculating CpG density for given regions...\n")  
	seq=matrix(unlist(IRanges::lapply(GRangesList(GRange.Reads),function(x){		
		#i=which(mixedsort(chromosomes)%in%names(x) )
		ranges(x)<-restrict(ranges(x),end=chr_lengths[which(chromosomes %in% as.vector(seqnames(x)))])
		y=DNAStringSet(getSeq(dataset, names=as.vector(seqnames(x)), start=start(x), end=end(x), as.character=TRUE))
		c(sum(as.numeric(vcountPattern("CG",y))),sum(as.numeric(vcountPattern("C",y))),sum(as.numeric(vcountPattern("G",y))),sum(as.numeric(width(y))),length(y))
		}
	),use.names=F),ncol=5,nrow=total,byrow=T)
  
	Value=colSums(seq)
	unused=length(GRange.Reads)-Value[5]
	if ( unused!=0 )cat(unused,"unused sequences, limits out of range\n")
	
	regions.CG=Value[1]
	regions.C=Value[2]
	regions.G=Value[3]
	all.genomic=Value[4]
	
	regions.relH=as.numeric(regions.CG)/as.numeric(all.genomic)*100
	regions.GoGe=(as.numeric(regions.CG)*as.numeric(all.genomic))/(as.numeric(regions.C)*as.numeric(regions.G))  
	
	##Calculate CpG density for reference genome
	cat(paste("Calculating CpG density for the reference genome", BSgenome, "...\n", sep = " "))	
	CG <- DNAStringSet("CG")
	pdict0 <- PDict(CG)
	params <- new("BSParams", X = dataset, FUN = countPDict, simplify = TRUE, exclude = c("rand", "chrUn"))
	genome.CG=sum(bsapply(params, pdict = pdict0))			
	params <- new("BSParams", X = dataset, FUN = alphabetFrequency, exclude = c("rand", "chrUn"), simplify=TRUE)
	alphabet=bsapply(params)
	genome.l=sum(as.numeric(alphabet))
 	
	genome.C=as.numeric(sum(alphabet[2,]))
	genome.G=as.numeric(sum(alphabet[3,]))
	genome.relH=genome.CG/genome.l*100
	genome.GoGe=(genome.CG*genome.l)/(genome.C*genome.G);
	
	enrichment.score.relH=regions.relH/genome.relH	
	enrichment.score.GoGe=regions.GoGe/genome.GoGe	
 	
	gc()
	return(list(genome=BSgenome, regions.CG=regions.CG, regions.C=regions.C, regions.G=regions.G, regions.relH=regions.relH, regions.GoGe=regions.GoGe, genome.C=genome.C, genome.G=genome.G, genome.CG=genome.CG, genome.relH=genome.relH, genome.GoGe=genome.GoGe, enrichment.score.relH=enrichment.score.relH, enrichment.score.GoGe=enrichment.score.GoGe))
}

##########################################################################
##Selects putative DMRs from result table returned by MEDIPS.meth()
## w.r.t. to specified parameters
##########################################################################
##Input:	result table returned by MEDIPS.meth (or by MEDIPS.selectROIs)
##Param:	
##Output:	row-wise subset of input
##Modified:	11/28/2011
##Author:	Lukas Chavez

MEDIPS.selectSig = function(results=NULL, p.value=0.01, adj=T, ratio=NULL, bg.counts=NULL, CNV=F){
	
	if(is.null(results)){stop("Must specify a result table.")}		
	cat(paste("Total number of windows: ", nrow(results), "\n", sep=""))		

	##Background counts- preparation
        ################################
        if(!is.null(bg.counts)){
                if(is.numeric(bg.counts)){
                        bg.t = bg.counts
                }
                else{
                     	column.bg = grep(bg.counts, colnames(results))
                        if(length(column.bg)==0){
                                stop("Specified background column not available.")
                        }
                        bg.t = quantile(results[, column.bg], probs=0.95)
                }
        }

	##Filter for windows tested for differential  methylation
	##########################################################	
	results=results[!is.na(results[,grep("p.value", colnames(results))[1]]),]
	cat(paste("Number of windows tested for differential methylation: ", nrow(results), "\n", sep=""))
	
	
	#Filter for p.values
	#######################
	if(adj){value_pvalue = grep("adj.p.value", colnames(results))}
	else{value_pvalue = grep("p.value", colnames(results))[1]} 
		
	results=results[results[,value_pvalue]<=p.value,]
	
	if(adj){cat(paste("Remaining number of windows with adjusted p.value<=", p.value, ": ", nrow(results), "\n", sep=""))}
	else{cat(paste("Remaining number of windows with p.value<=", p.value, ": ", nrow(results), "\n", sep=""))}

	##Ratio and CNV specific filter
	##############################
	##Filter for ratio
	if(!is.null(ratio)& CNV==F){
		
		column_ratio = grep("score.log2.ratio", colnames(results))
		if(length(column_ratio)==0){
			column_ratio = grep("edgeR.logFC", colnames(results))
		}

		results=results[results[,column_ratio]>=log2(ratio) | results[,column_ratio]<=(log2(1/ratio)),]
		cat(paste("Remaining number of windows with ratio >=",ratio," (or <=", round(1/ratio, digits=2), ", respectively): ", nrow(results), "\n", sep=""))		
	}	
	if(!is.null(ratio) & CNV==T){
		
		column_ratio = grep("score.log2.ratio", colnames(results))
                if(length(column_ratio)==0){
                        column_ratio = grep("edgeR.logFC", colnames(results))   
               	}
		
		column_CNVratio = grep("CNV.log2.ratio", colnames(results))
		if(length(column_CNVratio)==0){
			stop("No CNV results available.")
                }
		else if(length(column_CNVratio)>1){
			column_CNVratio = column_CNVratio[1]
		}
		results[is.na(results[,column_CNVratio]),column_CNVratio]=0
		results=results[abs(results[,column_ratio]-results[,column_CNVratio])>=abs(log2(ratio)),]
		cat(paste("Remaining number of windows with CNV corrected ratio >=",ratio," (or <=", round(1/ratio, digits=2), ", respectively): ", nrow(results), "\n", sep=""))
	}
	if(CNV==T & is.null(ratio)){
		stop("Please specify a ratio when setting CNV=T.")
	}

	##Background counts 
        ########################################
        if(!is.null(bg.counts)){
                results=results[results$MSets1.counts.mean>=bg.t | results$MSets2.counts.mean>=bg.t,]
                cat(paste("Remaining number of windows where the mean count of at least one group is >=", round(bg.t, digits=2), ": ", nrow(results),"\n", sep=""))
        }

	gc()
	return(as.data.frame(results,  stringsAsFactors=F))
}

##########################################################################
##Function to export a genome vector as wiggle file for a suitable genome browser (e.g. UCSC).
##########################################################################
##Input:	MEDIPS SET and/or COUPLING SET
##Param:	Set, CSet, (output)file, format, descr
##Output:	Wiggle file
##Modified:	11/01/2015
##Author:	Lukas Chavez

MEDIPS.exportWIG <-
function(Set=NULL, CSet=NULL, file=NULL, format="rpkm", descr=""){
	
	##Proof for correctness
	########################
	if(is.null(file)){stop("Must specify an output file!")}
	if(format != "count" & format!= "rpkm" & format != "pdensity" & format != "rms"){stop("Format pareeter must be either count, rpkm or pdensity!")}
	
	##Set sample names and output data
	###################################
	if(format=="pdensity"){		
		if(class(CSet)!="COUPLINGset"){stop("For exporting pattern densities, you have to specify a COUPLINGset object at CSet!")}
		window_size=window_size(CSet)
		chr_names=chr_names(CSet)
		chr_lengths=chr_lengths(CSet)
		chromosomes=chr_names(CSet)
		output_data = genome_CF(CSet)
		header_out=paste("track type=wiggle_0 name=\"", descr, "\" description=\"", descr, "\" visibility=full autoScale=on color=0,200,100 maxHeightPixels=100:50:20 graphType=bar priority=20", sep="")			
	}
	else if(format=="count"){	
		if(class(Set)!="MEDIPSset"){stop("For exporting count data, you have to specify a MEDIPSset object at Set!")}
		window_size=window_size(Set)
		chr_names=chr_names(Set)
		chr_lengths=chr_lengths(Set)
		chromosomes=chr_names(Set)		
		output_data = genome_count(Set)
		header_out=paste("track type=wiggle_0 name=\"", descr, "\" description=\"", descr, "\" visibility=full autoScale=on color=0,0,255 maxHeightPixels=100:50:20 graphType=bar priority=20", sep="")	
	}
	else if(format=="rpkm"){
		if(class(Set)!="MEDIPSset"){stop("For exporting rpkm data, you have to specify a MEDIPSset object at Set!")}
		window_size=window_size(Set)
		chr_names=chr_names(Set)
		chr_lengths=chr_lengths(Set)
		chromosomes=chr_names(Set)				
		output_data = round((genome_count(Set)*10^9)/(window_size*number_regions(Set)), digits=2)
		header_out=paste("track type=wiggle_0 name=\"", descr, "\" description=\"", descr, "\" visibility=full autoScale=on color=0,0,255 maxHeightPixels=100:50:20 graphType=bar priority=20", sep="")	
	}
	else if(format=="rms"){
		if(class(Set)!="MEDIPSset"){stop("For exporting rms data, you have to specify a MEDIPSset object at Set!")}
                if(class(CSet)!="COUPLINGset"){stop("For exporting rms data, you have to specify a COUPLINGset at CSet!")}
		window_size=window_size(Set)
                chr_names=chr_names(Set)
                chr_lengths=chr_lengths(Set)
                chromosomes=chr_names(Set)
		ccObj = MEDIPS.calibrationCurve(MSet=Set, CSet=CSet, input=F)
		output_data = MEDIPS.rms(Set, CSet, ccObj=ccObj)
                header_out=paste("track type=wiggle_0 name=\"", descr, "\" description=\"", descr, "\" visibility=full autoScale=on color=0,0,255 maxHeightPixels=100:50:20 graphType=bar priority=20", sep="")
	}
	
	##Calculate genomic coordinates
	##################################
	no_chr_windows = ceiling(chr_lengths/window_size)
	supersize_chr = cumsum(no_chr_windows)	
	genome_chr = as.vector(seqnames(MEDIPS.GenomicCoordinates(supersize_chr, no_chr_windows, chromosomes, chr_lengths, window_size)))
		
	write.table(header_out, file=file, sep="", quote=F, row.names=F, col.names=F)
	
	for(i in 1:length(chr_names)){
		cat(paste("Writing data for ", chr_names[i], "...\n", sep=""))
		chr_header=paste("fixedStep chrom=", chr_names[i]," start=1 step=", window_size, " span=",  window_size, sep="")
		write.table(chr_header, file=file, sep="", quote=F, row.names=F, col.names=F, append=T)
		temp_data=output_data[genome_chr==chr_names[i]]
		temp_data=temp_data[-length(temp_data)]
		write.table(temp_data, file=file, sep="", quote=F, row.names=F, col.names=F, append=T)
	}
	
	
}

##########################################################################
##Merges two MEDIPS SETs created based on the same window_size and based on the same reference genome and based on the same chromosomes.
##########################################################################
##Input:	Two MEDIPS SETs
##Param:	MSet1, MSet2, name
##Output:	MEDIPS SET
##Modified:	11/15/2011
##Author:	Lukas Chavez

MEDIPS.mergeSets <- function(MSet1=NULL, MSet2=NULL, name="Merged Set"){
	
	##Proof of correctness
	#######################
	if(class(MSet1)!="MEDIPSset"){stop("You have to state a MEDIPSset object!")}
	if(class(MSet2)!="MEDIPSset"){stop("You have to state a second MEDIPSset object!")}
	
	if(genome_name(MSet1)!=genome_name(MSet2)){stop("MEDIPSset objects MSet1 and MSet2 have different reference genomes!")}
	if(length(chr_names(MSet1))!=length(chr_names(MSet2))){stop("MEDIPSset objects MSet1 and MSet2 have different chromosome sets!")}
	for(i in 1:length(chr_names(MSet1))){
		if(chr_names(MSet1)[i]!=chr_names(MSet2)[i]){stop("MEDIPSset objects MSet1 and MSet2 have different chromosome sets!")}
	}
	if(window_size(MSet1)!=window_size(MSet2)){stop("MEDIPSset objects MSet1 and MSet2 have different window sizes!")}
	
	MEDIPSsetObj = new('MEDIPSset', sample_name=name, genome_name=genome_name(MSet1), number_regions=number_regions(MSet1)+number_regions(MSet2), chr_names=chr_names(MSet1), chr_lengths=chr_lengths(MSet1), genome_count=genome_count(MSet1)+genome_count(MSet2), window_size=window_size(MSet1))
    	
	gc()
	return(MEDIPSsetObj) 	
}

##########
#Function calculates genome wide coordinates based on reference genome and w.r.t specified window size.
#A GRange object for the genome wide windows is returned.
##########
##Input:	Parameters that specify the reference genome and targeted window size.
##Param:	supersize_chr, no_chr_windows_, chromosomes, chr_lengths, window_size
##Output:	GRange object
##Modified:	11/10/2011
##Author:	Lukas Chavez

MEDIPS.GenomicCoordinates <- function(supersize_chr=NULL, no_chr_windows=NULL, chromosomes=NULL, chr_lengths=NULL, window_size=NULL){
	
	cat("Calculating genomic coordinates...")
	
	genomeVec_chr=vector(length=supersize_chr[length(chromosomes)], mode="character")
	genomeVec_pos=vector(length=supersize_chr[length(chromosomes)], mode="numeric")		
	
	total=length(chromosomes)
 	for(i in 1:length(chromosomes)){		
		if(i==1){			
			genomeVec_chr[1:no_chr_windows[i]]=chromosomes[i]
			genomeVec_pos[1:no_chr_windows[i]]=seq(1, chr_lengths[i], window_size)
		}
		if(i>1){
			genomeVec_chr[(supersize_chr[i-1]+1):(supersize_chr[i-1]+no_chr_windows[i])]=chromosomes[i]
			genomeVec_pos[(supersize_chr[i-1]+1):(supersize_chr[i-1]+no_chr_windows[i])]=seq(1, chr_lengths[i], window_size)
		}
        }
	
	cat("\nCreating Granges object for genome wide windows...\n")
	ROIs = GRanges(seqnames=genomeVec_chr, ranges=IRanges(start=genomeVec_pos, end=genomeVec_pos+window_size-1))
	
	gc()
	return(ROIs)
	
}

##########
#Function to plot the results of the saturation analysis.
##########
##Input:	A saturation result object.
##Param:	saturationObj, main (characrter)
##Output:	Plot
##Modified:	11/10/2011
##Author:	Lukas Chavez

MEDIPS.plotSaturation <-
function(saturationObj=NULL, main="Saturation analysis"){
	
	if(is.null(saturationObj)){stop("Must specify a saturation object.")}
	distinctSets=saturationObj$distinct
	estimation=saturationObj$estimation
	maxEstCor=saturationObj$maxEstCor
	maxTruCor=saturationObj$maxTruCor
		
	#Set the colors for the output plot	
	colors=c("red", "blue")
	legend=c("Saturation", "Estimated saturation")
		
	##Plot	
	plot(ylim=c(0,1), estimation[,1], estimation[,2], type="l", col=colors[1], xlab="Number of reads", ylab="Pearson correlation coefficient", main=main, sub=paste("Saturation cor: ", round(maxTruCor[2], digits=2), "; Estimated cor: ", round(maxEstCor[2], digits=2), sep=""))
	lines(distinctSets[,1], distinctSets[,2], col=colors[2])		
	legend("bottomright", maxEstCor[2], legend, fill=c("blue", "red"))
	abline(1, 0)	
}

##########################################################################
##Function that identifies genomic positions of a given sequence pattern within the specified genome.
##########################################################################
##Input:	A BSgenome object, chromosomes and a sequence pattern (e.g. CG) to search for.
##Param:	BSgenome, pattern (character), chromosomes
##Output:	GRange object
##Requires:	BSgenome, Biostrings
##Modified:	11/10/2011
##Author:	Lukas Chavez, Joern Dietrich

MEDIPS.getPositions <-function(BSgenome=NULL, pattern=NULL, chromosomes=NULL){	
	
	if(is.null(pattern)){stop("Must specify a sequence pattern!")}
	
	currentchr=NULL
	currentstart=NULL
	
	genomedata = getBSgenome(BSgenome)
	
	##Determine pattern positions by accessing Biostrings
	for(chromosome in chromosomes){
		cat(paste("Searching in", chromosome, "..."))
	        {subject<-genomedata[[chromosome]]}
		
		plus_matches<-matchPattern(pattern,subject)
		start=start(plus_matches)   
		currentchr=c(currentchr,rep(chromosome,length(start)))
		currentstart=c(currentstart,start) 

		pattern<-DNAString(pattern)
		rcpattern<-reverseComplement(pattern)
		if(pattern!=rcpattern){
			minus_matches<-matchPattern(rcpattern,subject)
			start=start(minus_matches) 
			currentchr=c(currentchr,rep(chromosome,length(start)))
			currentstart=c(currentstart,start) 
		}
		cat(paste("[", length(start), "] found.\n"))			
	}

	cat(paste("Number of identified ", pattern, " pattern: ", length(currentchr), "\n"))
	gc()
	return(GRanges(seqnames=currentchr, ranges=IRanges(start=currentstart, end=currentstart)))
}

##########################################################################
##Function selects subsets of a results table returned by MEDIPS.meth w.r.s
##given ROIs and (optional) summarized methylation values of selected windows
##########################################################################
##Input:	results table from MEDIPS.meth, genomic coordinates of ROIs as list or as GRange object
##		In the latter case the Id must be in the first column of values
##Param:	results, rois, columns, summarize
##Output:	subset of results, or mean methylation values for each ROI and for selected columns 
##Modified:	05/15/2013
##Author:	Lukas Chavez, Matthias Lienhard

MEDIPS.selectROIs=function(results=NULL, rois=NULL, columns=NULL, summarize=NULL){
	
	if (! (is.null(summarize) || summarize=="avg" || summarize=="minP" || summarize=="sum")){
		stop("summarize must be \"avg\", \"minP\", \"sum\" or NULL")
	} 
		
	if(!is.null(columns)){
		column.ids = which(colnames(results) %in% columns)
		}else{
		column.ids = 4:dim(results)[2]
		}

	##Convert results to GRange object
	results.GRange = GRanges(seqnames=results[,1], ranges=IRanges(start=as.numeric(results[,2]), end=as.numeric(results[,3])))		
	elementMetadata(results.GRange) = results[, c(column.ids)]
	colnames(elementMetadata(results.GRange)) = colnames(results)[column.ids]
	
	if(class(rois)!="GRanges"){
		##Convert rois to GRange object
		rois.Grange = GRanges(seqnames=rois[,1], ranges=IRanges(start=as.numeric(rois[,2]), end=as.numeric(rois[,3])), ids=rois[,4])		
	}else{
		rois.Grange=rois
		if(is.null(rois.Grange$ids)) stop("Granges object for ROIs needs to contain \"ids\"")
	}	
	if(is.null(summarize)){
		##Preselect from results only ranges that overlap with rois 
		m=IRanges::as.matrix(findOverlaps(rois.Grange, results.GRange))

		##Convert Grange result object to base and data matrices	
		results.rois.data = results[m[,2],c(1,2,3,column.ids)]
		results.rois.data$ROI=rois.Grange$ids[m[,1]]
		return(results.rois.data)		
	}else if(summarize=="avg"){
		##For each roi, select according result frames and 
		##calculate mean for all specified columns
		###################################################
		m=IRanges::as.matrix(findOverlaps(rois.Grange, results.GRange))
   		mean.rois.data=apply(IRanges::as.data.frame(values(results.GRange)),2,function(x){
       			l=split(x[m[,2]],m[,1])
       			return(unlist(lapply(l,mean)))
   		})		
		##Convert Grange rois result object to base
		g = unique(m[,1])
		base = data.frame(chr=as.character(as.vector(seqnames(rois.Grange[g]))), start=start(rois.Grange[g]), end=end(rois.Grange[g]), stringsAsFactors=F)
		ids = rois.Grange$ids[g]
		if(dim(base)[1]==1){
			avgROI=data.frame(c(base, mean.rois.data))
		}else{avgROI=cbind(base, mean.rois.data)}
		avgROI$ROI=ids		
		return(avgROI)
	}else if(summarize=="sum"){
                ##For each roi, select according result frames and
                ##calculate sum for all specified columns
                ###################################################
                m=IRanges::as.matrix(findOverlaps(rois.Grange, results.GRange))
                mean.rois.data=apply(IRanges::as.data.frame(values(results.GRange)),2,function(x){
                        l=split(x[m[,2]],m[,1])
                        return(unlist(lapply(l,sum)))
                })
                ##Convert Grange rois result object to base
                g = unique(m[,1])
                base = data.frame(chr=as.character(as.vector(seqnames(rois.Grange[g]))), start=start(rois.Grange[g]), end=end(rois.Grange[g]), stringsAsFactors=F)
                ids = rois.Grange$ids[g]
                if(dim(base)[1]==1){
                        avgROI=data.frame(c(base, mean.rois.data))
                }else{avgROI=cbind(base, mean.rois.data)}
                avgROI$ROI=ids
                return(avgROI)
	}else if(summarize =="minP"){
		#find ROIs in data
		m=IRanges::as.matrix(findOverlaps(rois.Grange, results.GRange))
		#find col containing the pvalue
		pval_idx=grep("p.value", names(results)[c(1,2,3,column.ids)])[1]
	        if(is.na(pval_idx)){
			stop("Error: no p.value column selected while summarize is \"minP\"")
        	}
		#group windows by roi
                roi_list=split(results[m[,2],c(1,2,3,column.ids)],m[,1])
		#set the name of the rois
		names(roi_list)=rois.Grange$ids[as.numeric(names(roi_list))]
		#find rois containing windows with pvalue
		nonEmpty=lapply(X=roi_list, FUN=nrow)>0 &
		unlist(lapply(X=roi_list,FUN=function(x){return(any(!is.na(x[,pval_idx])))}))
		#for each ROI: select most significant window 
       		minPvalROI=unsplit(lapply(X=roi_list[nonEmpty], FUN=function(x){return(as.vector(x[which.min(x[,pval_idx]),]))} ),1:sum(nonEmpty))
		#set name of rois in result table
		minPvalROI$ROI=names(roi_list)[nonEmpty]
		return(minPvalROI)
	}
}
    	   	
	

##########################################################################
##Function merges neighbouring genomic coordinates
##########################################################################
##Input:	table containing row-wise genomic coordinates
##Param:	frames, distance
##Output:	merged table of genomic coordinates
##Modified:	11/23/2011
##Author:	Lukas Chavez

MEDIPS.mergeFrames = function(frames=NULL, distance=1){
	
	if(is.null(frames)){stop("Must specify a frame set.")}	
	
	chromosomes=as.character(unique(frames[,1]))
	
	output=NULL
	
	for(i in 1:length(chromosomes)){
		start=as.numeric(frames[,2][as.character(frames[,1])==chromosomes[i]])
		stop=as.numeric(frames[,3][as.character(frames[,1])==chromosomes[i]])
		stop_ext=stop+(distance)
			
		start_ID=vector(length=length(start), mode="numeric") 
		start_ID[]=1					
			
		stop_ID=vector(length=length(stop), mode="numeric") 
		stop_ID[]=-1
			
		positions=vector(length=(length(start)+length(stop)), mode="numeric") 
		positions[]=append(start, stop_ext)
		
		positions_orig=vector(length=(length(start)+length(stop)), mode="numeric")
		positions_orig[]=append(start, stop)
		
		IDs=vector(length=(length(start)+length(stop)), mode="numeric") 
		IDs[]=append(start_ID, stop_ID)
		
		IDs=IDs[order(positions)]
		positions_orig=positions_orig[order(positions)]
		positions=positions[order(positions)]
		
		merged_IDs=cumsum(IDs)		
				
		new_stop=positions_orig[merged_IDs==0]
		indices_stop=which(merged_IDs==0)

		new_start = positions_orig[1]
		new_start = c(new_start, positions_orig[c(indices_stop+1)])
		new_start = new_start[-length(new_start)]

		output=rbind(output, cbind(chromosomes[i], new_start, new_stop))
	}

	output = cbind(output, paste("ID", seq(1, nrow(output)), sep="_"))

	print(paste("Number of merged frames: ", length(output[,1]), sep=""), quote=F)
	output=list(chr=as.character(output[,1]), start=format(as.numeric(output[,2]), scientific=F, trim=T), stop=format(as.numeric(output[,3]), scientific=F, trim=T), ID=as.character(output[,4]))
	return(as.data.frame(output,stringsAsFactors=F))	
}

##########################################################################
##Function to get annotations by using biomaRt
##########################################################################
##Input:	Names of annotation, dataset and mart
##Param:	mart, dataset. annotation
##Output:	List of annotation matrix 
##Requires:	biomaRt
##Modified:	01/19/2016
##Author:	Joern Dietrich, Matthias Lienhard, Lukas Chavez
MEDIPS.getAnnotation<-function(host="www.ensembl.org",dataset=c("hsapiens_gene_ensembl","mmusculus_gene_ensembl")[1],annotation=c("TSS","EXON","GENE")[1],tssSz=c(-1000,500),chr=NULL){

	marts=biomaRt::listMarts(host=host)
	mart="ENSEMBL_MART_ENSEMBL"
	if(mart%in%marts[,1])
		cat("Getting annotation from database",as.character(marts[marts[,1]==mart,2]),"\n" )
	else
		stop(paste("cannot find mart \"",mart,"\" at ",host,sep=""))		
	biomart <- biomaRt::useMart(mart, dataset=dataset, host=host)
	dSets=biomaRt::listDatasets(biomart)
	if(dataset%in%dSets[,1])
		cat("Selecting dataset",as.character(dSets[dSets[,1]==dataset,2]),"\n" )
	else
		stop(paste("cannot find dataset \"",dataset,"\" at ",host,sep=""))		
	
	biomart <- biomaRt::useMart(mart, dataset,host=host)
	Annotation=NULL
	if(! is.null(chr)) {
		f="chromosome_name"
		for(i in 1:length(chr))#remove the chr prefix
			if(substr(chr[i],1,3)=="chr")
				chr[i]=substr(chr[i],4,nchar(chr[i]))
	}else{
		f=""
		chr=""
	} 

	if("GENE"%in%annotation){
		cat("...getting gene annotation\n")
		data <- getBM(attributes=c("ensembl_gene_id","chromosome_name","start_position","end_position"),mart=biomart,filters=f, values=chr)
		data$chromosome_name=paste("chr",data$chromosome_name,sep="")
		names(data)=c("id", "chr", "start", "end")
		Annotation=list("Gene"=data)
	}
	
	if("TSS"%in%annotation){
		cat("...getting TSS annotation\n")
		data <- getBM(attributes=c("ensembl_transcript_id","chromosome_name","transcript_start","transcript_end","strand"),mart=biomart,filters=f, values=chr)
		fs=data$strand == 1 #forward strand
		data[fs ,"transcript_end"  ]=data[fs,"transcript_start"]+tssSz[2]
		data[fs ,"transcript_start"]=data[fs,"transcript_start"]+tssSz[1]
		data[!fs ,"transcript_start"]=data[!fs,"transcript_end"]-tssSz[2]
		data[!fs ,"transcript_end"  ]=data[!fs,"transcript_end"]-tssSz[1]
		data$ensembl_transcript_id=paste("TSS",data$ensembl_transcript_id,sep="_")
		data$chromosome_name=paste("chr",data$chromosome_name,sep="")
		names(data)=c("id", "chr", "start", "end","strand")
		Annotation=c(Annotation,list("TSS"=data[,1:4]))
	}
	
	if("EXON"%in%annotation){
		cat("...getting exon annotation\n")
		data <- getBM(attributes=c("ensembl_exon_id","chromosome_name","exon_chrom_start","exon_chrom_end"),mart=biomart,filters=f, values=chr)
		data$chromosome_name=paste("chr",data$chromosome_name,sep="")
		names(data)=c("id", "chr", "start", "end")
		Annotation=c(Annotation,list("EXON"=data))
	}
	
	
	return(Annotation)
}


##########################################################################
##Function to add annotation to result data regarding their position 
##########################################################################
##Input:	Result matrix or data.frame and list of annotation
##Param:	regions. annotation
##Output:	List of annotation matrix 
##Requires:	IRanges
##Modified:	11/01/2015
##Author:	Joern Dietrich, Matthias Lienhard
MEDIPS.setAnnotation<-function(regions, annotation, cnv=F){

	tmp.regions = GRanges(seqnames=regions[,1], ranges=IRanges(start=as.numeric(regions[,2]), end=as.numeric(regions[,3])))
	ans=NULL
	if(is.data.frame(annotation))annotation=list(annotation=annotation)
	for(n in names(annotation)){ #um an den namen für die message zu kommen
	anno=annotation[[n]]
	anno.data=GRanges(anno[,2], ranges=IRanges(start=anno[,3], end=anno[,4]),ID=anno[,1])
	overlapsM=IRanges::as.matrix(findOverlaps(tmp.regions,anno.data))
	splitL=split(overlapsM[,2],overlapsM[,1])
	maxEle=max(c(0,unlist(lapply(splitL,length)))) #vermeidet die Warnung
	if(maxEle==0){ #mache nichts für diese anntoation und mach mit dem Nächsten weiter
		message("no \"",n,"\"annotation overlap the provided regions")
	}else{
		tmp.ans=matrix(ncol=maxEle,nrow=length(tmp.regions))
		colnames(tmp.ans)=paste(c(1:maxEle),"_",names(anno)[1],sep="")
		j=rep(names(splitL),sapply(splitL,length))
		k=unlist(lapply(splitL,function(x){1:length(x)}))
		tmp.ans[matrix(c(as.integer(j),as.integer(as.vector(k))),ncol=2)]=as.character(values(anno.data)[overlapsM[,2],1])
		ans=cbind(ans,tmp.ans)
		}
	}
	if(cnv){
		ans=data.frame(regions, CNV.log2.ratio=as.numeric(ans), stringsAsFactors=F)
	}else{
		ans=cbind(regions, ans, stringsAsFactors=F)
	}
	return(ans)
}

##########################################################################
##Takes a list of MEDIPS SETs, calculates correlation between all sets and
##reports a correlation matrix.
##########################################################################
##Input:	List of MEDIPS SETs
##Output:	correlation matrix
##Modified:	08/26/2016
##Author:	Lukas Chavez

MEDIPS.correlation <- function(MSets=NULL, plot=T, method="spearman"){
	
	n=length(MSets)

	cor.matrix=matrix(ncol=n, nrow=n)
	c.names=NULL

	if(plot){pdf(paste("Correlation_scatter_plots_" , gsub(" ", "_", date()), ".pdf", sep=""), height=10, width=10)}

	for(i in 1:n){
		c.names=c(c.names, sample_name(MSets[[i]]))
	
		for(j in i:n){
			#print(paste("Comparing sample ", i, " to sample ", j, "...", sep=""))
			##Proof of correctness
			#######################
			if(class(MSets[[i]])!="MEDIPSset" & class(MSets[[i]])!="MEDIPSroiSet"){stop("You have to state a MEDIPSset or MEDIPSroiSet object!")}
	    		if(class(MSets[[j]])!="MEDIPSset" & class(MSets[[j]])!="MEDIPSroiSet"){stop("You have to state a MEDIPSset or MEDIPSroiSet object!")}
			if(genome_name(MSets[[i]])!=genome_name(MSets[[j]])){stop("MEDIPSset objects MSet1 and MSet2 have different reference genomes!")}
			if(length(chr_names(MSets[[i]]))!=length(chr_names(MSets[[j]]))){stop("MEDIPSset objects MSet1 and MSet2 have different chromosome sets!")}
			for(k in 1:length(chr_names(MSets[[i]]))){
				if(chr_names(MSets[[i]])[k]!=chr_names(MSets[[j]])[k]){stop("MEDIPSset objects MSet1 and MSet2 have different chromosome sets!")}
			}
			if(class(MSets[[i]])=="MEDIPSroiSet" & class(MSets[[j]])=="MEDIPSroiSet" & length(MSets[[i]]@genome_count)!=length(MSets[[j]]@genome_count)){stop("MEDIPSroiSet objects MSet1 and MSet2 have different number of regions of interest!")}
			if(class(MSets[[i]])=="MEDIPSset" & class(MSets[[j]])=="MEDIPSset"){
				 if(window_size(MSets[[i]])!=window_size(MSets[[j]])){stop("MEDIPSset objects MSet1 and MSet2 have different window sizes!")}
			}	
			c=cor(MSets[[i]]@genome_count, MSets[[j]]@genome_count, method=method)
			cor.matrix[i,j]=c

			if(plot & i!=j){
				plot(log2(MSets[[i]]@genome_count), log2(MSets[[j]]@genome_count), pch=".", main=paste("Scater_", sample_name(MSets[[i]]), "_vs_", sample_name(MSets[[j]]),  sep=""), sub=paste(method, " correlation: ", round(cor.matrix[i,j], digits=2), sep=""), xlab=paste(sample_name(MSets[[i]]), " log2(counts)", sep=""), ylab=paste(sample_name(MSets[[j]]), " log2(counts)", sep=""))
			}
		}
	}

	if(plot){dev.off()}

	colnames(cor.matrix)=c.names
	rownames(cor.matrix)=c.names

	gc()
	return(cor.matrix)		
}

##########################################################################
##Estimates the reproducibility of genome wide short read coverages 
##by sampling subsets of the given data and comparing accordance.
##########################################################################
##Input:	bam file or tab (|) separated txt file "chr | start | stop  | strand"
##Param:	file, BSSgenome, nit, nrit, empty_bins, rank, extend, shift, window_size, uniq (T|F), chr.select
##Output:	Saturation result object
##Requires:	gtools, BSgenome, MEDIPS.Bam2GRanges, MEDIPS.txt2Granges, MEDIPS.GenomicCoordinates
##Modified:	11/10/2012
##Author:	Lukas Chavez


MEDIPS.saturation<-
function(file=NULL, BSgenome=NULL, nit=10, nrit=1, empty_bins=TRUE, rank=FALSE, extend=0, shift=0,  window_size=500, uniq=1e-3, chr.select=NULL, paired=F, isSecondaryAlignment = FALSE, simpleCigar=TRUE){
	
	## Proof of correctness....
	if(is.null(BSgenome)){stop("Must specify a BSgenome library.")}
	if(is.null(file)){stop("Must specify a bam or txt file.")}
		
	## Read file		
	fileName=unlist(strsplit(file, "/"))[length(unlist(strsplit(file, "/")))]
	path=paste(unlist(strsplit(file, "/"))[1:(length(unlist(strsplit(file, "/"))))-1], collapse="/") 
	if(path==""){path=getwd()}		
	if(!fileName%in%dir(path)){stop(paste("File", fileName, " not found in", path, sep =" "))}
	
	dataset = getBSgenome(BSgenome)
	if(!paired){GRange.Reads = getGRange(fileName, path, extend, shift, chr.select, dataset, uniq, ROI = NULL, isSecondaryAlignment = isSecondaryAlignment, simpleCigar=simpleCigar)}
	else{GRange.Reads = getPairedGRange(fileName, path, extend, shift, chr.select, dataset, uniq, ROI = NULL, isSecondaryAlignment = isSecondaryAlignment, simpleCigar=simpleCigar)}

	## Sort chromosomes
	if(length(unique(seqlevels(GRange.Reads)))>1){chromosomes=mixedsort(unique(seqlevels(GRange.Reads)))}
	if(length(unique(seqlevels(GRange.Reads)))==1){chromosomes=unique(seqlevels(GRange.Reads))}
	
	## Get chromosome lengths for all chromosomes within data set.
	cat(paste("Loading chromosome lengths for ",BSgenome, "...\n", sep=""))		
	#chr_lengths=as.numeric(sapply(chromosomes, function(x){as.numeric(length(dataset[[x]]))}))
	chr_lengths=as.numeric(seqlengths(dataset)[chromosomes])	
	
	## Create the genome vector Granges object	
	no_chr_windows = ceiling(chr_lengths/window_size)
	supersize_chr = cumsum(no_chr_windows)	
	Granges.genomeVec = MEDIPS.GenomicCoordinates(supersize_chr, no_chr_windows, chromosomes, chr_lengths, window_size)	
				
	####################################
	#The first run (a1) is to calculate the saturation based on two distinct subsets of given regions.
	#The second run (a2) is to estimate a saturation based on an artifically doubled set of given regions.
	####################################
	for(a in 1:2){		
		if(a==1){
			distinctSets_size=floor(length(GRange.Reads)/2)
			subset_size=floor(distinctSets_size/nit)
			cat("Saturation analysis...\n")
		}		
		if(a==2){
			cat("Estimated saturation analysis...\n")
			distinctSets_size=length(GRange.Reads)
			GRange.Reads = c(GRange.Reads, GRange.Reads)			
			nit=nit*2
		}			
						
		####################################
		#The loops: First one is  for repeating the random process and results are averaged at the end.
		####################################
		for(r in 1:nrit){			
			cat(paste("Random iteration: ",r,"/", nrit, "...\n", sep=""))
						
			correlation=0
			no_considered_reads=0
	
			##Create a random order for all given regions.
			random=sample(1:length(GRange.Reads), length(GRange.Reads))		
			
			####################################
			#The loops: Second one is  for calculating correlations for subsets of the current total set of given regions.
			####################################
			for(l in 1:nit){						
				cat(paste("Processing subset ", l, "/", nit, "...\n", sep=""))
				
				subset_start_one=(l-1)*subset_size+1			
				subset_start_two=((l-1)*subset_size+1)+distinctSets_size
				
				if(l<nit){	
					subset_stop_one=l*subset_size
					subset_stop_two=(l*subset_size)+distinctSets_size												
					no_considered_reads=c(no_considered_reads, l*subset_size)
				}
				if(l==nit){	
					subset_stop_one=distinctSets_size							
					subset_stop_two=length(GRange.Reads)					
					no_considered_reads=c(no_considered_reads, distinctSets_size)
				}		
				
				##Calculate coverage							
				if(l==1){
					genome_value_a = countOverlaps(Granges.genomeVec, GRange.Reads[c(random[subset_start_one:subset_stop_one])]) 
					genome_value_b = countOverlaps(Granges.genomeVec, GRange.Reads[c(random[subset_start_two:subset_stop_two])]) 
				}
				else{
					genome_value_a = genome_value_a + countOverlaps(Granges.genomeVec, GRange.Reads[c(random[subset_start_one:subset_stop_one])]) 
					genome_value_b = genome_value_b + countOverlaps(Granges.genomeVec, GRange.Reads[c(random[subset_start_two:subset_stop_two])]) 
				}				
								
				##Calculate correlation for each interval							
				if(empty_bins){
					if(!rank){correlation=c(correlation, cor(genome_value_a, genome_value_b))}
					if(rank){correlation=c(correlation, cor(rank(genome_value_a), rank(genome_value_b)))}
					
				}
				if(!empty_bins){
					if(!rank){correlation=c(correlation, cor(genome_value_a[genome_value_a!=0 & genome_value_b!=0], genome_value_b[genome_value_a!=0 & genome_value_b!=0]))}
					if(rank){correlation=c(correlation, cor(rank(genome_value_a[genome_value_a!=0 & genome_value_b!=0]), rank(genome_value_b[genome_value_a!=0 & genome_value_b!=0])))}
				}
			}			
	
			##Store the results of each iteration step.
			if(r==1){
				output_matrix=matrix(ncol=2, nrow=length(correlation))
				output_matrix[,1]=no_considered_reads
				output_matrix[,2]=correlation
			}
			if(r>1){
				output_matrix[,2]=output_matrix[,2]+correlation
			}					
		
		}

		##Correct for the number of Monte-Carlo iterations
		output_matrix[,2]=output_matrix[,2]/nrit
		
		if(a==1){
			distinct=output_matrix
			maxTruCor=c(output_matrix[length(correlation),1], output_matrix[length(correlation),2])
		}
		if(a==2){
			maxEstCor=c(output_matrix[length(correlation),1], output_matrix[length(correlation),2])
			saturationObj=list(distinctSets=distinct, estimation=output_matrix, numberReads=(length(GRange.Reads)/2), maxEstCor=maxEstCor, maxTruCor=maxTruCor)
		}
	}
	gc()				
	return(saturationObj)
}

##########################################################################
##Plots the calibration plot
##########################################################################
##Input:	MEDIPS SET and COUPLING SET
##Param:	MSet, CSet, plot_chr, rpkm, main, xrange, input
##Output:	Calibration Plot
##Modified:	03/18/2013
##Author:	Lukas Chavez, Matthias Lienhard

MEDIPS.plotCalibrationPlot <- function(MSet=NULL, ISet=NULL, CSet=NULL, plot_chr="all", rpkm=T, main="Calibration plot", xrange=T){
	
	##Proof data accordance....
	##########################
	input=F

	if(!(is.null(MSet)) & (class(MSet)!="MEDIPSset" & class(MSet)!="MEDIPSroiSet")) stop("MSet must be a MEDIPSset or MEDIPSroiSet object!")	
	if(!(is.null(ISet)) & (class(ISet)!="MEDIPSset" & class(ISet)!="MEDIPSroiSet")) stop("ISet must be a MEDIPSset or MEDIPSroiSet object!")	
	if(is.null(MSet) & is.null(ISet) ) stop("ISet and/or MSet must be specified")	

	#print("Checking CSet")
	if(class(CSet)!="COUPLINGset") stop("Must specify a COUPLINGset object!")
	
	#print("Checking MSet")
	if(!is.null(MSet) & class(MSet)=="MEDIPSset"){
	  if(window_size(MSet)!=window_size(CSet)) stop("MSet and COUPLINGset have different window sizes!")
	  if(length(chr_names(MSet))!=length(chr_names(CSet))) stop("MSet and COUPLINGset contain a different number of chromosomes!")
	  for(i in 1:length(chr_names(MSet))){
		if(chr_names(MSet)[i]!=chr_names(CSet)[i]){stop("MSset and COUPLINGset contain different chomosomes!")}
	  }
	}
	
	if(!is.null(MSet) & class(MSet)=="MEDIPSroiSet"){
		if( length(genome_count(MSet)) != length(genome_CF(CSet)) ){stop("MSet and COUPLINGset have different number of regions of interest!")}
		if( length(chr_names(MSet)) != length(chr_names(CSet)) ){stop("MSet and COUPLINGset contain a different number of chromosomes!")}
          	for(i in 1:length(chr_names(MSet))){
                	if(chr_names(MSet)[i]!=chr_names(CSet)[i]){stop("MSset and COUPLINGset contain different chomosomes!")}
          	}
	}

	#print("Checking ISet")
	if(!is.null(ISet) & class(ISet)=="MEDIPSset"){
	  if(window_size(ISet)!=window_size(CSet)) stop("ISet and COUPLINGset have different window sizes!")
	  if(length(chr_names(ISet))!=length(chr_names(CSet))) stop("ISet and COUPLINGset contain a different number of chromosomes!")
	  for(i in 1:length(chr_names(ISet))){
		if(chr_names(ISet)[i]!=chr_names(CSet)[i]){stop("ISet and COUPLINGset contain different chomosomes!")}
	  }
	}

	if(!is.null(ISet) & class(ISet)=="MEDIPSroiSet"){
		if( length(genome_count(ISet)) != length(genome_CF(CSet)) ){stop("MSet and COUPLINGset have different number of regions of interest!")}
                if( length(chr_names(ISet)) != length(chr_names(CSet)) ){stop("MSet and COUPLINGset contain a different number of chromosomes!")}
                for(i in 1:length(chr_names(ISet))){
                        if(chr_names(ISet)[i]!=chr_names(CSet)[i]){stop("MSset and COUPLINGset contain different chomosomes!")}
               	}
	}

	if(!is.null(MSet)){
		signal=genome_count(MSet)
		chr_lengths = chr_lengths(MSet)
		if(class(MSet)=="MEDIPSset"){window_size = window_size(MSet)}
		if(class(MSet)=="MEDIPSroiSet"){window_size = width(rois(MSet))}
		number_regions = number_regions(MSet)
		chromosomes=chr_names(MSet)
	}else{
		signal=genome_count(ISet)
		chr_lengths = chr_lengths(ISet)
		if(class(ISet)=="MEDIPSset"){window_size = window_size(ISet)}
                if(class(ISet)=="MEDIPSroiSet"){window_size = width(rois(ISet))}
		number_regions = number_regions(ISet)
		chromosomes=chr_names(ISet)
	}
	coupling=genome_CF(CSet)
	seq_pattern=seq_pattern(CSet)
		
	##Calculate calibration curve
	#####################################
	if (!is.null(MSet))
	 	ccObj_MSet = MEDIPS.calibrationCurve(MSet=MSet, CSet=CSet, input=F)
	if (!is.null(ISet))
		ccObj_ISet = MEDIPS.calibrationCurve(MSet=ISet, CSet=CSet, input=T)

		
	##Check, if a subset of chromosomes has been selected
	######################################################
	if(plot_chr!="all" & (class(MSet)=="MEDIPSset" | class(ISet)=="MEDIPSset")){
		cat(paste("Extracting data for",plot_chr, "...\n", sep=" "))
		
		##Calculate genomic coordinates
		##################################
		no_chr_windows = ceiling(chr_lengths/window_size)
		supersize_chr = cumsum(no_chr_windows)	
		genome_chr = as.vector(seqnames(MEDIPS.GenomicCoordinates(supersize_chr, no_chr_windows, chromosomes, chr_lengths, window_size)))
				
		if(length(genome_chr[genome_chr==plot_chr])==0){stop("Stated calibration chromosome does not exist within the MEDIPS SET.")}
		signal = signal[genome_chr==plot_chr]
		coupling = coupling[genome_chr==plot_chr]
		cat(paste("Plotting calibration plot for", plot_chr, "...\n", sep=" "))
	}

	if(plot_chr!="all" & (class(MSet)=="MEDIPSroiSet" | class(ISet)=="MEDIPSroiSet")){stop("Selecting chromosomes nor supported for regions of interest.")}

	if(plot_chr=="all"){cat("Plotting calibration plot for all chromosomes. It is recommended to redirect the output to a graphic device.\n")}

	if (!rpkm) {
        	descSignal = "#reads/window"
	}else{
		descSignal = "rpkm"
		if(!is.null(MSet)){
		  if(class(MSet)=="MEDIPSroiSet"){stop("Transformation to rpkm not supported for regions of interest.")}
		  f=10^9/(window_size * number_regions(MSet))
		  signal=signal*f
		  ccObj_MSet$slope=ccObj_MSet$slope*f
		  ccObj_MSet$intercept=ccObj_MSet$intercept*f
		  ccObj_MSet$mean_signal=ccObj_MSet$mean_signal*f
		}
		if(!is.null(ISet)){
		  if(class(ISet)=="MEDIPSroiSet"){stop("Transformation to rpkm not supported for regions of interest.")}
		  signal=signal*10^9/(window_size * number_regions(ISet))
         	  fI=10^9/(window_size * number_regions(ISet))
		  ccObj_ISet$mean_signal=ccObj_ISet$mean_signal/fI
		}
	}

	##Preparations for raw data plots
	#################################
	if(xrange){
	  if(!is.null(MSet))
	    range=c(0,max(ccObj_MSet$mean_signal)*5)
	  else
	    range=c(0,max(ccObj_ISet$mean_signal)*5)
	}else
	  range=c(0,max(signal))
	  
	##Plot
	#######
	plot(coupling,signal, pch=".", main=main, ylab=descSignal,ylim=range, xlab=paste(seq_pattern, " coupling factor", sep=""), col="lightblue")		
	for(i in 0:max(coupling)){
	  t=table(signal[coupling==i])
	  points(x=rep(i,length(t)), y=as.numeric(names(t)),lwd=log(t, 10), pch=4, col="lightblue")
	}
	if(!is.null(MSet))
	  llab="MeDIP reads in genomic window"
	else
	  llab="Input reads in genomic window"
	lcol="lightblue"
	if(! is.null(MSet)){
		lines(ccObj_MSet$coupling_level, ccObj_MSet$mean_signal, col="red")
		abline(a=ccObj_MSet$intercept, b=ccObj_MSet$slope, col="green")
		llab=c(llab,"MeDIP read density for coupling level","Estimated linear fit for MeDIP set")
		lcol=c(lcol,"red", "green")
	}
	if(! is.null(ISet)){
		lines(ccObj_ISet$coupling_level, ccObj_ISet$mean_signal, col="blue")
		llab=c(llab,"Input read density for coupling level" )
		lcol=c(lcol,"blue")
	}

	legend("topright", legend=llab, fill=lcol)
	
}

##########################################################################
##Creates MEDIPS SET of type S4 from input data (i.e. aligned short reads)
##########################################################################
##Input:	bam file or tab (|) separated BED txt file
##Param:	[path]+file name, [path]+file roi name, extend, shift, window_size, BSgenome, uniq, chr.select
##Output:	MEDIPS SET
##Requires:	gtools, BSgenome
##Modified:	11/01/2015
##Author:	Lukas Chavez

MEDIPS.createROIset <- function(file=NULL, ROI=NULL, extend=0, shift=0, bn=1, BSgenome=NULL, uniq=1e-3, chr.select=NULL, paired=F, sample_name=NULL, isSecondaryAlignment = FALSE, simpleCigar=TRUE){
			
	## Proof of correctness....
	if(is.null(BSgenome)){stop("Must specify a BSgenome library.")}
	if(is.null(file)){stop("Must specify a bam or txt file.")}
		
	## Read region file		
	fileName=unlist(strsplit(file, "/"))[length(unlist(strsplit(file, "/")))]
	path=paste(unlist(strsplit(file, "/"))[1:(length(unlist(strsplit(file, "/"))))-1], collapse="/") 
	if(path==""){path=getwd()}
		
	if(!fileName%in%dir(path)){stop(paste("File", fileName, " not found in", path, sep =" "))}

	dataset = getBSgenome(BSgenome)

	#Check chromosomes in ROI file and in chr.select
	if(is.null(ROI)){
		stop("Regions of interest (ROI) required.")		
	}
	
	chromosomes=as.character(unique(ROI[,1]))
	
	#Test, if the roi file contains chromosomes also in the BSgenome reference
	if(sum(!chromosomes%in%seqnames(dataset))!=0){
               	cat("The chromosome(s)", chromosomes[!chromosomes%in%seqnames(dataset)], "are not available in the BSgenome reference. Chromosomes available in the BSgenome reference:", seqnames(dataset), "\n")
                       stop("Please check the ROI object.")
	} 
	
	#Test, if chr.select contains chromosomes only in ROI
	if(!is.null(chr.select) & sum(!chr.select%in%chromosomes)!=0){
		cat("The chromosome(s)", chr.select[!chr.select%in%chromosomes], "are not available in the ROI object. Chromosomes available in the ROI object:", chromosomes, "\n")
		stop("Please check chromosome selection.")
	}
	
	#Shorten ROI by chr.select, if required
	if(!is.null(chr.select) & sum(!chr.select%in%chromosomes)==0){
		ROI=ROI[ROI[,1] %in% chr.select,]
		chromosomes=as.character(unique(ROI[,1]))
	}
	
	## Sort chromosomes
        if(length(chromosomes)>1){chromosomes=mixedsort(chromosomes)}
	
	if(!paired){GRange.Reads = getGRange(fileName, path, extend, shift, chromosomes, dataset, uniq, ROI=ROI, isSecondaryAlignment = isSecondaryAlignment, simpleCigar=simpleCigar)}
	else{GRange.Reads = getPairedGRange(fileName, path, extend, shift, chromosomes, dataset, uniq, ROI=ROI, isSecondaryAlignment = isSecondaryAlignment, simpleCigar=simpleCigar)}
				
	## Get chromosome lengths for all chromosomes within data set.
	cat(paste("Loading chromosome lengths for ",BSgenome, "...\n", sep=""))		
	dataset = getBSgenome(BSgenome)
	chr_lengths=as.numeric(seqlengths(dataset)[chromosomes])	

	## Create the ROI Granges object	
	ROI = data.frame(chr=as.character(ROI[,1]), start=ROI[,2], end=ROI[,3], ID=as.character(ROI[,4]))
        Granges.genomeVec  = bin.ROIs(ROI=ROI, binNo=bn)
		
	##Distribute reads over roi's
	cat("Calculating short read coverage at regions of interest...\n")
	overlap = countOverlaps(Granges.genomeVec, GRange.Reads)

	##Set sample name
	if(is.null(sample_name)){
		sample_name = fileName
	}
			
	## creating MEDIPSset object
    	MEDIPSroiSetObj = new('MEDIPSroiSet', sample_name=sample_name,
				                        path_name=path,
				                        genome_name=BSgenome, 
							number_regions=length(GRange.Reads), 
							chr_names=chromosomes, 
							chr_lengths=chr_lengths, 
							genome_count=overlap, 
							extend=extend,
							shifted=shift, 
							bin_number=bn,
							uniq=uniq,
							ROI=Granges.genomeVec)
    	gc()
	return(MEDIPSroiSetObj) 	
}


#####################################
##Create intervals of given regions
#####################################
##Input: matrix containing genomic regions
##Param: number of bins
##Output: GRanges object where for each range a 'number of bins' number of regions was created
##Modified: 14/10/2011
##Author: Lukas Chavez
bin.ROIs = function(ROI=NULL, binNo=NULL){
	
	chr=as.character(ROI[,1])
	start=as.numeric(ROI[,2])
	stop=as.numeric(ROI[,3])
	name=as.character(ROI[,4])	
	
	result.ext = matrix(ncol=4, nrow=length(chr)*binNo)

	if(binNo>1){
		for(i in 1:length(chr)){
		
			interval.positions = floor(seq(start[i], stop[i], length.out=binNo+1))
			start.ext=interval.positions[c(1:length(interval.positions)-1)]
			start.ext[2:length(start.ext)]=start.ext[2:length(start.ext)]+1
			stop.ext=interval.positions[c(2:length(interval.positions))]
	
			result.ext[c(((i-1)*binNo+1):(i*binNo)),1] = chr[i]	
			result.ext[c(((i-1)*binNo+1):(i*binNo)),2] = start.ext
			result.ext[c(((i-1)*binNo+1):(i*binNo)),3] = stop.ext	
			result.ext[c(((i-1)*binNo+1):(i*binNo)),4] = paste(name[i], seq(1,binNo), sep="_")	
		}
	} else{
		result.ext[,1] = chr
		result.ext[,2] = start
		result.ext[,3] = stop
		result.ext[,4] = name		
	}
	
	binROIs = GRanges(seqnames=result.ext[,1], ranges=IRanges(start=as.numeric(result.ext[,2]), end=as.numeric(result.ext[,3]), names=result.ext[,4]))
	
	return(binROIs)

}

#### MEDIPS class definition ###
setClass(Class = 'MEDIPSset', 
	representation = representation(
					sample_name='character',
					path_name='character',
					genome_name='character', 
					number_regions='numeric', 
					chr_names='character',					
					chr_lengths='numeric', 
					genome_count='numeric',					
					window_size='numeric', 
					extend='numeric',
					shifted='numeric',
					uniq='numeric'				
					),
	prototype = prototype(),
	validity = function(object){
		if(FALSE){stop("")}
		return(TRUE)
	}
)

### show ###
setMethod('show', signature='MEDIPSset', definition=function(object) {
	cat("S4 Object of class MEDIPSset")
	cat("\n=======================================\n")
	cat(paste("Regions file: ", sample_name(object), "\n"))
	cat(paste("File path: ", path_name(object), "\n"))
	cat(paste("Genome: ", genome_name(object), '\n'))
	cat(paste("Number of regions: ", number_regions(object), '\n'))
	cat("Chromosomes: ")
	cat(chr_names(object))
	cat("\nChromosome lengths: ")
	cat(chr_lengths(object))	
	cat(paste("\nGenome wide window size: ", window_size(object), '\n'))
	cat(paste("Reads extended to: ", extend(object), '\n'))
	cat(paste("Reads shifted by: ", shifted(object), '\n'))
	cat(paste("Parameter uniq: ", uniq(object), '\n'))	
	}
)

#### MEDIPSroi class definition ###
setClass(Class = 'MEDIPSroiSet', 
	representation = representation(
					sample_name='character',
					path_name='character',
					genome_name='character', 
					number_regions='numeric', 
					chr_names='character',					
					chr_lengths='numeric', 
					genome_count='numeric',					
					bin_number='numeric', 
					extend='numeric',
					shifted='numeric',
					uniq='numeric',
					ROI='GRanges'	
					),
	prototype = prototype(),
	validity = function(object){
		if(FALSE){stop("")}
		return(TRUE)
	}
)

### show ###
setMethod('show', signature='MEDIPSroiSet', definition=function(object) {
	cat("S4 Object of class MEDIPSset")
	cat("\n=======================================\n")
	cat(paste("Regions file: ", sample_name(object), "\n"))
	cat(paste("File path: ", path_name(object), "\n"))
	cat(paste("Genome: ", genome_name(object), '\n'))
	cat(paste("Number of regions: ", number_regions(object), '\n'))
	cat("Chromosomes: ")
	cat(chr_names(object))
	cat("\nChromosome lengths: ")
	cat(chr_lengths(object))	
	cat(paste("\nNumber of bins per ROI: ", bin_number(object), '\n'))
	cat(paste("Reads extended to: ", extend(object), '\n'))
	cat(paste("Reads shifted by: ", shifted(object), '\n'))
	cat(paste("Parameter uniq: ", uniq(object), '\n'))
	cat("ROIs: \n")
	print(rois(object))
	}
)

#### COUPLING class definition ###
setClass(Class = 'COUPLINGset', 
	representation = representation(
					seq_pattern='character',
					genome_name='character', 
					genome_CF='numeric',
					number_pattern='numeric',
					window_size='numeric', 
					chr_names='character',
					chr_lengths='numeric'
					),
	prototype = prototype(),
	validity = function(object){
		if(FALSE){stop("")}
		return(TRUE)
	}
)

### show ###
setMethod('show', signature='COUPLINGset', definition=function(object) {
	cat("S4 Object of class COUPLINGset")
	cat("\n=======================================\n")
	cat(paste("Sequence pattern: ", seq_pattern(object), "\n"))
	cat(paste("Genome: ", genome_name(object), "\n"))
	cat("Chromosomes: ")
	cat(chr_names(object))
	cat("\nChromosome lengths: ")
	cat(chr_lengths(object))	
	cat(paste("\nNumber of sequence pattern in genome: ", number_pattern(object), '\n'))
	cat(paste("Window size: ", window_size(object), '\n'))	
	}
)

#### Methods for extracting slots ###
# Genome
setGeneric('genome_name', function(object) standardGeneric('genome_name'))
setMethod('genome_name', 'MEDIPSset', function(object) object@genome_name)
setMethod('genome_name', 'MEDIPSroiSet', function(object) object@genome_name)
setMethod('genome_name', 'COUPLINGset', function(object) object@genome_name)

# window size
setGeneric('window_size', function(object) standardGeneric('window_size'))
setMethod('window_size','MEDIPSset', function(object) object@window_size)
setMethod('window_size','COUPLINGset', function(object) object@window_size)

# bin number
setGeneric('bin_number', function(object) standardGeneric('bin_number'))
setMethod('bin_number','MEDIPSroiSet', function(object) object@bin_number)

# chr names
setGeneric('chr_names', function(object) standardGeneric('chr_names'))
setMethod('chr_names','COUPLINGset', function(object) object@chr_names)
setMethod('chr_names','MEDIPSset', function(object) object@chr_names)
setMethod('chr_names','MEDIPSroiSet', function(object) object@chr_names)

# chr lengths
setGeneric('chr_lengths', function(object) standardGeneric('chr_lengths'))
setMethod('chr_lengths','MEDIPSset', function(object) object@chr_lengths)
setMethod('chr_lengths','MEDIPSroiSet', function(object) object@chr_lengths)
setMethod('chr_lengths','COUPLINGset', function(object) object@chr_lengths)

# pattern
setGeneric('seq_pattern', function(object) standardGeneric('seq_pattern'))
setMethod('seq_pattern','COUPLINGset', function(object) object@seq_pattern)

# coupling factor per window
setGeneric('genome_CF', function(object) standardGeneric('genome_CF'))
setMethod('genome_CF','COUPLINGset', function(object) object@genome_CF)

# Coupling factors
setGeneric('genome_CF', function(object) standardGeneric('genome_CF'))
setMethod('genome_CF','COUPLINGset', function(object) object@genome_CF)

# number pattern 
setGeneric('number_pattern', function(object) standardGeneric('number_pattern'))
setMethod('number_pattern','COUPLINGset', function(object) object@number_pattern)

# sample name
setGeneric('sample_name', function(object) standardGeneric('sample_name'))
setMethod('sample_name','MEDIPSset', function(object) object@sample_name)
setMethod('sample_name','MEDIPSroiSet', function(object) object@sample_name)

# path name
setGeneric('path_name', function(object) standardGeneric('path_name'))
setMethod('path_name','MEDIPSset', function(object) object@path_name)
setMethod('path_name','MEDIPSroiSet', function(object) object@path_name)

# number of regions
setGeneric('number_regions', function(object) standardGeneric('number_regions'))
setMethod('number_regions','MEDIPSset', function(object) object@number_regions)
setMethod('number_regions','MEDIPSroiSet', function(object) object@number_regions)

# genome count data per window
setGeneric('genome_count', function(object) standardGeneric('genome_count'))
setMethod('genome_count','MEDIPSset', function(object) object@genome_count)
setMethod('genome_count','MEDIPSroiSet', function(object) object@genome_count)

# extend
setGeneric('extend', function(object) standardGeneric('extend'))
setMethod('extend','MEDIPSset', function(object) object@extend)
setMethod('extend','MEDIPSroiSet', function(object) object@extend)

# shifted
setGeneric('shifted', function(object) standardGeneric('shifted'))
setMethod('shifted','MEDIPSset', function(object) object@shifted)
setMethod('shifted','MEDIPSroiSet', function(object) object@shifted)

# uniq
setGeneric('uniq', function(object) standardGeneric('uniq'))
setMethod('uniq','MEDIPSset', function(object) object@uniq)
setMethod('uniq','MEDIPSroiSet', function(object) object@uniq)

# rois
setGeneric('rois', function(object) standardGeneric('rois'))
setMethod('rois','MEDIPSroiSet', function(object) object@ROI)

##########################################################################
##Function processes a MEDIPSset and weights the counts by the estimated coupling factor dependent signal of the calibration curve.
##Normalized counts are transformed into a rpkm scale.
##########################################################################
##Input:	MEDIPS SET, CS
##Output:	rms vector
##Modified:	1/9/2015
##Author:	Lukas Chavez

MEDIPS.rms <- function(MSet=NULL, CSet=NULL, ccObj=NULL){
	
	signal = genome_count(MSet)
	coupling = genome_CF(CSet)
		
	if(is.null(ccObj)){
		##Calculate calibration curve
		#####################################
		ccObj = MEDIPS.calibrationCurve(MSet=MSet, CSet=CSet, input=F)
	}

	##Weight signals by linear regression obtained parameters
	####################
	cat("Calculating relative methylation score...\n")
	
        estim=numeric(length(ccObj$mean_signal))

	##For the low range of the calibration curve (< max_index) divide counts by observed mean count
	low_range=1:ccObj$max_index
        estim[low_range]=ccObj$mean_signal[low_range]

	##For the higher range of the calibration curve (>=max_index) divide counts by estimated count
	high_range=(ccObj$max_index+1):length(estim)

	estim[high_range]=ccObj$intercept + (ccObj$slope * ccObj$coupling_level[high_range]) 

	#rms normalization:
	signal=signal/estim[coupling+1]
	signal[coupling==0]=0

	##Transform weighted signals into reads per thousand million
	if(class(MSet)=="MEDIPSset"){
		signal = (signal*10^9)/(window_size(MSet)*number_regions(MSet))
	}
	else{
		signal = (signal*10^9)/(as.numeric(width(rois(MSet)))*number_regions(MSet))
	}

	#Transform the resulting data range into the consistent interval [0:1] by trimming the upper 0.1 quantile of the data
	#######################
	signal = log2(signal)

	signal[is.na(signal)] = 0
				
	##Shift signals into positive value range
	####################
	minsignal=min(signal[signal!=-Inf])
	signal[signal!=-Inf]=signal[signal!=-Inf]+abs(minsignal)
	
	##Transform values into the interval [0:1] by compressing the top 20% of the signals
	####################
	maxsignal = max(signal[signal!=Inf])*0.8
	signal[signal!=Inf & signal>maxsignal]=maxsignal
	signal=round((signal/maxsignal), digits=2)

	##Eliminate -Inf & Inf --> 0
	#######################
	signal[signal==-Inf | signal ==Inf]=0

	return(signal)
}

#######################################
##Read bed file
#######################################
##Input:	tab (|) separated bed file "chr | start | stop | name | score | strand | ..."
##Param:	allignment.file, path, extend, shift, uniq, dataset
##Output:	Granges object
##Requires:	GenomicRanges
##Modified:	06/24/2016
##Author:	Lukas Chavez, Joern Dietrich, Isaac Lopez Moyado 

getGRange <-
function (fileName, path = NULL, extend, shift, chr.select = NULL, 
    dataset = NULL, uniq = 1e-3, ROI = NULL, isSecondaryAlignment = FALSE, simpleCigar=TRUE) 
{
    ext = substr(fileName, nchar(fileName) - 3, nchar(fileName))
    bam = (ext == ".bam" | ext == ".BAM")
    bamindex = bam & file.exists(paste(path, "/", fileName, ".bai", 
        sep = ""))
    if (bam) {
        scanFlag = scanBamFlag(isUnmappedQuery = FALSE, isSecondaryAlignment = isSecondaryAlignment)
        if (bamindex & (!is.null(chr.select) | !is.null(ROI))) {
            if (!is.null(ROI)) {
                cat("Reading bam alignment", fileName, "\n considering ROIs using bam index\n")
                if (!is.null(extend)) {
                  ROI[, 2] = ROI[, 2] - extend
                  ROI[, 3] = ROI[, 3] + extend
                }
                if (!is.null(shift)) {
                  ROI[, 2] = ROI[, 2] - shift
                  ROI[, 3] = ROI[, 3] - shift
                }
                sel = GRanges(chr.select, IRanges(1, 536870912))
            }
            else {
                cat("Reading bam alignment", fileName, "\n considering ", 
                  chr.select, " using bam index\n")
                sel = GRanges(chr.select, IRanges(1, 536870912))
            }
            scanParam = ScanBamParam(flag = scanFlag, simpleCigar= simpleCigar, what = c("rname", 
                "pos", "strand", "qwidth", "isize", "mpos"), which = sel)
        }
        else {
            cat("Reading bam alignment", fileName, "\n")
            scanParam = ScanBamParam(flag = scanFlag, simpleCigar= simpleCigar, what = c("rname", 
                "pos", "strand", "qwidth", "isize", "mpos"))
        }
        regions = scanBam(file = paste(path, fileName, sep = "/"), 
            param = scanParam)
        regions = do.call(rbind, lapply(regions, as.data.frame, 
            stringsAsFactors = F))
        regions = data.frame(chr = as.character(as.vector(regions$rname)), 
            start = as.numeric(as.vector(regions$pos)), stop = as.numeric(as.vector(regions$pos) + 
                as.vector(regions$qwidth) - 1), strand = as.character(as.vector(regions$strand)), 
            stringsAsFactors = F)
    }
    else {
        cat("Reading bed alignment", fileName, "\n")
        regions = read.table(paste(path, fileName, sep = "/"), 
            sep = "\t", header = FALSE, row.names = NULL, comment.char = "", 
            colClasses = c("character", "numeric", "numeric", 
                "NULL", "NULL", "character"))
        names(regions) = c("chr", "start", "stop", "strand")
    }
    if (!is.null(chr.select) & !bamindex) {
        cat("Selecting ", chr.select, "\n")
        regions = regions[regions[, 1] %in% as.vector(chr.select), 
            ]
    }
    cat("Total number of imported short reads: ", nrow(regions), 
        "\n", sep = "")
    regions = adjustReads(regions, extend, shift)
    cat("Creating GRange Object...\n")
    regions_GRange = GRanges(seqnames = regions$chr, ranges = IRanges(start = regions$start, 
        end = regions$stop), strand = regions$strand)
   
    if(is.logical(uniq)){stop("Parameter 'uniq' is not logical anymore, please specify a p-value and see the MEDIPS vignette.")}
    if (uniq == 1) {
		cat("Keep at most one 1 read mapping to the same genomic location.\n", sep = "")
		regions_GRange = unique(regions_GRange)
		cat("Number of remaining reads: ", length(regions_GRange), 
			"\n", sep = "")
	} else if (uniq < 1 & uniq > 0) {
		max_dup_number = qpois(1 - as.numeric(uniq), length(regions_GRange) / 
			sum(as.numeric(seqlengths(dataset)[chr.select])))
		max_dup_number = max(1, max_dup_number)
		cat("Keep at most ", max_dup_number, 
			" read(s) mapping to the same genomic location\n", sep = "")
		uniq_regions = unique(regions_GRange)
		dup_number = countMatches(uniq_regions, regions_GRange)
		dup_number[dup_number > max_dup_number] = max_dup_number
		regions_GRange = rep(uniq_regions, times = dup_number)
		cat("Number of remaining reads: ", length(regions_GRange), 
			"\n", sep = "")
	} else if (uniq == 0) {
		cat("Do not correct for potential PCR artefacts (keep all reads).\n", sep = "")
	} else {
		stop("Must specify a valid value for parameter uniq. Please check MEDIPS vignette.")
	}
	strand(regions_GRange) = "*"
	return(regions_GRange)
}

getPairedGRange <-
function (fileName, path = NULL, extend, shift, chr.select = NULL, 
    dataset = NULL, uniq = 1e-3, ROI = NULL, isSecondaryAlignment = FALSE, simpleCigar=TRUE) 
{
    ext = substr(fileName, nchar(fileName) - 3, nchar(fileName))
    bam = (ext == ".bam" | ext == ".BAM")
    bamindex = bam & file.exists(paste(path, "/", fileName, ".bai", 
        sep = ""))
    if (bam) {
        scanFlag = scanBamFlag(isPaired = T, isProperPair = TRUE, 
            hasUnmappedMate = FALSE, isUnmappedQuery = F, isFirstMateRead = T, 
            isSecondMateRead = F, isSecondaryAlignment = isSecondaryAlignment)
        if (bamindex & (!is.null(chr.select) | !is.null(ROI))) {
            if (!is.null(ROI)) {
                cat("Reading bam alignment", fileName, "\n considering ROIs using bam index\n")
                if (!is.null(extend)) {
                  ROI[, 2] = ROI[, 2] - extend
                  ROI[, 3] = ROI[, 3] + extend
                }
                if (!is.null(shift)) {
                  ROI[, 2] = ROI[, 2] - shift
                  ROI[, 3] = ROI[, 3] - shift
                }
                sel = GRanges(ROI[, 1], IRanges(start = ROI[, 
                  2], end = ROI[, 3]))
            }
            else {
                cat("Reading bam alignment", fileName, "\n considering ", 
                  chr.select, " using bam index\n")
                sel = GRanges(chr.select, IRanges(1, 536870912))
            }
        scanParam = ScanBamParam(flag = scanFlag, simpleCigar= simpleCigar, what = c("rname", 
		    "pos", "strand", "qwidth", "isize", "mpos"), which = sel)    
        }
        else {
            cat("Reading bam alignment", fileName, "\n")
            scanParam = ScanBamParam(flag = scanFlag, simpleCigar = simpleCigar, what = c("rname", 
                  "pos", "strand", "qwidth", "isize", "mpos"))
        }
   
        regions = scanBam(file = paste(path, fileName, sep = "/"), 
            param = scanParam)
        regions = do.call(rbind, lapply(regions, as.data.frame, 
            stringsAsFactors = F))
    }
    else {
        stop("BED files in paired end mode not supported.\n")
    }
    if (!is.null(chr.select) & !bamindex) {
        cat("Selecting", chr.select, "\n")
        regions = regions[regions[, 1] %in% as.vector(chr.select), 
            ]
    }
    cat("Total number of imported first mate reads in properly mapped pairs: ", 
        nrow(regions), "\n", sep = "")
    cat("scanBamFlag: isPaired = T, isProperPair=TRUE , hasUnmappedMate=FALSE, ", 
        "isUnmappedQuery = F, isFirstMateRead = T, isSecondMateRead = F\n", 
        sep = "")
    cat("Mean insertion size: ", mean(abs(regions$isize)), " nt\n", 
        sep = "")
    cat("SD of the insertion size: ", sd(abs(regions$isize)), 
        " nt\n", sep = "")
    cat("Max insertion size: ", max(abs(regions$isize)), " nt\n", 
        sep = "")
    cat("Min insertion size: ", min(abs(regions$isize)), " nt\n", 
        sep = "")
   
   qwidth = regions[, "qwidth"]
   regions = data.frame(chr = as.character(as.vector(regions$rname)), 
   start = as.numeric(as.vector(regions$pos)), stop = as.numeric(as.vector(regions$mpos)), 
   strand = as.character(as.vector(regions$strand)), 
   isize = as.numeric(as.vector(regions$isize)), stringsAsFactors = F)
   
   regionsToRev = regions$start > regions$stop
   regions[regionsToRev, ]$start = regions[regionsToRev,]$stop
   regions[, "stop"] = regions[, "start"] + abs(regions[, "isize"]) - 1    
   
   if(extend!=0){cat("The extend parameter will be neglected, because the actual DNA fragment length is known in paired-end data.\n")}
   if(shift!=0){cat("The shift parameter will be neglected, because the actual DNA fragment position is known in paired-end data.\n")}
    
    cat("Creating GRange Object...\n")
    regions_GRange = GRanges(seqnames = regions$chr, ranges = IRanges(start = regions$start, 
        end = regions$stop), strand = regions$strand)
	
	if(is.logical(uniq)){stop("Parameter 'uniq' is not logical anymore, please specify a p-value and see the MEDIPS vignette.")}
	
	if (uniq == 1) {
		cat("Keep at most 1 read mapping to the same genomic location.\n", sep = "")
		regions_GRange = unique(regions_GRange)
		cat("Number of remaining short reads: ", length(regions_GRange), 
			"\n", sep = "")
	} else if (uniq < 1 & uniq > 0) {
		max_dup_number = qpois(1 - as.numeric(uniq), length(regions_GRange) / 
			sum(as.numeric(seqlengths(dataset)[chr.select])))
		max_dup_number = max(1, max_dup_number)
		cat("Keep at most ", max_dup_number, 
			" first mate read(s) mapping to the same genomic location\n", sep = "")		
		uniq_regions = unique(regions_GRange)
		dup_number = countMatches(uniq_regions, regions_GRange)
		dup_number[dup_number > max_dup_number] = max_dup_number
		regions_GRange = rep(uniq_regions, times = dup_number)
		cat("Number of remaining short reads: ", length(regions_GRange), 
			"\n", sep = "")
	} else if (uniq == 0) {
		cat("Do not correct for potential PCR artefacts (keep all reads).\n", sep = "")
	} else {
		stop("Must specify a valid value for parameter uniq. Please check MEDIPS vignette.")
	}
	strand(regions_GRange) = "*"
	return(regions_GRange)
}

scanBamToGRanges <- function(...) {
	dat <- scanBam(...)[[1]]
	keep <- !is.na(dat$pos)
	GRanges(seqnames=dat$rname[keep],
	ranges=IRanges(start=dat$pos[keep], width=nchar(dat$seq[keep])),
	strand=dat$strand[keep], isize=dat$isize[keep],
	mrnm=dat$mrnm[keep], flag=dat$flag[keep])
}

#######################################
##Read wig file
#######################################
##Input:	wiggle file
##Param:	wiggle.file, path, chromosomes, genome
##Output:	MEDIPSsetObj
##Requires:	rtracklayer
##Modified:	29/10/2012
##Author:	Matthias Lienhard
getMObjectFromWIG <- function(fileName, path, chr.select=NULL,BSgenome){
        cat("Reading wiggle file",fileName,"\n")	
	if(!is.null(chr.select)){
          cat("Select chromosomes",chr.select,"\n")
          sel=GRanges(chr.select,IRanges(1, 536870912))
	  #this function will warn, if type is not bigwig
	  wiggle=rtracklayer::import(paste(path,fileName,sep="/"), which=sel)	
	}else{
	  wiggle=rtracklayer::import(paste(path,fileName,sep="/"))
	  chr.select=names(seqlengths(wiggle))
	}
	
	dataset = getBSgenome(BSgenome)
	chr_lengths=as.numeric(seqlengths(dataset)[chr.select])
	genome_count=values(wiggle)[,1]
	window_size=width(wiggle)[1]
	#check that all chromosomes are completely covered
        wiggle_chrL=runLength(seqnames(wiggle))
	wiggle_chrN=as.character(runValue(seqnames(wiggle)))
	m=match(chr.select,wiggle_chrN)
	if(any(is.na(m))){
	    stop("ERROR: wiggle file must cover all selected chromosomes\nNot covered chr: ",paste(chr.select[is.na(m)],sep=", "),"\n")
	}
	if(any(wiggle_chrL[m] != ceiling(chr_lengths/window_size))){
	    stop("ERROR: wiggle file must completly cover all selected chromosomes\nNot covered chr: ",paste(wiggle_chrL[m] != ceiling(chr_lengths/window_size),sep=", "),"\n")
	}
	
	#check that values are integer
	tol = .Machine$double.eps^0.5
	if(any(abs(genome_count - round(genome_count))>tol)){
	  stop("ERROR: wiggle file must contain counts of genomic windows, but found floting numbers\n")
	}
	return(new('MEDIPSset', sample_name=fileName,
				                        path_name=path,
				                        genome_name=BSgenome, 
							number_regions=sum(genome_count),
							chr_names=chr.select, 
							chr_lengths=chr_lengths,
							genome_count=genome_count, 
							extend=0,
							shifted=0, 
							window_size=window_size,
							uniq=NA))
}


#####################################
##get types function
#####################################
##Input:	file
##Param:	file, sep
##Output:	vector object
##Modified:	12/10/2011
##Author:	Joern Dietrich
getTypes<-function(file,sep="\t"){
	data=read.table(file,nrows=1,sep=sep,comment.char='')
	types=apply(data,2,typeof)
	return(types)
}

#####################################
##set types function
#####################################
##Input:	vector
##Param:	types
##Output:	vector object
##Modified:	12/10/2011
##Author:	Joern Dietrich
setTypes<-function(types){
	types[2:3]="numeric"
	types[4:5]="NULL"
	return(types)
}

#####################################
##adjust GRange function
#####################################
##Input:	dataframe
##Param:	regions, extend, shift
##Output:	dataframe object
##Modified:	12/10/2011
##Author:	Lukas Chavez, Joern Dietrich
adjustReads<-function(regions, extend, shift){
	if(extend!=0){		
		cat("Extending reads...\n")
		extend.c = pmax(0,extend-regions$stop+regions$start)
		regions$stop[regions$strand=="+"]=regions$stop[regions$strand=="+"]+extend.c[regions$strand=="+"]
		regions$start[regions$strand=="-"]=regions$start[regions$strand=="-"]-extend.c[regions$strand=="-"]	
	}
	
	if(shift!=0){
		cat("Shifting reads...\n")
		regions$start[regions$strand=="+"] = regions$start[regions$strand=="+"]+shift
		regions$stop[regions$strand=="+"] = regions$stop[regions$strand=="+"]+shift
		regions$start[regions$strand=="-"] = regions$start[regions$strand=="-"]-shift
		regions$stop[regions$strand=="-"] = regions$stop[regions$strand=="-"]-shift	
	}
	return(regions)
}

##########################################################################
##Function to calculate the number of covered genomic sequence patterns (e.g. CpGs) by given genomic regions.
##########################################################################
##Input:	bam file or tab (|) separated txt file "chr | start | stop  | strand"
##Param:	file, BSSgenome, file, pattern, extend, shift, uniq (T|F), chr.select
##Output:	seqCoverage result object 
##Requires:	gtools, BSgenome, MEDIPS.getPositions, MEDIPS.Bam2GRanges, MEDIPS.txt2Granges
##Modified:	30/11/2015
##Author:	Lukas Chavez

MEDIPS.seqCoverage<-                                  
function(file=NULL, BSgenome=NULL, pattern="CG", extend=0, shift=0, uniq=1e-3, chr.select=NULL, paired=F, isSecondaryAlignment = FALSE, simpleCigar=TRUE){
	
	## Proof of correctness....
	if(is.null(BSgenome)){stop("Must specify a BSgenome library.")}
	if(is.null(file)){stop("Must specify a bam or txt file.")}
		
	## Read file		
	fileName=unlist(strsplit(file, "/"))[length(unlist(strsplit(file, "/")))]
	path=paste(unlist(strsplit(file, "/"))[1:(length(unlist(strsplit(file, "/"))))-1], collapse="/") 
	if(path==""){path=getwd()}		
	if(!fileName%in%dir(path)){stop(paste("File", fileName, " not found in", path, sep =" "))}
	
	dataset = getBSgenome(BSgenome)
	if(!paired){GRange.Reads = getGRange(fileName, path, extend, shift, chr.select, dataset, uniq, ROI = NULL, isSecondaryAlignment = isSecondaryAlignment, simpleCigar=simpleCigar)}
	else{GRange.Reads = getPairedGRange(fileName, path, extend, shift, chr.select, dataset, uniq, ROI = NULL, isSecondaryAlignment = isSecondaryAlignment, simpleCigar=simpleCigar)}
		
	## Sort chromosomeos
	if(length(unique(seqlevels(GRange.Reads)))>1){chromosomes=mixedsort(unique(seqlevels(GRange.Reads)))}
	if(length(unique(seqlevels(GRange.Reads)))==1){chromosomes=unique(seqlevels(GRange.Reads))}
	
	## Get chromosome lengths for all chromosomes within data set.
	cat(paste("Loading chromosome lengths for ",BSgenome, "...\n", sep=""))		
	#chr_lengths=as.numeric(sapply(chromosomes, function(x){as.numeric(length(dataset[[x]]))}))
	chr_lengths=as.numeric(seqlengths(dataset)[chromosomes])	
	
	## Get the genomic positions of the sequence pattern
	cat("Get genomic sequence pattern positions...\n")
	GRanges.pattern = MEDIPS.getPositions(BSgenome, pattern, chromosomes)	
		
	cat("Calculating sequence pattern coverage...\n")
	overlap = countOverlaps(GRanges.pattern, GRange.Reads) 
	overlap_2 = countOverlaps(GRange.Reads, GRanges.pattern)
	overlap_2 = length(overlap_2[overlap_2==0])
	
	
	seqCoverageObject=list(cov.res=overlap, pattern=pattern, numberReads=length(GRange.Reads), numberReadsWO=overlap_2)
	gc()
	return(seqCoverageObject)
}

##########
#Function
##########
##Input:	Parameters that specify the reference genome and targeted window size.
##Param:	supersize_chr, no_chr_windows_, chromosomes, chr_lengths, window_size
##Output:	GRange object
##Modified:	11/10/2011
##Author:	Joern Dietrich
matNnotNA <- function(x,dimension=c("row"=1,"col"=2)[1]){
	#returns number of non-na-values per row/col
	return(apply(X=!is.na(x),MARGIN=dimension,FUN=sum))
}

## ---------------------------------------------------
##########
#Function
##########
##Input:	Parameters that specify the reference genome and targeted window size.
##Param:	supersize_chr, no_chr_windows_, chromosomes, chr_lengths, window_size
##Output:	GRange object
##Modified:	11/10/2011
##Author:	Joern Dietrich
matMin <- function(x,dimension=c("row"=1,"col"=2)[1]){
	return(apply(X=x,MARGIN=dimension,FUN=min))
}
matDiff<-function(x,groups,dimension=c("row"=1,"col"=2)[1]){
	ugr <- sort(unique(groups))
	f0 <- groups==ugr[1] & !is.na(groups)
	f1 <- groups==ugr[2] & !is.na(groups)
	if(dimension==1){	
	  res<-x[,f0,drop=FALSE]-x[,f1,drop=FALSE]
	}else{
	  res<-x[f0,,drop=FALSE]-x[f1,,drop=FALSE]
	}
	return(res)
}

## ---------------------------------------------------
matMax <- function(x,dimension=c("row"=1,"col"=2)[1]){
	return(apply(X=x,MARGIN=dimension,FUN=max))
}
## ---------------------------------------------------
##########
#Function
##########
##Input:	Parameters that specify the reference genome and targeted window size.
##Param:	supersize_chr, no_chr_windows_, chromosomes, chr_lengths, window_size
##Output:	GRange object
##Modified:	11/10/2011
##Author:	Joern Dietrich
matMean <- function(x,dimension=c("row"=1,"col"=2)[1]){
	return(apply(X=x,MARGIN=dimension,FUN=mean))
}
## ---------------------------------------------------
##########
#Function
##########
##Input:	Parameters that specify the reference genome and targeted window size.
##Param:	supersize_chr, no_chr_windows_, chromosomes, chr_lengths, window_size
##Output:	GRange object
##Modified:	11/10/2011
##Author:	Joern Dietrich
matSd <- function(x,dimension=c("row"=1,"col"=2)[1]){
	return(apply(X=x,MARGIN=dimension,FUN=sd))
}
## ---------------------------------------------------
##########
#Function
##########
##Input:	Parameters that specify the reference genome and targeted window size.
##Param:	supersize_chr, no_chr_windows_, chromosomes, chr_lengths, window_size
##Output:	GRange object
##Modified:	11/10/2011
##Author:	Joern Dietrich
matTtest <- function(x,groups,dimension=c("row"=1,"col"=2)[1],alternative = c("two.sided", "less", "greater")[1],paired=c(FALSE,TRUE)[1]){
	#cat("modified version!\n")
	if(length(groups)!= dim(x)[c(2,1)[dimension]]){
		stop(paste("Length of groups vector is not identical to dimension",c(2,1)[dimension],"  of x."))
	}
	if(paired){
		if(length(f0)!=length(f1)){
			stop("not all arguments have the same length")
		}
		vdiff<-matDiff(x,groups)
#######################das habe ich auch geaendert, aber paired ttest wird ja eh nicht aufgerufen
		n=apply(!is.na(vdiff),dimension,sum)
#######################
		tstat=matMean(vdiff)/sqrt(apply(X=x,MARGIN=dimension,FUN=var)/n)
		df <- n -1
	}else{
		ugr <- sort(unique(groups))
		if(length(ugr)!=2){
			stop(paste("There need to be exactly 2 group identifiers in groups (not counting NAs) but",
							length(ugr),"were provided."))
		}
		f0 <- groups==ugr[1] & !is.na(groups)
		f1 <- groups==ugr[2] & !is.na(groups)
		sd0<- apply(x[,f0],dimension,sd)
		sd1<- apply(x[,f1],dimension,sd)
		na0<-apply(!is.na(x[,f0]),dimension,sum)
		na1=apply(!is.na(x[,f1]),dimension,sum)
		tstat <- (apply(x[,f0],dimension,mean)-apply(x[,f1],dimension,mean)) / sqrt( sd0^2/na0 + sd1^2/na1)
		df <- na0 + na1 -2
		if(any(sd0 != sd1)){
			fi     <- sd0 != sd1 			
			err0   <- sd0[fi]/sqrt(na0[fi])
			err1   <- sd1[fi]/sqrt(na1[fi])		
			df[fi] <- (err0^2+err1^2)^2/(err0^4/(na0-1) + err1^4/(na1-1))		
		}
	}
	if (alternative == "less") {
		pval <- pt(tstat, df)
	}
	else if (alternative == "greater") {
		pval <- pt(tstat, df, lower.tail = FALSE)
	}
	else {
		pval  <- 2 * pt(-abs(tstat), df)
	}
	return(data.frame(p.value=pval,df=df, t.statistics=tstat))
################da die ganzen werte eh nicht ausgewertet werden, könnte man auch statdessen nur pval zurückgeben
	#return(pval)

}

##########################################################################
##Function provides two moudiles for calculating differential methylation
##########################################################################
##Input:	genomic coordinates and data for groups of MEDIPS SETs
##Param:	base, values, diff.method, nMSets1, nMSets2, p.adj, n.r.M1, n.r.M2, p.adj, MeDIP, minRowSum
##Output:	results of differential methylation analysis plus index in genome wide table
##Requires:	edgeR
##Modified:	1/9/2015
##Author:	Lukas Chavez, Joern Dietrich

MEDIPS.diffMeth = function(base = NULL, values=NULL, diff.method="ttest", nMSets1=NULL, nMSets2=NULL, n.r.M1=n.r.M1, n.r.M2=n.r.M2, p.adj="bonferroni", MeDIP, minRowSum=10, diffnorm="tmm")
{
	##edgeR##
	#########
	if(diff.method=="edgeR"){		
			
		##Extract non-zero MeDIP count windows
		cat(paste("Extracting count windows with at least", minRowSum, "reads...\n", sep=" "))
		filter= rowSums(values)>=minRowSum

		##Extract non-zero coupling factor rows
		if(MeDIP){
			cat(paste("Extracting non-zero coupling factor windows...\n", sep=" "))
			filter=filter & base[,4]!=0
		}

		cat(paste("Execute edgeR for count data of", sum(filter), "windows...\n", sep=" "))
		cat("(Neglecting parameter 'type')\n")

		cat("Creating a DGEList object...\n")						
		edRObj.group=c(rep(1, nMSets1), rep(2, nMSets2))
		edRObj.length=c(n.r.M1, n.r.M2)
		#d <- edgeR::DGEList(counts = values[filter,], group = edRObj.group, lib.size=edRObj.length)
		d <- edgeR::DGEList(counts = values[filter,], group = edRObj.group)

		if(diffnorm=="tmm"){
			cat("Apply trimmed mean of M-values (TMM) for library sizes normalization...\n")	
			d=edgeR::calcNormFactors(d)
		}
		if(diffnorm=="quantile" | diffnorm=="none"){
			cat("Skipping trimmed mean of M-values (TMM) library size normalization...\n")	
			d=edgeR::calcNormFactors(d, method="none")
		}
	    if(diffnorm!="tmm" & diffnorm!="quantile" & diffnorm!="none"){
	    	stop("diffnorm method unknown.")
	    }

		if(nMSets1!=1 | nMSets2!=1){
			cat("Estimating common dispersion...\n")			
			d=edgeR::estimateCommonDisp(d)
			cat("Estimating tagwise dispersion...\n")	
			d=edgeR::estimateTagwiseDisp(d)
			cat("Calculating differential coverage...\n")
			de.com=edgeR::exactTest(d,pair=c("2","1"))
		}
		else{
			cat("There is no replication, setting dispersion to bcv^2 where bcv=0.01.\n")
			cat("Please consider http://www.bioconductor.org/packages/release/bioc/vignettes/edgeR/inst/doc/edgeRUsersGuide.pdf section 2.9.\n")
			bcv = 0.01
			cat("Calculating differential coverage...\n")
			de.com = suppressWarnings(edgeR::exactTest(d, dispersion=bcv^2, pair=c("2","1")))
		}
		
		##Adjusting p.values for multiple testing
		cat(paste("Adjusting p.values for multiple testing...\n", sep=" "))
		colnames(de.com$table) = c("edgeR.logFC", "edgeR.logCPM", "edgeR.p.value")		
		diff.results = cbind(de.com$table, edgeR.adj.p.value=p.adjust(de.com$table$edgeR.p.value, p.adj)) 
		
		rm(de.com, edRObj.group, edRObj.length, d)
		gc()
	}
		
	##ttest/Score##
	#########
	else{			
		##Extract non-zero MeDIP rows
		cat(paste("Extracting count windows with at least",minRowSum," reads...\n", sep=" "))

		filter= rowSums(values)>=minRowSum

		##Extract non-zero coupling factor windows
		if(MeDIP){
			cat(paste("Extracting non-zero coupling factor windows...\n", sep=" "))
			filter=filter & base[,4]!=0
		}
	
		#filter NA
		#if there is a na in a row, this row is sorted out?!
		filter=filter & !is.na(rowSums(values))

			
		cat(paste("Calculating score for", sum(filter), "windows...\n", sep=" "))
		ms1=1:nMSets1
		ms2=(nMSets1+1):(nMSets1+nMSets2)
		##Calculate ratios##
		####################
		ratio=rowSums(values[filter,ms1]+0.1)/rowSums(values[filter,ms2,drop=F]+0.1)*(nMSets2/nMSets1)
	
		##Calculate p.values##
		######################
		##Check for constant entries
		## Filter out constant entries, as they have no sd

		const = apply(X=values[filter,ms1,drop=F],MARGIN=1,FUN=min) - apply(X=values[filter,ms1,drop=F],MARGIN=1,FUN=max) 	+
			apply(X=values[filter,ms2,drop=F],MARGIN=1,FUN=min) - apply(X=values[filter,ms2,drop=F],MARGIN=1,FUN=max) 	== 0

		t.test.p.value = rep(NA, sum(filter))				

		t.test.p.value[!const]=matTtest(values[filter,][!const,],groups=c(rep(1,nMSets1),rep(2,nMSets2)))$p.value

		##Calculate the final score##
		#############################
		score = (-log10(t.test.p.value)*10)*log(ratio)
		
		##Adjusting p.values for multiple testing
		cat(paste("Adjusting p.values for multiple testing...\n", sep=" "))	
			
		diff.results = cbind(score.log2.ratio=log2(ratio), score.p.value=t.test.p.value, score.adj.p.value=p.adjust(t.test.p.value, p.adj), score=score)
			
		rm(const, ratio, t.test.p.value, score)
		
	}		
	return(list(diff.results=diff.results, diff.index=which(filter)))
}

##########################################################################
##The function counts how many of the specified sequence pattern exist in each window.
##########################################################################
##Input:	Parameters that specify the sequence pattern and the size of the windows w.r.t the reference genome
##		Parameters can be specified w.r.t. a given MEDIPS SET object.
##Param:	pattern, refObj
##Output:	COUPLING SET
##Requires:	gtools, BSgenome
##Modified:	01/09/2015
##Author:	Lukas Chavez

MEDIPS.couplingVector <- function(pattern="CG", refObj=NULL){	
	if(is.list(refObj)){
		refObj=refObj[[1]]
	}
	if(class(refObj)!="MEDIPSset" & class(refObj)!="MEDIPSroiSet")	{
		stop("You must provide an MEDIPSset or MEDIPSroiSet as reference object\n")
	}

	chr_lengths=chr_lengths(refObj)
	chromosomes = chr_names(refObj)
	BSgenome = genome_name(refObj)

	if(is.list(refObj)){
		refObj=refObj[[1]]
	}

	## Get the genomic positions of the sequence pattern
	cat("Get genomic sequence pattern positions...\n")
	GRanges.pattern = MEDIPS.getPositions(BSgenome, pattern, chromosomes)
	
	## Create the genome vector Granges object	
	if(class(refObj)=="MEDIPSset"){
		window_size = window_size(refObj)
		no_chr_windows = ceiling(chr_lengths/window_size)
		supersize_chr = cumsum(no_chr_windows)	
		Granges.genomeVec = MEDIPS.GenomicCoordinates(supersize_chr, no_chr_windows, chromosomes, chr_lengths, window_size)	
	}else{	#this means: class(refObj)=="MEDIPSroiSet"
		Granges.genomeVec = rois(refObj)
		window_size=-1
	}
			
	##Count the number of sequence pattern in each window.
	cat(paste("Counting the number of ",pattern, "'s in each window...\n", sep=""))
	genomeCoup = countOverlaps(Granges.genomeVec, GRanges.pattern) 

	COUPLINGsetObj = new('COUPLINGset', seq_pattern=pattern, genome_name=BSgenome, genome_CF=genomeCoup, number_pattern=length(GRanges.pattern), window_size=window_size, chr_names=chromosomes, chr_lengths=chr_lengths)
	gc()
	
	return(COUPLINGsetObj)	
}

%\VignetteIndexEntry{MEDIPS}
%\VignetteKeywords{}
%\VignetteDepends{MEDIPS, BSgenome, BSgenome.Hsapiens.UCSC.hg19, edgeR, DNAcopy, rtracklayer}
%\VignettePackage{MEDIPS}

\documentclass[a4paper]{article}

<<style-Sweave, eval=TRUE, echo=FALSE, results=tex>>=
BiocStyle::latex()
@

\bioctitle[MEDIPS]{MEDIPS: genome-wide differential coverage analysis of sequencing data derived from DNA enrichment experiments.}
\author{Lukas Chavez\footnote{lukaschavez@ucsd.edu}}

\begin{document}

\maketitle

%\pagenumbering{roman}

\tableofcontents

\section{Introduction}
\Biocpkg{MEDIPS} was developed for analyzing data derived from methylated DNA immunoprecipitation (MeDIP) experiments \cite{Weber2005a} followed by sequencing (MeDIP-seq) \cite{Down2008}.
However, \Biocpkg{MEDIPS} provides several functionalities for the analysis of other kinds of quantitative sequencing data (e.g. ChIP-seq, MBD-seq, CMS-seq, and others) including calculation of differential coverage between groups of samples as well as saturation and correlation analyses \cite{Lienhard}.
 
In detail, \Biocpkg{MEDIPS} adresses the following aspects in the context of quantitative sequencing data analysis: 

\begin{itemize}
\item 
calculating genome wide signal densities at a user specified resolution (counts, rpkm),
\item 
calculating differential coverage comparing two groups of samples,
\item 
estimating the reproducibility for obtaining full genome short read coverage profiles (saturation analysis), 
\item 
correcting for copy number variations present in the genomic background of the samples based on Input samples (if available),
\item 
export of raw and normalized data as Wiggle files for visualization in common genome browsers (e.g. the UCSC genome browser).
\end{itemize} 

In addition, \Biocpkg{MEDIPS} provides the following MeDIP/MBD-seq specific functionalities:
\begin{itemize}
\item 
analyzing the coverage of genome wide DNA sequence patterns (e.g. CpGs) by the given short reads (or their mapping results, respectively),
\item 
calculating a CpG enrichment factor as a quality control for MeDIP/MBD specific immunoprecipitation,
\item 
calculating genome wide sequence pattern densities (e.g. CpGs) at a user specified resolution and export as wiggle track,
\item 
plotting of calibration plots as a data quality check and for a visual inspection of the dependency between local sequence pattern (e.g. CpG) densities and MeDIP/MBD signals,
\item 
normalization of MeDIP-seq data with respect to local sequence pattern (e.g. CpG) densities (rms, relative methylation score) \cite{Chavez2010}.
\end{itemize} 

\Biocpkg{MEDIPS} starts where the mapping tools stop (BAM or BED files) and can be used for any genome of interest. In case a genome of interest is not available as a \Biocpkg{BSgenome} package but the sequence of the genome is available, a custom \Biocpkg{BSgenome} package can be generated, please see the "How to forge a \Biocpkg{BSgenome} data package" manual of the \Biocpkg{BSgenome} package.





\section{Installation}
To install the \Biocpkg{MEDIPS} package into your \R{} environment, start \R{} and enter:

<<echo=TRUE, eval=F>>=
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("MEDIPS")
@

Next, it is necessary to have a genome of interest available in your \R{} environment. 
Please load the \Biocpkg{BSgenome} package

<<echo=T, eval=F, results=hide>>=
library("BSgenome")
@
and check the available genomes
<<echo=TRUE, eval=F>>=
available.genomes()
@

In the given example, we mapped the short reads against the human genome build hg19. 
Therefore, we download and install this genome build:

<<echo=TRUE, eval=F>>=
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("BSgenome.Hsapiens.UCSC.hg19")
@
This takes some time, but has to be done only once for each reference genome.

Finally, the \Biocpkg{MEDIPS} workflow described below requires access to example data available in the \Biocexptpkg{MEDIPSData} package which can be installed by typing:

<<echo=TRUE, eval=F>>=
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("MEDIPSData")
@





\section{Preparations}
First, the \Biocpkg{MEDIPS} package has to be loaded. 

<<echo=T, eval=T, results=hide>>=
library(MEDIPS)
@

In the given example, we mapped the short reads against the human genome build hg19. 
Therefore, we load the pre-installed hg19 library:

<<echo=T, eval=T, results=hide>>=
library(BSgenome.Hsapiens.UCSC.hg19)
@

\Biocpkg{MEDIPS} requires mapping results in BAM or tab-separated (|) BED text files (chr | start | end | name | score | strand) as input. 
\Biocpkg{MEDIPS} can also import precomputed genome coverage from fixedStep wiggle files. In the latter case, all specified chromosomes have to be described completely.

\begin{sloppypar}
In order to present a typical \Biocpkg{MEDIPS} workflow, we access BAM files as well as preprocessed data included in the data package \Biocexptpkg{MEDIPSData}.
In order to load the library, please type:

<<echo=T, results=hide, eval=T, keep.source=FALSE>>=
library("MEDIPSData")
@

The example data has been generated based on the following BAM files:

\texttt{hESCs.MeDIP.Rep1.chr22.bam} (7.6M), 
\texttt{hESCs.MeDIP.Rep2.chr22.bam} (14M),
\texttt{hESCs.MeDIP.Rep3.chr22.bam} (9.1M), 
\texttt{hESCs.Input.chr22.bam} (4.9M), 
\texttt{DE.MeDIP.Rep1.chr22.bam} (12M), 
\texttt{DE.MeDIP.Rep2.chr22.bam} (14M), 
\texttt{DE.MeDIP.Rep3.chr22.bam} (13M), and
\texttt{DE.Input.chr22.bam} (11M)
\end{sloppypar}

These BAM files are the \software{bowtie} \cite{Langmead2009} mapping results of MeDIP-seq data derived from three replicates of human embryonic stem cells (hESCs) and 
three replicates of differentiated hESCs (definitive endoderm, DE) \cite{Chavez2010}. 
For each condition there is one BAM file containg the mapping results of corresponding Input-seq data. 

In this manual, we access some BAM files located in the \texttt{extdata} subdirectory of the \Biocexptpkg{MEDIPSData} package.
We have to point to the example BAM files as follows:

<<echo=T, results=hide, eval=T, keep.source=FALSE>>=
bam.file.hESCs.Rep1.MeDIP = system.file("extdata", "hESCs.MeDIP.Rep1.chr22.bam", package="MEDIPSData")
bam.file.hESCs.Input = system.file("extdata", "hESCs.Input.chr22.bam", package="MEDIPSData")
bam.file.DE.Input = system.file("extdata", "DE.Input.chr22.bam", package="MEDIPSData")
@

Some other BAM files have been already preprocessed and will be accessed as internally saved RData objects (see below).
 
Typically, you will directly specify your data file at the \texttt{file} parameter.
It is also possible to specify the full path to your input file together with the file name.

Next, we define several parameters which will be used throughout the manual.
The reference genome is hg19:
<<echo=T, eval=T, results=hide>>=
BSgenome="BSgenome.Hsapiens.UCSC.hg19"
@
To avoid artefacts caused by PCR over amplification \Biocpkg{MEDIPS} determines a maximal allowed number of stacked reads per genomic position by a poisson distribution of stacked reads genome wide and by a given p-value:
<<echo=T, eval=T, results=hide>>=
uniq=1e-3
@
The smaller the p-value, the more reads at the same genomic position are potentially allowed.
Alternatively, all reads mapping to exactly the same genomic position can be maintained (uniq = 0) or replaced by only one representative (uniq = 1).


All reads will be extended to a length of 300nt according to the given strand information:
<<echo=T, eval=T, results=hide>>=
extend=300
@
As an alternative to the extend parameter, the \texttt{shift} parameter can be used.
Here, the reads are not extended but shifted by the specified number of nucleotides with respect to the given strand infomation.
One of the two parameters \texttt{extend} or \texttt{shift} has to be 0. 
<<echo=T, eval=T, results=hide>>=
shift=0
@
The genome will be divided into adjacent windows of length 100nt and all further calculations (short read coverage, differential coverage between conditions etc.) will be applied to these windows. 
<<echo=T, eval=T, results=hide>>=
ws=100
@

\bioccomment{There is no general recommendation for the window size, because different DNA enrichment experiments can have different resolutions. Smaller window sizes may lose some statistical power due to smaller sequencing counts per window. The choice of an appropriate window size will depend on the available sequencing depth, the expected resolution of the experiment, and on the memory and runtime requirements (the smaller the window size, the higher the memory requirements and the bigger the result table).}

In this manual, we are going to process only one chromosome (i.e. chr22).
Therefore, we specify the \texttt{chr.select} parameter.
Please note, the example BAM files contain only data for chr22 anyway. 
<<echo=T, eval=T, results=hide>>=
chr.select="chr22"
@

\bioccomment{Make sure that the sequencing data has been mapped to the same version of the reference genome as the BSgenome reference and that the mapping reference has the same chromosome names as the BSgenome reference. By default, MEDIPS will calculate coverage at all chromosomes of the specified BSgenome reference. To avoid unusual chromosmes in the results, please make use of the \texttt{chr.select} parameter.}






\section{Case study: Genome wide methylation and differential coverage between two conditions}
Here, we calculate genome wide short read coverage and methylation profiles for the three hESCs and for the three DE replicates \cite{Chavez2010}.
In addition, we calculate differential coverage between conditions (here, this will be interpreted as differential methylation).

\subsection{Data Import and Preprocessing}
First, we create a MEDIPS SET for the first replicate from the undifferentiated hESCs:
<<echo=TRUE, eval=F, results=hide, keep.source=FALSE>>=
hESCs_MeDIP = MEDIPS.createSet(file=bam.file.hESCs.Rep1.MeDIP, BSgenome=BSgenome, extend=extend, shift=shift, uniq=uniq, window_size=ws, chr.select=chr.select)
@
where the parameters remain as defined in section \texttt{Preparations}.
Subsequently, we have to concatenate the remaining two replicates to the first MEDIPS SET resulting in a list of MEDIPS SETs.
In principle, this would look like:
 
<<echo=TRUE, eval=F, results=hide, keep.source=FALSE>>=
bam.file.hESCs.Rep2.MeDIP = system.file("extdata", "hESCs.MeDIP.Rep2.chr22.bam", package="MEDIPSData")
hESCs_MeDIP = c(hESCs_MeDIP, MEDIPS.createSet(file=bam.file.hESCs.Rep2.MeDIP, BSgenome=BSgenome, extend=extend, shift=shift, uniq=uniq, window_size=ws, chr.select=chr.select))
@

\bioccomment{Concatenating MEDIPS SETs into a list of MEDIPS SETs does not merge these MEDIPS SETs. All samples will be treated as replicates.}

However, here we load the preprocessed lists of MeDIP-seq MEDIPS SETs available in the \Biocexptpkg{MEDIPSData} package:
<<echo=TRUE, eval=T, results=hide, keep.source=FALSE>>=
data(hESCs_MeDIP)
data(DE_MeDIP)
@


For the Input-seq data sets, we explicitely create MEDIPS SETs (also called INPUT SETs) as follows
<<echo=TRUE, eval=T, results=hide, keep.source=FALSE>>=
hESCs_Input = MEDIPS.createSet(file=bam.file.hESCs.Input, BSgenome=BSgenome, extend=extend, shift=shift, uniq=uniq, window_size=ws, chr.select=chr.select)
DE_Input = MEDIPS.createSet(file=bam.file.DE.Input, BSgenome=BSgenome, extend=extend, shift=shift, uniq=uniq, window_size=ws, chr.select=chr.select)
@

\bioccomment{Please consider the parameter \texttt{paired} of the MEDIPS.createSet function for importing paired-end sequening data.}

It is possible to add as many samples to each list as available. 
This is valid for the MeDIP and Input sets.

For CpG density dependent normalization of MeDIP-seq data, we need to generate a coupling set.
The coupling set must be created based on the same reference genome, the same set of chromosomes, and with the same window size used for the MEDIPS SETs.
For this, we specify the first MEDIPS SET in the \texttt{hESCs} object as reference,
but any of the other MEDIPS SETs would be fine as well, because all of them consist of the same set of chromosomes (here chr22 only, hg19) and have been generated with the same window size.

<<echo=TRUE, eval=T, results=hide, keep.source=FALSE>>=
CS = MEDIPS.couplingVector(pattern="CG", refObj=hESCs_MeDIP[[1]])
@



\subsection{Coverage, methylation profiles and differential coverage}
It is possible to calculate genome wide coverage and methylation profiles for only one MEDIPS SET or for only one group of MEDIPS SETs using the function \Rfunction{MEDIPS.meth}.
However, in this case study we also want to calculate differential coverage (i.e. differential methylation) between two conditions. Whenever two groups of MEDIPS SETs are provided to the \Rfunction{MEDIPS.meth} function differential coverage will be calculated.

<<echo=TRUE, eval=T, results=hide, keep.source=FALSE>>=
mr.edgeR = MEDIPS.meth(MSet1=DE_MeDIP, MSet2=hESCs_MeDIP, CSet=CS, ISet1=DE_Input, ISet2=hESCs_Input, p.adj="bonferroni", diff.method="edgeR", MeDIP=T, CNV=F, minRowSum=10)
@

Parameters that can be specified are:
\begin{itemize}
\item
\texttt{MSet1}: first group of MEDIPS SETs. Please specify at least one set.
\item
\texttt{MSet2}: second group of MEDIPS SETs. Differential coverage will be calculated, if MSet1 and MSet2 are not empty. 
\item
\texttt{CSet}: a coupling set (typically a CpG coupling set). Mandatory for normalization of MeDIP data. Can be skipped, if MeDIP=F (see below).
\item
\texttt{ISet1}: first group of INPUT SETs (corresponding to MSet1).
\item
\texttt{ISet2}: second group of INPUT SETs (corresponding to MSet2). Copy number variations will be calculated, if ISet1 and ISet2 are not empty. Can be swithced off by setting CNV=F (see below). 
\item
\texttt{p.adj}: in order to correct p.values for multiple testing, \Biocpkg{MEDIPS} uses \R{}'s \Rfunction{p.adjust} function.
Therefore, the following methods are available: holm, hochberg, hommel, bonferroni, BH, BY, fdr, none.
\item 
\texttt{diff.method}: method for calculating differential coverage. Available methods: \texttt{ttest} and \texttt{edgeR}.
The \texttt{ttest} method will be calculated only in case there are at least three replicates/MEDIPS SETs per group.
The \texttt{ttest} method can be applied to the rpkm or CpG density normalized rms values as specified by the \texttt{type} parameter (see below).
The \texttt{ttest} method adds four vectors to the result table: \texttt{score.log2.ratio}, \texttt{score.p.value}, \texttt{score.adj.p.value}, and \texttt{score} where \texttt{score = (-log10(p.value)*10)*log(ratio)}.
As an alternative, \Biocpkg{edgeR} can be applied for testing differential coverage at genome wide windows even for less than 3 replicates per group.
However, in case there is only one MEDIPS SET per group, the dispersion will be set to $bcv^2$ where $bcv=0.01$ (please consider section "What to do if you have no replicates" of \Biocpkg{edgeR}'s User's Guide).
When applying \Biocpkg{edgeR}, the weighted trimmed mean of M-values (TMM) method is used to calculate scale factors between libraries.
The \Biocpkg{edgeR} method will be applied to the counts of the genome wide windows.
The \Biocpkg{edgeR} method adds four vectors to the result table which are \Biocpkg{edgeR}'s exactTest standard output: \texttt{edgeR.logFC}, \texttt{edgeR.logCPM}, \texttt{edgeR.p.value}, and \texttt{edgeR.adj.p.value}.
\item 
\texttt{MeDIP}: This parameter determines, if a CpG density dependent relative methylation scores (rms) will be calculated for the MEDIPS SETs given at the slots \texttt{MSet1} and \texttt{MSet2}.  
\item 
\texttt{CNV}: In case there are INPUT SETs provided at both Input slots (i.e. \texttt{ISet1} and \texttt{ISet2}), 
copy number variation will be tested by applying the package \texttt{DNAcopy} to the window-wise log-ratios calculated based on the the means per group. 
By setting \texttt{CNV}=F this function will be disabled. 
Please note, the function \texttt{MEDIPS.addCNV} allows to run the CNV analysis on two groups of INPUT SETs using another (typically increased) window size.
Subsequently, the \texttt{MEDIPS.addCNV} function matches its CNV results to a given result table previously generated by the \texttt{MEDIPS.meth} function.
This allows for calculating CNVs for larger windows what might be more appropriate in case of low Input sequencing depth.
\item 
\texttt{type}: In case \texttt{diff.method} has been set to \texttt{ttest}, this parameter specifies, if differential coverage is calculated based on the rpkm or rms values.
This parameter is ignored in case the \Biocpkg{edgeR} method. \Biocpkg{edgeR} will always be applied to the count data.  
\item 
\texttt{chr}: to process only a selected set of chromosomes, e.g. c("chr1", "chr2")). 
\item
\texttt{minRowSum}: threshold for a minimum sum of counts across all samples per window (default=10). Windows with lower coverage will not be tested for differential coverage.
\item
\texttt{diffnorm}: To normalize for different library sizes and/or for different enrichment efficiencies, normalization can be enabled by setting this parameter to tmm, quantile, rpkm or rms (or none). If differential enrichment between conditions is calcualted based on edgeR (diff.method=edgeR), tmm (default) or quantile (or none) are possible, while rpkm and rms are only available when diff.method=ttest. It has been proposed \cite{Seumois} that quantile normalization can correct for varying DNA enrichment efficiencies. When enabled, quantile normalization will be applied to the count table (including all genomic windows and all samples) prior to testing for differential coverage between conditions. 
\warning{In case of quantile normalisation, the counts - but not rpkm and rms values - of the returned result table will be quantile normalized.} 
\end{itemize} 

The returned object (here \texttt{mr.edgeR}) is a list of vectors (all of the same length) where the rows correspond to genome wide windows (i.e. the result table). 
The number of vectors (or columns of the result table) depends on the number of provided MEDIPS SETs, the number of INPUT SETs, and on the specification of several parameters including \texttt{diff.methods}, \texttt{MeDIP}, and \texttt{CNV}.
For each window and for each MEDIPS or INPUT SET, there will be columns for the \texttt{counts} and \texttt{rpkm} values.
For MEDIPS SETs there can also be columns for \texttt{rms} values (if \texttt{MeDIP}=T).
For each condition with more than one provided MEDIPS or INPUT SET, respectively, there will be an additional column for the mean over the counts and rpkm values (and for rms, if available).
Moreover, there are columns for log2 ratios (MSet1/MSet2), p.values, and adjusted p.values when differential coverage has been calculated.
Optionally, there will be a vector of log2 ratios (ISet1/ISet2) as a result of the CNV analysis, in case two groups of INPUT SETs have been provided (and in case \texttt{CNV}=T) or in case a CNV analysis has been added afterwards by applying the function \texttt{MEDIPS.addCNV} (see below).
 

\subsection{Differential coverage: selecting significant windows}
As we have processed two groups of MEDIPS SETs, we are now interested in genomic windows which show significant differential coverage:

<<echo=TRUE, eval=T, keep.source=FALSE>>=
mr.edgeR.s = MEDIPS.selectSig(results=mr.edgeR, p.value=0.1, adj=T, ratio=NULL, bg.counts=NULL, CNV=F)
@

Here, we set a thresold of 0.1 for the adjusted p.values in order to select significant windows. 
There are the following filter criteria available:

\begin{itemize}
\item 
\texttt{p.value}: this is the p.value threshold as calculated either by the \texttt{ttest} or \Biocpkg{edgeR} method
\item
\texttt{adj}: this parameter specifies whether the p.value or the adjusted p.values is considered
\item 
\texttt{ratio}: this parameter sets an additional thresold for the ratio where the ratio is either \texttt{score.log2.ratio} or \texttt{edgeR.logFC} depending on the previously selected method.
Please note, the specified value will be transformed into log2 internally.
\item 
\texttt{bg.counts}: as an additional filter parameter, it is possible to require a minimal number of reads per window in at least one of the MEDIPS SET groups.
To apply this condition, the mean of the counts per group is considered. The parameter \texttt{bg.counts} can either be a concrete integer or an appropriate column name of the result matrix.
By specifying a column name (here e.g. \texttt{bg.counts="hESC.Input.bam.counts"} or \texttt{bg.counts="MSets1.counts.mean"}), 
the 0.95 quantile of the according genome wide count distribution is determined and used as a minimal background threshold (please note, only count columns are reasonable).  
\item 
\texttt{CNV}: The information on CNVs present in the samples of interest can be used for correcting differential coverage observed in the corresponding IP data (e.g. MeDIP or ChIP data).
In the given example data, we do not expect extensive events of copy number variation between pluripotent and differentiated hESCs because both samples have been derived from the same cell line.
However, samples derived from e.g. cancer tissues might show an relevant occurence of copy number variations.
Therefore, when comparing MeDIP- or ChIP-seq data derived from cancer tissue against MeDIP- or ChIP-seq data derived from corresponding healthy tissue,
an event of differential coverage might be explained in part or entirely by a local CNV.
In case Input data has been provided for both conditions, \Biocpkg{MEDIPS} is capable of calculating genome wide CNV ratios by employing the package DNAcopy.
In case the parameter \texttt{CNV} is set to TRUE, \Biocpkg{MEDIPS} will consider only genomic windows having a CNV corrected IP ratio higher than the specified ratio threshold (specification of the ratio parameter is required in this case).
\end{itemize} 

\subsection{Merging neighboring significant windows}
After having identified and extracted genomic windows showing significant differential coverage between conditions, 
it remains of interest to merge neighboring significant windows into a larger continuous region.
Please note, the result object \texttt{mr.edgeR.s} returned by the \texttt{MEDIPS.selectSig} contains genomic regions that show differential coverage into both directions, 
i.e. either a higher coverage in the group of samples in MSet1 (here DE) over the group of samples in MSet2 (here hESCs) or vice versa.
In order to isolate the subset of genomic regions that show e.g. higher coverage in MSet1 over MSet2, we use the following \R{}  syntax:

<<echo=TRUE, eval=T, keep.source=FALSE>>=
mr.edgeR.s.gain = mr.edgeR.s[which(mr.edgeR.s[,grep("logFC", colnames(mr.edgeR.s))]>0),]
@

Subsequently, the function \texttt{MEDIPS.mergeFrames} can be applied to merge all adjacent significant regions into one region which will be finally regarded as one event of differential coverage: 

<<echo=TRUE, eval=T, keep.source=FALSE, results=hide>>=
mr.edgeR.s.gain.m = MEDIPS.mergeFrames(frames=mr.edgeR.s.gain, distance=1)
@

Here we interpret the selected and merged genomic regions as differentially methylated regions (DMRs) showing gain of methylation during differentiation.

The \texttt{distance} parameter allows for merging windows having an according gap in between.
Please note, merged windows are represented only by their genomic coordinates and do not contain any summarized values (counts, rpkm, ratios etc.).

    

\subsection{Extracting data at regions of interest}
\Biocpkg{MEDIPS} provides the functionality to select subsets of the result matrix returned by the \texttt{MEDIPS.meth} function according to any given set of regions of interest (ROIs).
As an example, we consider the set of merged windows (here \texttt{mr.edgeR.s.gain.m}, see previous section) as a set of ROIs:

<<echo=TRUE, eval=F, keep.source=FALSE>>=
columns=names(mr.edgeR)[grep("counts",names(mr.edgeR))]
rois=MEDIPS.selectROIs(results=mr.edgeR, rois=mr.edgeR.s.gain.m, columns=columns, summarize=NULL)
@

The function \texttt{MEDIPS.selectROIs} will select all genomic windows in the original result table (here \texttt{mr.edgeR})
which are included in the boundaries defined by the genomic coordinates of the given set of ROIs.
The number of returned windows depends on the window size and on the length of the provided ROIs.
Please note, only selected columns will be returned as determined by the \texttt{columns} parameter.
In the given example, all columns that contain count values will be extracted.

As an alternative, it is also possible to calculate mean values over the extracted windows for each ROI, a behaviour that is controlled by the parameter \texttt{summarize}:

<<echo=TRUE, eval=F, keep.source=FALSE>>=
rois.s=MEDIPS.selectROIs(results=mr.edgeR, rois=mr.edgeR.s.gain.m, columns=columns, summarize="avg")
@

For each ROI and for each specified column, there will be one mean value returned.




\section{Quality controls}
\Biocpkg{MEDIPS} provides three different quality controls. 
In this section, the quality controls are demonstrated for the MeDIP-seq hESCs sample \texttt{hESCs\_Rep1\_MeDIP.bam}.  

\subsection{Saturation analysis}
The saturation analysis addresses the question, whether the given set of mapped reads is sufficient to generate a saturated and reproducible coverage profile of the reference genome.
Only if there is a sufficient number of short reads, the resulting genome wide coverage profile will be reproducible by another independent set of a similar number of short reads.
The saturation analysis is not specific for MeDIP-seq data and can be applied to other types of sequencing data like e.g. ChIP-seq.

<<echo=TRUE, results=hide, eval=T, keep.source=FALSE>>=
sr=MEDIPS.saturation(file=bam.file.hESCs.Rep1.MeDIP, BSgenome=BSgenome, uniq=uniq, extend=extend, shift=shift, window_size=ws, chr.select=chr.select, nit=10, nrit=1, empty_bins=TRUE, rank=FALSE)
@

The saturation analysis divides the total set of available regions into two distinct random sets (\texttt{A} and \texttt{B}) of equal size.
Both sets \texttt{A} and \texttt{B} are again divided into random subsets of equal size where the number of subsets is determined by the parameter \texttt{nit} (default=10).
For each set, \texttt{A} and \texttt{B}, the saturation analysis iteratively selects an increasing number of subsets and 
calculates short read coverage at genome wide windows where the window sizes are defined by the \texttt{window\_size} parameter.
In each iteration step, the resulting genome wide coverages for the current subsets of \texttt{A} and \texttt{B} are compared using pearson correlation. 
As the number of considered reads increases during each iteration step, it is assumed that the resulting genome wide coverages become more similar, 
a dependency that is expressed by an increased correlation. 

It has to be noted that the saturation analysis can be performed on two independent sets of short reads only. 
Therefore, a true saturation for one given sample can only be calculated for half of the available short reads.
As it is of interest to examine the reproducibility for the total set of available short reads of the given sample, the saturation analysis is followed by an estimated saturation analysis.
For the estimated saturation analysis, the full set of given regions is artifically doubled by considering each given region twice.
Subsequently, the described saturation analysis is performed on the artificially doubled set of regions (see also Supplementary Methods in \cite{Chavez2010}).

The results of the saturation and of the estimated saturation analysis can be viewed by typing
<<echo=TRUE, eval=T>>=
sr
@

The maximal obtained correlation of the saturation analysis is stored at the \texttt{maxTruCor} slot 
and the maximal obtained correlation of the estimated saturation analysis is stored at the \texttt{maxEstCor} slot of the saturation results object 
(here \texttt{sr}, first column: total number of considered reads, second column: correlation).
The results of each iteration step are stored in the \texttt{distinctSets} and \texttt{estimation} slots for the saturation and estimated saturation analysis, respectively 
(first column: total number of considered reads, second column: obtained correlation).

In addition, the results can be visualized as shown in Figure~\ref{MEDIPS-saturationplot} by typing

<<saturationplot, fig=TRUE, include=FALSE>>=
MEDIPS.plotSaturation(sr)
@
\incfig{MEDIPS-saturationplot}{0.5\textwidth}{Saturation analysis.}{The saturation analysis indicates the reproducibility of the genome wide coverage at regular genomic intervals given an increasing sequencing depth.}

Further parameters that can be specified for the saturation analysis are:
\begin{itemize}
\item
\texttt{nrit}: methods that randomly select data entries may be processed several times in order to obtain more stable results. 
By specifying the \texttt{nrit} parameter (default=1) it is possible to run the saturation analysis several times. 
The final results returned to the saturation results object are the averaged results of all random iteration steps.  
\item 
\texttt{empty\_bins}: can be either TRUE or FALSE (default TRUE). This parameter affects the way of calculating correlations between the resulting genome wide coverages. 
If there occur genomic bins which contain no overlapping regions, neither from the subset(s) of \texttt{A} nor from the subset(s) of \texttt{B}, 
these windows will be neglected when the paramter is set to FALSE.
\item 
\texttt{rank}: can be either TRUE or FALSE (default FALSE). This parameter also effects the way of calculating correlations between the resulting genome vectors.
If \texttt{rank} is set to TRUE, the correlation will be calculated for the ranks of the bins instead of considering the counts (i.e. spearman correlation).
Setting this parameter to TRUE is a more robust approach which reduces the effect of possible occuring outliers (i.e. windows with very high counts) on the correlation.   
\end{itemize} 


\subsection{Correlation between samples}
Genome wide short read coverage profiles are expected to be similar for biological or technical replicates given a sufficient sequencing depth (compare section \texttt{Saturation Analysis}).
The \texttt{MEDIPS.correlation} function comapares genome wide coverage profiles of given MEDIPS SETs 
and returns a correlation matrix containing pair-wise correlations.

<<echo=TRUE, eval=F, keep.source=FALSE>>=
cor.matrix=MEDIPS.correlation(MSets=c(hESCs_MeDIP, DE_MeDIP, hESCs_Input, DE_Input), plot=T, method="pearson")
@


\subsection{Sequence Pattern Coverage}
The main idea of the sequence pattern coverage analysis is to test the number of CpGs (or any other predefined sequence pattern) covered by the given short reads.
In addition, the depth of coverage per CpG is tested.
The sequence pattern coverage analysis can be started by typing

<<echo=TRUE, results=hide, eval=T, keep.source=FALSE>>=
cr=MEDIPS.seqCoverage(file=bam.file.hESCs.Rep1.MeDIP, pattern="CG", BSgenome=BSgenome, chr.select=chr.select, extend=extend, shift=shift, uniq=uniq)
@

The sequence pattern coverage results object (here \texttt{cr}) contains four different slots:
\begin{itemize}
\item
\texttt{cov.res}: is a vector of length equal to the total number of sequence patterns (e.g. CpGs). The entries correspond to the number of overlapping regions (coverage).
\item 
\texttt{pattern}: the tested sequence pattern (e.g. CpG)
\item 
\texttt{numberReads}: the total number of tested reads
\item 
\texttt{numberReadsWO}: the number of reads which do not cover a tested sequence pattern
\end{itemize} 

The results of the coverage analysis can be visualized by a pie chart as shown in Figure ~\ref{MEDIPS-coverageplot}:

<<coverageplot, fig=TRUE, include=FALSE>>=
MEDIPS.plotSeqCoverage(seqCoverageObj=cr, type="pie", cov.level = c(0,1, 2, 3, 4, 5))
@
\incfig{MEDIPS-coverageplot}{0.5\textwidth}{Coverage analysis- pie chart}{The coverage analysis illustrates the fraction of CpGs covered by the given reads according to their coverage level.}

The visualized coverage levels can be adjusted by the \texttt{cov.level} parameter.

Alternatively, a histogram can be plotted to visalizes the total number of CpGs that have been covered at different level (see Figure ~\ref{MEDIPS-coverageplothist}):

<<coverageplothist, fig=TRUE, include=FALSE>>=
MEDIPS.plotSeqCoverage(seqCoverageObj=cr, type="hist", t = 15, main="Sequence pattern coverage, histogram")
@
\incfig{MEDIPS-coverageplothist}{0.5\textwidth}{Coverage analysis- histogram}{The histogram shows the distribution of CpG coverages. The parameter \texttt{t} specifies the maximal coverage depth to be plotted (here: 15 reads).}



\subsection{CpG Enrichment}
As a quality check for the enrichment of CpG rich DNA fragments obtained by the immunoprecipitation step of a MeDIP/MBD experiment, \Biocpkg{MEDIPS} provides the functionality to calculate CpG enrichment values. 
The main idea is to test the enrichment of CpGs within the genomic regions covered by the given set of short reads compared to the full reference genome.
For this, \Biocpkg{MEDIPS} counts the number of Cs, the number of Gs, the number CpGs, and the total number of bases within the specified reference genome. 
Subsequently, \Biocpkg{MEDIPS} calculates the relative frequency of CpGs and the observed/expected ratio of CpGs present in the reference genome.
Additionally, \Biocpkg{MEDIPS} calculates the same for the DNA sequences underlying the given regions.
The final enrichment values result by dividing the relative frequency of CpGs (or the observed/expected value, respectively) of the regions by 
the relative frequency of CpGs (or the observed/expected value, respectively) of the reference genome.

<<echo=TRUE, eval=F, results=hide, keep.source=FALSE>>=
er=MEDIPS.CpGenrich(file=bam.file.hESCs.Rep1.MeDIP, BSgenome=BSgenome, chr.select=chr.select, extend=extend, shift=shift, uniq=uniq)
@

The enrichment results object (here \texttt{er}) contains several slots which show the number of Cs, Gs, and CpGs within the reference genome and within the given regions.
Additionally, there are slots that show the relative frequency as well as the observed/expected CpG ratio within the reference genome and within the given regions.
Finally, the slots \texttt{enrichment.score.relH} and \texttt{enrichment.score.GoGe} indicate the enrichment of CpGs within the given regions compared to the reference genome.
For short reads derived from Input experiments (i.e. sequencing of none-enriched DNA fragments), the enrichment values should be close to 1.
In contrast, a MeDIP-seq experiment should return CpG rich sequences what will be indicated by increased CpG enrichment scores.





\section{Miscellaneous}
In this section we discuss several additional functionalities currently available in the \Biocpkg{MEDIPS} package. 

\subsection{Processing regions of interest}
Instead of caluclating coverage and differential coverage at genome wide small windows, it is also possible to perform targetd analyses of regions of interest (ROI's, e.g. exons, promoter regions, CpG islands etc.). Here, the alignment files have to be imported using the function \Rfunction{MEDIPS.createROIset}. The function \Rfunction{MEDIPS.createROIset} has the same parameters as \Rfunction{MEDIPS.createSet} except that the \texttt{window\_size} parameter has been replaced by the \texttt{ROI} parameter. The \texttt{ROI} parameter expects a data.frame with columns "chr", "start", "end" and "name" defining the regions of interest. Furthermore, ROIs can be divided into bins prior to calculating sequencing coverage, a behaviour controlled by the parameter \texttt{bn}. 
\bioccomment{Please note, all ROIs will be divided into the same number of bins regardless of their length, possibly resulting into bins of different sizes.} 



\subsection{Export Wiggle Files}
\Biocpkg{MEDIPS} allows to export genome wide coverage profiles as wiggle files for visualization in common genome browsers.

<<echo=TRUE, eval=F, keep.source=FALSE>>=
MEDIPS.exportWIG(Set=hESCs_MeDIP[[1]], file="hESC.MeDIP.rep1.wig", format="rpkm", descr="")
@

\begin{itemize}
\item
\texttt{Set}: a MEDIPS SET to be exported as a wiggle file. Required when the parameter \texttt{format} is \texttt{count}, \texttt{rpkm}, or \texttt{rms}.
\item
\texttt{CSet}: a COUPLING SET to be exported as a wiggle file. Required when the parameter \texttt{format} is \texttt{pdensity} or \texttt{rms}.
\item 
\texttt{file}: the output file name
\item 
\texttt{format}: can be either count, rpkm, or rms for a MEDIPS SET or pdensity for a COUPLING SET.
\item 
\texttt{descr}: a track description for the wiggle file
\end{itemize} 


\subsection{Merging MEDIPS SETs}
A MEDIPS SET represents the mapping results of a biological sample of interest, typically a biological or technical replicate.
However, a biological or technical replicate might be sequenced several times or distributed over different lanes resulting in several bam files. 
Instead of merging associated bam files in advance of a \Biocpkg{MEDIPS} analysis, the \Biocpkg{MEDIPS} package allows to merge MEDIPS SETs generated from associated bam files.

<<echo=TRUE, eval=F, keep.source=FALSE>>=
Input.merged=MEDIPS.mergeSets(MSet1=hESCs_Input, MSet2=DE_Input, name="Input.hESCs.DE")
@

Please note, MEDIPS SETs to be merged are required to be previously generated based on the same reference genome, chromosome set, and window size.
The \texttt{extend}, \texttt{shift} or \texttt{uniq} parameters can be different and are left blank in the resulting MEDIPS SET specification.
The parameter \texttt{name} assigns a new name to the merged MEDIPS SET. 
Consequently, the merged MEDIPS SET does not have a concrete path and file association anymore and cannot be used as input for the \texttt{MEDIPS.addCNV} function.    


\subsection{Annotation of significant windows}
It is of interest to annotate genomic windows with known genome characteristics like transcription start sites, exons, CpG islands etc.
\Biocpkg{MEDIPS} provides a basic function for adding additional annotation columns to the result table. 
For this, an annotation object is required which contains the annotation ids, chromosome names, start and end positions. 
As an example, \Biocpkg{MEDIPS} allows to generate such an annotation object by accessing BioMart \cite{Durinck}:

<<echo=TRUE, eval=F, keep.source=FALSE>>=
anno.mart.gene = MEDIPS.getAnnotation(dataset=c("hsapiens_gene_ensembl"), annotation=c("GENE"), chr="chr22")
@

Annotation of the result matrix (either the full matrix or a subset of the matrix as selected by e.g. the \texttt{MEDIPS.selectSig} function)
can now be performed as follows:

<<echo=TRUE, eval=F, keep.source=FALSE>>=
mr.edgeR.s = MEDIPS.setAnnotation(regions=mr.edgeR.s, annotation=anno.mart.gene)
@

An annotation is assigned to a genomic window, if their genomic coordinates overlap.

\subsection{addCNV}
In case there are INPUT SETs provided at both Input slots (i.e. \texttt{ISet1} and \texttt{ISet2}) of the \texttt{MEDIPS.meth} function, 
copy number variation will be tested by applying the package \texttt{DNAcopy} to window-wise log-ratios calculated based on the the means per group. 
However, by setting \texttt{CNV}=F copy number variation analysis will be disabled avoiding a computational demanding CNV analysis at previously determined (typically short) genome wide windows. 
The function \texttt{MEDIPS.addCNV} allows to run the CNV analysis on two groups of INPUT SETs using another (typically increased) window size.
Subsequently, the \texttt{MEDIPS.addCNV} function matches its CNV results to the given result table as previously generated by the \texttt{MEDIPS.meth} function.
This allows for calculating CNVs for larger windows what might be more appropriate in case of low sequencing depth of Input-seq data.

<<echo=TRUE, eval=F, keep.source=FALSE>>=
mr.edgeR=MEDIPS.addCNV(cnv.Frame=10000, ISet1=hESCs_Input, ISet2=DE_Input, results=mr.edgeR)
@

\subsection{Calibration Plot}
MeDIP-seq data is transformed into genome wide relative methylation scores by a previously presented CpG dependent normalization method \cite{Chavez2010}.
Normalization is based on the dependency between short read coverage and CpG density at genome wide windows. 
This dependency has been originally demonstrated by Down et al. \cite{Down2008} and can be visualized as a calibration plot.

<<echo=TRUE, eval=F, keep.source=FALSE>>=
MEDIPS.plotCalibrationPlot(CSet=CS, main="Calibration Plot", MSet=hESCs_MeDIP[[1]], plot_chr="chr22",  rpkm=TRUE,  xrange=TRUE)
@

\begin{itemize}
\item
\texttt{CS}: the COUPLING SET
\item 
\texttt{ISet}: an INPUT SET (i.e. a MEDIPS SET created from Input sequening data). No linear regression will be calculated for the Input Set.
\item 
\texttt{main}: the main of the figure
\item 
\texttt{MSet}: the MEDIPS SET object
\item 
\texttt{plot\_chr}: the chromsome for which the calibration plot will be generated
\item 
\texttt{rpkm}: specifies, if the MeDIP data range will be plotted in count or rpkm format. It is necessary to set rpkm=T, if both, a MSet and an ISet are given and plotted at the same time.
\item 
\texttt{xrange}: if set to TRUE, only the lower data range of the calibration plot will be visualized
\end{itemize} 

Please note, it is strongly recommended to direct the output to a graphics device like e.g. png().    


\subsection{Comments on the experimental design and Input data}
There are two common questions for conducting and analyzing MeDIP or any other kind of enrichment/immunoprecipitation (IP) based sequencing data: 
first, it is of interest to identify enriched regions in an IP sample in order to reveal e.g. methylated regions, the occurrence of histone modifications, or to localize transcription factor binding sites. 
Second, it is of interest to identify differential short read coverage comparing two conditions (here treatment vs. control) in order to identify genomic regions that show e.g. differential methylation or differential transcription factor binding. 
An intutive approach for identifying differential coverage is to first calculate condition-wise enrichments (or 'peaks') followed by mutual subtraction of these 'peak sets'. 
However, this approach has several limitations (not discussed here) and the \Biocpkg{MEDIPS} package follows an alternative strategy directly comparing the groups of IP samples against each other.

For the identification of sample-wise local enrichments, any peak finder appropriate for the analyzed data type may be applied (differences of peak finding tools are not discussed here). 
In addition, it is recommended to include Input data for estimating a background coverage distribution and local coverage bias. 
Most peak finders are capable of incorporating Input data. For MeDIP data, a CpG density bias has been observed that is not considered by standard peak callers. 
MEDIPS allows to incorporate the CpG density into the short-read counts resulting in relative methylation values (rms), and we have shown an improved correlation of rms values to bisulfite sequencing data compared to counts or rpkm values \cite{Chavez2010}. 
However, the resulting range of rms values depends on several unknown factors including the total abundance of methyalted cytosines in the sample or high outlier signals which might be present even in Input data.
In case reference bisulfite data of selected genomic regions is available (low to high methylation), it is possible to associate the range of MeDIP-seq derived rms values to the bisulfite derived data range (i.e. percentage of methylated cytosines per window) \cite{Grimm2013}. 
However, without reference data, it remains an insufficiently solved problem to estimate thresholds for low, intermediate, and high metylation, or to caluculate significant local enrichments based on CpG density corrected data in order to identify methylated regions (or 'peaks') over background.

For the identification of differential coverage, it can be assumed that any experiment independent bias, like local CpG density, affects the short read coverage in both samples (control and treatment) the same way. 
Therefore, no normalization of CpG density or other experiment independent factors may be performed when differential coverage between two groups of IP samples is calculated. 
As a consequence, Input samples for the control and for the treatment samples might not be necessary. 
However, there can exist differences in the genomic backgrounds of the control and treatment samples caused by e.g. copy number variations in cancer versus healthy cells. 
In such cases, it is necessary to explicitly create independent Input samples for the control and for the treatment samples in order to reveal local background differences that can influence the identification of differential coverage comparing the according IP samples. 
\Biocpkg{MEDIPS} (1.10.0 or higher) can process an arbitrary number of Input samples per condition, if available, and allows for considering copy number variations observed in the Input data when differential coverage is calculated for the IP data. 

In summary, the need for Input data depends on two conditions: the experimental design ("Am I interested in IP enrichments over Input or do I want to calculate differential coverage between groups of IP samples?") and the genomic background or different experimental conditions of the biological samples ("Do my samples have the same genomic background?").



\bibliography{MEDIPSTutorial}


\end{document}

\name{MEDIPS.getAnnotation}
\alias{MEDIPS.getAnnotation}
\title{
Funtion to fetch annotations from biomaRt.
}
\description{
The function receives predifined annotations from ensembl biomaRt for subsequent annotation of a result table.
}
\usage{
MEDIPS.getAnnotation(host="www.ensembl.org",dataset=c("hsapiens_gene_ensembl","mmusculus_gene_ensembl")[1],annotation=c("TSS","EXON","GENE")[1],tssSz=c(-1000,500),chr=NULL)
}
\arguments{
  \item{host}{
BioMart database host you want to connect to.
For current ensembl version, use "www.ensembl.org". For other versions, set to the respective archive host, e.g. "may2012.archive.ensembl.org" for Ensembl 67
Please ensure that the ensembl version is compatible to the used genome version. 
}
  \item{dataset}{
The dataset you want to use.  To see the different datasets available within a biomaRt you can e.g. do: mart = useMart('ensembl'), followed by listDatasets(mart).
}
\item{annotation}{
Type of annotation you want to retrieve.  You can select "EXON" for exonic regions, "GENE" for gene regions including introns and "TSS" for regions at the transcirption start site. 
}
\item{tssSz}{
Defines the TSS region: start and end position relative to the strand and position of the transcript. 
}
\item{chr}{
Chromosome names for which the annotations should be filtered.
}
}
\value{
The MEDIPS.getAnnotation function returns a list of annotation tables where each table consists of
\item{id}{the id of the annotation}
\item{chr}{the chromosome of the annotation}
\item{start}{the start position (5') of the annotation}
\item{end}{the end position (3') of the annotation}
}
\author{
Joern Dietrich and Matthias Lienhard
}

\examples{

#homo sapiens, current ensembl version
#annotation_hs = MEDIPS.getAnnotation(dataset="hsapiens_gene_ensembl", annotation="TSS", chr=c("chr22"),tssSz=c(-1000,500))

#mus musculus, ensembl version 58 (mm9)
#annotation_mm9 = MEDIPS.getAnnotation(host="may2010.archive.ensembl.org",dataset="mmusculus_gene_ensembl", annotation="TSS", chr=c("chr19"))

}

\name{MEDIPS.plotCalibrationPlot}
\alias{MEDIPS.plotCalibrationPlot}
\title{
Creates the calibration plot.
}
\description{
Visualizes the dependency between MeDIP-seq signals and CpG densities together with the calcibration curve and the results of the linear modelling.
}
\usage{
MEDIPS.plotCalibrationPlot(MSet=NULL, ISet=NULL, CSet=NULL, plot_chr="all", rpkm=T, main="Calibration plot", xrange=T)
}
\arguments{
  \item{MSet}{
a MEDIPS SET object
}
\item{ISet}{
an INPUT SET (i.e. a MEDIPS SET created from Input sequening data)
}
\item{CSet}{
an according COUPLING SET object
}
\item{plot_chr}{
default="all". It is recommended to call a graphics device (e.g. png("calibrationPlot.png")) before calling the plot command, because R might not be able to plot the full amount of data in reasonable time.
}
\item{rpkm}{
can be either TRUE or FALSE. If set to TRUE, the methylation signals will be transformed into rpkm before plotted.
The coupling values remain untouched. It is necessary to set rpkm=T, if both, a MSet and an ISet are given and plotted at the same time.
}
\item{main}{
The title of the calibration plot.
}
\item{xrange}{
The signal range of the calibration curve typically falls into a low signal range. 
By setting the xrange parameter to TRUE, the calibration plot will visualize the low signal range only. 
}

}
\value{
The calibration plot will be visualized.
}
\author{
Lukas Chavez, Matthias Lienhard
}
\examples{
library(MEDIPSData)
data(hESCs_MeDIP)
data(CS)

MEDIPS.plotCalibrationPlot(CSet=CS, main="Calibration Plot", MSet=hESCs_MeDIP[[1]], plot_chr="chr22",  rpkm=TRUE,  xrange=TRUE)

}

\name{MEDIPSset-class}
\Rdversion{1.1}
\docType{class}
\alias{MEDIPSset-class}
\alias{MEDIPSset}
\alias{genome_name,MEDIPSset-method}
\alias{bin_size,MEDIPSset-method}
\alias{chr_names,MEDIPSset-method}
\alias{chr_lengths,MEDIPSset-method}
\alias{sample_name,MEDIPSset-method}
\alias{path_name,MEDIPSset-method}
\alias{number_regions,MEDIPSset-method}
\alias{genome_count,MEDIPSset-method}
\alias{extend,MEDIPSset-method}
\alias{show,MEDIPSset-method}
\alias{shifted,MEDIPSset-method}
\alias{window_size,MEDIPSset-method}
\alias{uniq,MEDIPSset-method}

\alias{setTypes}
\alias{path_name}
\alias{getTypes}
\alias{getGRange}
\alias{adjustReads}
\alias{MEDIPS.Bed2Granges}
\alias{MEDIPS.Bam2GRanges}

\alias{genome_name}
\alias{bin_size}
\alias{chr_names}
\alias{chr_lengths}
\alias{sample_name}
\alias{number_regions}
\alias{genome_count}
\alias{extend}
\alias{show}
\alias{shifted}
\alias{uniq}
\alias{window_size}

\alias{MEDIPS.GenomicCoordinates}
\alias{MEDIPS.calibrationCurve}
\alias{MEDIPS.cnv}
\alias{MEDIPS.getPositions}
\alias{MEDIPS.rms}

\alias{matNnotNA}
\alias{matMin}
\alias{matDiff}
\alias{matMax}
\alias{matMean}
\alias{matSd}
\alias{matTtest}



\title{MEDIPSset class and internal functions}
\description{MEDIPSset class is used in the MEDIPS library in order to store and extract objects and information from the input file as well as parameter settings specified during the workflow.}
\section{Objects from the Class}{
Objects of the classes contain information about the provided short reads, MeDIP raw/count signals, and further parameter settings.
A MEDIPS SET object is created by the MEDIPS.genomeVector() function.
According slots will be filled during the workflow.
}
\section{Slots}{
  \describe{
	\item{\code{genome_name}:}{Object of class \code{"character"} : the refernce genome }
	\item{\code{window_size}:}{Object of class \code{"numeric"} : the window size for the genome vector }
	\item{\code{chr_names}:}{Object of class \code{"character"} : the names of the chromosomes included within the MEDIPS/COUPLING SET }
	\item{\code{chr_lengths}:}{Object of class \code{"numeric"} : the lengths of the chromosomes included within the MEDIPS/COUPLING SET}
	\item{\code{sample_name}:}{Object of class \code{"character"} : the name of the input file }
	\item{\code{path_name}:}{Object of class \code{"character"} : the path to the input file }
	\item{\code{number_regions}:}{Object of class \code{"numeric"} : the total number of included regions }
	\item{\code{genome_count}:}{Object of class \code{"numeric"} : the raw MeDIP-seq signals at the genomic bins }    
	\item{\code{extend}:}{Object of class \code{"numeric"} : the length of the regions after extension }
	\item{\code{shifted}:}{Object of class \code{"numeric"} : the number of bases by which the reads are shifted along the sequencing direction }
	\item{\code{uniq}:}{Object of class \code{"logical"} : determines if all reads mapping to exactly the same genomic position should be kept (uniq = 0), replaced by only one representative (uniq = 1), or if the number of stacked reads should be capped by a maximal number of stacked reads per genomic position determined by a poisson distribution of stacked reads genome wide and by a given p-value (1 > uniq > 0).}                
  }
}
\section{Methods}{
  \describe{
    \item{genome_name}{\code{signature(object = "MEDIPSset")}: extracts the reference genome of the MEDIPS SET}    
    \item{window_size}{\code{signature(object = "MEDIPSset")}: extracts the window size from the bin_size slot of the MEDIPS SET}
    \item{chr_names}{\code{signature(object = "MEDIPSset")}: extracts the names of the chromosomes included within the MEDIPS SET }
    \item{chr_lengths}{\code{signature(object = "MEDIPSset")}: extracts the length of the chromosomes included within the MEDIPS SET }
    \item{fragmentLength}{\code{signature(object = "MEDIPSset")}: extracts the estimated fragment length of the DNA fragments }
    \item{sample_name}{\code{signature(object = "MEDIPSset")}: extracts the name of the input file}
    \item{path_name}{\code{signature(object = "MEDIPSset")}: extracts the path to the input file}
    \item{number_regions}{\code{signature(object = "MEDIPSset")}: extracts the total number of included regions}
    \item{genome_count}{\code{signature(object = "MEDIPSset")}: extracts the raw MeDIP-Seq signals at the genomic bins }    
    \item{extend}{\code{signature(object = "MEDIPSset")}: extracts the number of bases by which the regions are extended }
    \item{show}{\code{signature(object = "MEDIPSset")}: prints a summary of the MEDIPS SET object content }
    \item{shifted}{\code{signature(object = "MEDIPSset")}: extracts the number of bases by which the regions are shifted }
    \item{uniq}{\code{signature(object = "MEDIPSset")}: extracts the specified value for the uniq parameter }
        
    \item{MEDIPS.GenomicCoordinates}{\code{signature(object = "MEDIPSset")}: internal function for calculating coordinates for the genomic bins }    
    \item{MEDIPS.readRegionsFile}{\code{signature(object = "MEDIPSset")}: internal function for reading short read information }
    \item{MEDIPS.calibrationCurve}{\code{signature(object = "MEDIPSset")}: internal function for calculating the calibration curve}
    \item{MEDIPS.cnv}{\code{signature(object = "MEDIPSset")}: internal function for calculating CNVs in case two groups of INPUT SETs have been provided to the MEDIPS.meth function}
    \item{MEDIPS.diffMeth}{\code{signature(object = "MEDIPSset")}: internal function for calculating differential coverage in case two groups of MEDIPS SETs have been provided to the MEDIPS.meth function}
    \item{MEDIPS.getPositions}{\code{signature(object = "MEDIPSset")}: internal function for receiving genomic coordinates of a given sequence pattern (e.g. CG)}
    \item{MEDIPS.rms}{\code{signature(object = "MEDIPSset")}: internal function for calculating relative methylation scores}

    \item{matNnotNA}{\code{signature(object = "MEDIPSset")}: internal function for vectorized calculation of the t.test }
    \item{matMin}{\code{signature(object = "MEDIPSset")}:   internal function for vectorized calculation of the t.test }
    \item{matDiff}{\code{signature(object = "MEDIPSset")}:  internal function for vectorized calculation of the t.test }
    \item{matMax}{\code{signature(object = "MEDIPSset")}:  internal function for vectorized calculation of the t.test }
    \item{matMean}{\code{signature(object = "MEDIPSset")}:  internal function for vectorized calculation of the t.test }
    \item{matSd}{\code{signature(object = "MEDIPSset")}:  internal function for vectorized calculation of the t.test }
    \item{matTtest}{\code{signature(object = "MEDIPSset")}:  internal function for vectorized calculation of the t.test  }
   
    
    }
}
\author{Lukas Chavez, Joern Dietrich }
\examples{
showClass("MEDIPSset")
}
\keyword{classes}

\name{MEDIPS.createROIset}
\alias{MEDIPS.createROIset}
\alias{bin.ROIs}
\title{
Creates a MEDIPS ROI SET by reading a suitable input file
}
\description{
Reads the input file and calculates the short read coverage (counts) for the specified regions of interest(ROI).
After reading of the input file, the MEDIPS ROI SET contains information about the input file name, 
the dependent organism, the chromosomes included in the input file, the length of the included chromosomes (automatically loaded), the number of regions, and a GRange object of the ROIs. 
}
\usage{
MEDIPS.createROIset(file=NULL, ROI=NULL, extend=0, shift=0, bn=1, BSgenome=NULL, uniq=1e-3, chr.select=NULL, paired = F, sample_name=NULL, isSecondaryAlignment=FALSE, simpleCigar=TRUE)
}
\arguments{
   \item{file}{
Path and file name of the input data
}
   \item{ROI}{
Data.frame with columns "chr", "start", "end" and "name" of regions of interest
}
  \item{extend}{
defines the number of bases by which the region will be extended before the genome vector is calculated.
Regions will be extended along the plus or the minus strand as defined by their provided strand information.
}
\item{shift}{
As an alternative to the extend parameter, the shift parameter can be specified. Here, the reads are not extended but shifted by the specified number of nucleotides with respect to the given strand infomation.
One of the two parameters extend or shift has to be 0. 
}
\item{bn}{
Number of bins per ROI
}
  \item{BSgenome}{
The reference genome name as defined by BSgenome 
}
\item{uniq}{
The uniq parameter determines, if all reads mapping to exactly the same genomic position should be kept (uniq = 0), replaced by only one representative (uniq = 1), or if the number of stacked reads should be capped by a maximal number of stacked reads per genomic position determined by a poisson distribution of stacked reads genome wide and by a given p-value (1 > uniq > 0) (deafult: 1e-3). The smaller the p-value, the more reads at the same genomic position are potentially allowed.
}
\item{chr.select}{
only data at the specified chromosomes will be processed.
}
\item{paired}{
option for paired end reads
}
\item{sample_name}{
name of the sample to be stored with the MEDIPSROI SET.
}
\item{isSecondaryAlignment}{
option to import only primary alignments.
}
\item{simpleCigar}{
option to import only alignments with simple Cigar string.
}
}
\value{
An object of class MEDIPSroiSet.
}
\author{
Lukas Chavez and Matthias Lienhard
}
\examples{

library("BSgenome.Hsapiens.UCSC.hg19")
bam.file.hESCs.Rep1.MeDIP = system.file("extdata", "hESCs.MeDIP.Rep1.chr22.bam", package="MEDIPSData")
rois=data.frame(chr=c("chr22","chr22"), start=c(19136001, 19753401), stop=c(19136200, 19753500), ID=c("ID_1", "ID_2"))
MSet=MEDIPS.createROIset(file=bam.file.hESCs.Rep1.MeDIP,ROI=rois, BSgenome="BSgenome.Hsapiens.UCSC.hg19", extend=250, shift=0, uniq=1e-3)
}

\name{COUPLINGset-class}
\Rdversion{1.1}
\docType{class}
\alias{COUPLINGset}
\alias{COUPLINGset-class}
\alias{genome_name,COUPLINGset-method}
\alias{window_size,COUPLINGset-method}
\alias{chr_names,COUPLINGset-method}
\alias{chr_lengths,COUPLINGset-method}
\alias{seq_pattern,COUPLINGset-method}
\alias{genome_CF,COUPLINGset-method}
\alias{number_pattern,COUPLINGset-method}
\alias{show,COUPLINGset-method}

\alias{seq_pattern}
\alias{genome_CF}
\alias{number_pattern}

\title{COUPLINGset class and internal functions}
\description{COUPLINGset class is used in the MEDIPS library to store and extract information generated during the creation of a coupling vector.}
\section{Objects from the Class}{
Objects of the classes contain information about sequence pattern information, included chromosomes, and further parameter settings.
A COUPLING SET object is created by the MEDIPS.couplingVector() function.
According slots will be filled during the workflow.
}
\section{Slots}{
  \describe{
	\item{\code{genome_name}:}{Object of class \code{"character"} : the refernce genome }
	\item{\code{window_size}:}{Object of class \code{"numeric"} : the window size for the genome vector }
	\item{\code{chr_names}:}{Object of class \code{"character"} : the names of the chromosomes included within the MEDIPS/COUPLING SET }
	\item{\code{chr_lengths}:}{Object of class \code{"numeric"} : the lengths of the chromosomes included within the MEDIPS/COUPLING SET}
	\item{\code{seq_pattern}:}{Object of class \code{"character"} : the sequence pattern (e.g. CG) }  
	\item{\code{genome_CF}:}{Object of class \code{"numeric"} : the coupling factor at the genomic bins }
	\item{\code{number_pattern}:}{Object of class \code{"numeric"} : the total number of sequence pattern }
  }
}
\section{Methods}{
  \describe{	 
    \item{genome_name}{\code{signature(object = "COUPLINGset")}: extracts the reference genome of the COUPLING SET}
    \item{window_size}{\code{signature(object = "COUPLINGset")}: extracts the window size from the window_size slot COUPLING SET}
    \item{chr_names}{\code{signature(object = "COUPLINGset")}: extracts the names of the chromosomes included within the COUPLING SET }
    \item{chr_lengths}{\code{signature(object = "COUPLINGset")}: extracts the length of the chromosomes included within the COUPLING SET }
    \item{seq_pattern}{\code{signature(object = "COUPLINGset")}: extracts the sequence pattern (e.g. CpG)}
    \item{genome_CF}{\code{signature(object = "COUPLINGset")}: extracts the coupling factor at the genomic bins }
    \item{number_pattern}{\code{signature(object = "COUPLINGset")}: extracts the total number of sequence pattern}
    \item{show}{\code{signature(object = "COUPLINGset")}: prints a summary of the COUPLING SET object content }       
    }
}
\author{Lukas Chavez, Matthias Lienhard, Joern Dietrich}
\examples{
showClass("COUPLINGset")
}
\keyword{classes}

\name{MEDIPS.plotSeqCoverage}
\alias{MEDIPS.plotSeqCoverage}
\title{
Function plots the results of the MEDIPS.seqCoverage function.
}
\description{
The results of the sequence pattern coverage analysis will be visualized in two possible ways.
}
\usage{
MEDIPS.plotSeqCoverage(seqCoverageObj=NULL, main=NULL, type="pie", cov.level = c(0,1,2,3,4,5), t="Inf")
}
\arguments{
  \item{seqCoverageObj}{
The coverage results object returned by the MEDIPS.seqCoverage function.
}
\item{main}{
The title of the coverage plot.
}
\item{type}{
there are two types of visualization. The pie chart (default) illustrates the fraction of CpGs covered by the given reads at different coverage level (see also the parameter cov.level).
As an alternative, a histogram over all coverage level can be ploted ("hist").
}
\item{cov.level}{
The pie chart illustrates the fraction of CpGs covered by the given reads according to their coverage level.
The visualized coverage levels can be adjusted by the cov.level parameter.
}
\item{t}{
specifies the maximal coverage depth to be plotted, if type="hist"
}
}
\value{
The sequence pattern coverage plot will be visualized.
}
\author{
Lukas Chavez
}
\examples{

library(MEDIPSData)
library(BSgenome.Hsapiens.UCSC.hg19)
bam.file.hESCs.Rep1.MeDIP = system.file("extdata", "hESCs.MeDIP.Rep1.chr22.bam", package="MEDIPSData")

cr=MEDIPS.seqCoverage(file=bam.file.hESCs.Rep1.MeDIP, pattern="CG", BSgenome="BSgenome.Hsapiens.UCSC.hg19", chr.select="chr22", extend=250, shift=0, uniq=1e-3, paired=FALSE)

MEDIPS.plotSeqCoverage(seqCoverageObj=cr, main="Sequence pattern coverage", type="pie", cov.level = c(0,1,2,3,4,5))


}

\name{MEDIPS.exportWIG}
\alias{MEDIPS.exportWIG}
\title{
Exports count, rpkm, or sequence pattern densities into a wiggle file.
}
\description{
The function allows for exporting the calculated methylation values (counts or rpkm) or sequence pattern densities from a MEDIPS or COUPLING SET into a wiggle (WIG) file.
The wiggle file will contain values for all genomic windows of the genome/coupling vector and can be used for data visualization using appropriate genome browsers.
Either a MEDIPS SET (parameter MSet) or a COUPLING SET (parameter CSet) has to be given. 
}
\usage{
MEDIPS.exportWIG(Set=NULL, CSet=NULL, file=NULL, format="rpkm", descr="")
}
\arguments{
  \item{Set}{
has to be a MEDIPS SET object. Required when the parameter 'format' is 'count', 'rpkm', or 'rms'.
}
  \item{CSet}{
has to be a COUPLING SET object. Required when the parameter 'format' is 'pdensity' or 'rms'.
}
  \item{file}{
defines the name of the exported file
}
  \item{format}{
if set to "count", there must be a MEDIPS SET at 'Set'. The number of overlapping (extended) short reads per window will be exported.
if set to "rpkm", there must be a MEDIPS SET at 'Set'. The rpkm values will be exported (default). 
If set to "pdensity", there must be a COUPLING SET at 'CSet'. The pattern densities (counts per window) will be exported (parameter Set will be ignored).
If set to 'rms', there must be a MEDIPS SET at 'Set' and a corresponding COUPLING SET at 'CSet'. The CpG density normalized methylatin estimates will be exported.
}
  \item{descr}{
the exported wiggle file will include a track name and description that will be visualized by the utilized genome browser.
Both, track name and description will be the same as defined here.
}  
}
\value{
the funtion exports the specified data from the MEDIPS or COUPLING SET into the stated file
}
\author{
Lukas Chavez
}
\examples{

library("BSgenome.Hsapiens.UCSC.hg19")

bam.file.hESCs.Rep1.MeDIP = system.file("extdata", "hESCs.MeDIP.Rep1.chr22.bam", package="MEDIPSData")
MSet=MEDIPS.createSet(file=bam.file.hESCs.Rep1.MeDIP, BSgenome="BSgenome.Hsapiens.UCSC.hg19", chr.select="chr22", extend=250, shift=0, uniq=1e-3)

MEDIPS.exportWIG(Set=MSet, file="hESCs.Rep1.wig", format="rpkm", descr="hESCs.Rep1")

}

\name{MEDIPS.mergeFrames}
\alias{MEDIPS.mergeFrames}
\title{
Merges genomic coordinates of neighboring windows into one supersized window
}
\description{
After having filtered the result table returned by the MEDIPS.meth function using the MEDIPS.selectSig function, there might be neighboring significant frames.
For these cases it is worthwhile to merge neighbouring regions into one supersized frame.
}
\usage{
MEDIPS.mergeFrames(frames=NULL, distance=1)
}
\arguments{
  \item{frames}{
  is a filtered result table received by the MEDIPS.selectSig function.
}
\item{distance}{
  allows an according number of bases as a gap between neighboring significant windows to be merged.
 The default value is 1 in order to merge adjacent windows.
}
}
\value{
The remaining distinct frames are represented only by their genomic coordinates within the returned results table
\item{chromosome}{the chromosome of the merged frame}
\item{start}{the start position of the merged frame}
\item{stop}{the stop position of the merged frame}
\item{ID}{a numbered ID of the merged frame}
The result table does not contain any merged significant values.
}
\author{
Lukas Chavez
}
\examples{

regions=as.data.frame(list(chr=c("chr22", "chr22"), start=c(1001, 1501), stop=c(1500,1750)))
regions.merged=MEDIPS.mergeFrames(regions)

regions.merged

}

\name{MEDIPSroiSet-class}
\Rdversion{1.1}
\docType{class}
\alias{MEDIPSroiSet-class}
\alias{MEDIPSroiSet}
\alias{rois}
\alias{bin_number}
\alias{ROI,MEDIPSroiSet-method}
\alias{bin_number,MEDIPSroiSet-method}
\alias{genome_name,MEDIPSroiSet-method}
\alias{chr_names,MEDIPSroiSet-method}
\alias{chr_lengths,MEDIPSroiSet-method}
\alias{sample_name,MEDIPSroiSet-method}
\alias{path_name,MEDIPSroiSet-method}
\alias{number_regions,MEDIPSroiSet-method}
\alias{genome_count,MEDIPSroiSet-method}
\alias{extend,MEDIPSroiSet-method}
\alias{show,MEDIPSroiSet-method}
\alias{shifted,MEDIPSroiSet-method}
\alias{uniq,MEDIPSroiSet-method}
\alias{rois,MEDIPSroiSet-method}
\alias{rois}

\title{MEDIPSroiSet class and internal functions}
\description{MEDIPSroiSet class is used in the MEDIPS library in order to store and extract objects and information of the specified regions of interest (ROI) from the input file as well as parameter settings specified during the workflow.}
\section{Objects from the Class}{
Objects of the classes contain information about the provided short reads, MeDIP raw/count signals, and further parameter settings.
A MEDIPS ROI SET object is created by the MEDIPS.createROIset() function.
According slots will be filled during the workflow.
}
\section{Slots}{
  \describe{
	\item{\code{genome_name}:}{Object of class \code{"character"} : the refernce genome }
	\item{\code{chr_names}:}{Object of class \code{"character"} : the names of the chromosomes included within the MEDIPS ROI SET }
	\item{\code{chr_lengths}:}{Object of class \code{"numeric"} : the lengths of the chromosomes included within the MEDIPS ROI SET}
	\item{\code{sample_name}:}{Object of class \code{"character"} : the name of the input file }
	\item{\code{path_name}:}{Object of class \code{"character"} : the path to the input file }
	\item{\code{number_regions}:}{Object of class \code{"numeric"} : the total number of included regions }
	\item{\code{genome_count}:}{Object of class \code{"numeric"} : the raw MeDIP-seq signals at the bins }    
	\item{\code{extend}:}{Object of class \code{"numeric"} : the length of the reads after extension }
	\item{\code{shifted}:}{Object of class \code{"numeric"} : the number of bases by which the reads are shifted along the sequencing direction }
	\item{\code{uniq}:}{Object of class \code{"logical"} : determines if reads mapping to exactly the same genomic position should be replaced by only on representative }
	\item{\code{ROI}:}{Object of class \code{"GRanges"}: the genomic positions of the regions of interest}                
	\item{\code{bin_number}:}{Object of class \code{"numeric"}: the number of bins per region}                

  }
}
\section{Methods}{
  \describe{
    \item{genome_name}{\code{signature(object = "MEDIPSroiSet")}: extracts the reference genome of the MEDIPS ROI SET}    
    \item{bin_number}{\code{signature(object = "MEDIPSroiSet")}: extracts the number of bins per ROI the bin_number slot of the MEDIPS ROI SET}
    \item{chr_names}{\code{signature(object = "MEDIPSroiSet")}: extracts the names of the chromosomes included within the MEDIPS ROI SET }
    \item{chr_lengths}{\code{signature(object = "MEDIPSroiSet")}: extracts the length of the chromosomes included within the MEDIPS ROI SET }
    \item{sample_name}{\code{signature(object = "MEDIPSroiSet")}: extracts the name of the input file}
    \item{path_name}{\code{signature(object = "MEDIPSroiSet")}: extracts the path to the input file}
    \item{number_regions}{\code{signature(object = "MEDIPSroiSet")}: extracts the total number of included regions}
    \item{genome_count}{\code{signature(object = "MEDIPSroiSet")}: extracts the raw MeDIP-Seq signals at the genomic bins }    
    \item{extend}{\code{signature(object = "MEDIPSroiSet")}: extracts the number of bases by which the regions are extended }
    \item{show}{\code{signature(object = "MEDIPSroiSet")}: prints a summary of the MEDIPS SET object content }
    \item{shifted}{\code{signature(object = "MEDIPSroiSet")}: extracts the number of bases by which the regions are shifted }
    \item{uniq}{\code{signature(object = "MEDIPSroiSet")}: extracts the specified value for the uniq parameter }
    \item{rois}{\code{signature(object = "MEDIPSroiSet")}: extracts the GRange object containing the regions of interest }       
    \item{MEDIPS.calibrationCurve}{\code{signature(MSet = "MEDIPSroiSet", CSet="COUPLINGset")}: internal function for calculating the calibration curve}
    \item{MEDIPS.negBin}{\code{signature(MSet="MEDIPSroiSet", CSet="COUPLINGset")}: internal function for calculating methylatiopn probabilities with respect to CpG density dependent negative binomial distributions}
    \item{MEDIPS.pois}{\code{signature(MSet="MEDIPSroiSet", CSet="COUPLINGset")}: internal function for calculating methylatiopn probabilities with respect to CpG density dependent poisson distributions}
    \item{MEDIPS.rms}{\code{signature(MSet="MEDIPSroiSet", CSet="COUPLINGset")}: internal function for calculating relative methylation scores}
    
    }
}
\author{Lukas Chavez, Joern Dietrich }
\examples{
showClass("MEDIPSroiSet")
}
\keyword{classes}

\name{MEDIPS.setAnnotation}
\alias{MEDIPS.setAnnotation}
\title{
Funtion to annotate a matrix of genomic coordinates (i.e. a result table) by a given annotation object.
}
\description{
The function appends any annotation IDs included in the given annotation object to the given regions object.
An annotation object can be retrived by the MEDIPS.getAnnotation function and the regions object is typically a (filtered) result table as returned by the MEDIPS.meth function.
An annotation ID is appended to a genomic region if their genomic coordinates overlap by at least one base.
There will be as many columns added to the regions object as overlapping annotations exist in the annotation object.
}
\usage{
MEDIPS.setAnnotation(regions, annotation, cnv=F)
}
\arguments{
  \item{regions}{
a matrix that contains row-wise genomic regions, e.g. as a result of the MEDIPS.meth function.
}
  \item{annotation}{
the annotation data object contains the genomic coordinates of annotations.
An annotation object can be e.g. retrived by the MEDIPS.getAnnotation function.
}
  \item{cnv}{
the MEDIPS.setAnnotation function is also internally used by the MEDIPS.addCNV function which automatically sets this parameter to TRUE. 
Otherwise cnv should be set to FALSE.
}
}
\value{
The provided result object with added columns containing overlapping annotations.
}
\author{
Joern Dietrich, Matthias Lienhard
}

\examples{
library(MEDIPSData)
data(resultTable)

sig = MEDIPS.selectSig(results=resultTable, p.value=0.05, adj=TRUE, ratio=NULL, bg.counts=NULL, CNV=FALSE)
sig = MEDIPS.mergeFrames(frames=sig, distance=1)
#ens_gene = MEDIPS.getAnnotation( annotation="GENE",chr="chr22")
#sig = MEDIPS.setAnnotation(regions=sig, annotation=ens_gene)

}

\name{MEDIPS.seqCoverage}
\alias{MEDIPS.seqCoverage}
\title{
The function identifies the number of CpGs (or any other predefined sequence pattern) covered by the given short reads.
}
\description{
The main idea of the sequence pattern coverage analysis is to test the number of CpGs (or any other predefined sequence pattern) covered by the given short reads and to test the depth of coverage.
}
\usage{
MEDIPS.seqCoverage(file = NULL, BSgenome = NULL, pattern = "CG", extend = 0, shift = 0, uniq = 1e-3, chr.select = NULL, paired = F, isSecondaryAlignment = FALSE, simpleCigar=TRUE)
}
\arguments{
 \item{file}{
Path and file name of the input data
}
 \item{BSgenome}{
The reference genome name as defined by BSgenome 
}
 \item{pattern}{
defines the sequence pattern, e.g. CG for CpGs.
} 
  \item{extend}{
defines the number of bases by which the region will be extended before the genome vector is calculated.
Regions will be extended along the plus or the minus strand as defined by their provided strand information.
Please note, the extend and shift parameter are mutual exclusive.
}
  \item{shift}{
defines the number of bases by which the region will be shifted before the genome vector is calculated.
Regions will be shifted along the plus or the minus strand as defined by their provided strand information.
Please note, the extend and shift parameter are mutual exclusive.
}
  \item{uniq}{
The uniq parameter determines, if all reads mapping to exactly the same genomic position should be kept (uniq = 0), replaced by only one representative (uniq = 1), or if the number of stacked reads should be capped by a maximal number of stacked reads per genomic position determined by a poisson distribution of stacked reads genome wide and by a given p-value (1 > uniq > 0) (deafult: 1e-3). The smaller the p-value, the more reads at the same genomic position are potentially allowed.
}
  \item{chr.select}{
specify a subset of chromosomes for which the saturation analysis is performed.
}
\item{paired}{
option for paired end reads
}
\item{isSecondaryAlignment}{
option to import only primary alignments.
}
\item{simpleCigar}{
option to import only alignments with simple Cigar string.
}
}
\author{
Lukas Chavez
}
\examples{

library(MEDIPSData)
library(BSgenome.Hsapiens.UCSC.hg19)
bam.file.hESCs.Rep1.MeDIP = system.file("extdata", "hESCs.MeDIP.Rep1.chr22.bam", package="MEDIPSData")

cr = MEDIPS.seqCoverage(file=bam.file.hESCs.Rep1.MeDIP, BSgenome="BSgenome.Hsapiens.UCSC.hg19", pattern="CG", extend=250, shift=0, uniq=1e-3, chr.select="chr22")

}

\name{MEDIPS.meth}
\alias{MEDIPS.meth}
\alias{MEDIPS.diffMeth}

\title{
Funtion summarizes coverage profiles for given MEDIPS SETs and allows to calculate differental coverage and copy number vartiation, if applicable. 
}
\description{
The function summarizes coverage profiles (counts, rpkm) for given MEDIPS SETs at the slots MSet1, MSet2, ISet1, and ISet1.
In case the parameter MeDIP is set to TRUE and a COUPLING SET was provided at the slot CS, 
the function will calculate CpG density normalized methylation profiles (relative methylation score, rms) for the MEDIPS SETs at the slots MSet1 and MSet2.
In case two groups of MEDIPS SETs have been provided at MSet1 and MSet2, the function will calculate differential coverage.
In case two groups of MEDIPS SETs have been provided at ISet1 and ISet2 and the parameter CNV was set to TRUE, 
the function will calculate copy number variation.
The function allows for processing a variable number of provided MEDIPS SETs and therefore, the returned matrix is of variable length.
}
\usage{
MEDIPS.meth(MSet1 = NULL, MSet2 = NULL, CSet = NULL, ISet1 = NULL, ISet2 = NULL, chr = NULL, p.adj="bonferroni", diff.method="edgeR", CNV=FALSE, MeDIP=FALSE, minRowSum=10, diffnorm="tmm")
}
\arguments{
  \item{MSet1}{
has to be one or a concatenated list of MEDIPS SET objects (the control replicates)
}
  \item{MSet2}{
has to be one or a concatenated list of MEDIPS SET objects (the treatment data) or empty
}
  \item{CSet}{
has to be a COUPLING SET object (must fit the given MEDIPS SET objects with respect to reference genome and represented chromosomes)
}
  \item{ISet1}{
has to be one or a concatenated list of Input derived MEDIPS SET objects (general Input data or Inputs from the control replicates) or empty
}
   \item{ISet2}{
has to be one or a concatenated list of Input derived MEDIPS SET objects (Inputs from the treatment replicates) or empty
}
   \item{chr}{
specify one or several chromosomes (e.g. c("chr1", "chr2")), if only a subset of available chromosomes have to be processed. 
}
  \item{p.adj}{
in order to correct p.values derived from the differential coverage analysis for multiple testing, MEDIPS uses Rs' p.adjust function.
Therefore, the following methods are available: holm, hochberg, hommel, bonferroni (default) , BH, BY, fdr, none.
}
  \item{diff.method}{
method for calculating differential coverage. Available methods: ttest (default) and edgeR.
}
  \item{CNV}{
In case there are INPUT SETs provided at both Input slots (i.e. ISet1 and ISet2), 
copy number variation will be tested by applying the package DNAcopy to the window-wise log-ratios calculated based on the the means per group. 
By setting CNV=F this function will be disabled (default: CNV=TRUE). 
Please note, there is the function MEDIPS.addCNV which allows to run the CNV analysis on two groups of INPUT SETs using another (typically increased) window size.
}
  \item{MeDIP}{
This parameter determines, whether for the MEDIPS SETs given at the slots MSet1 and MSet2, CpG density dependent normalization values (rms and prob) will be calculated (default: MeDIP=TRUE).  
}
  \item{minRowSum}{
threshold for the sum of counts in a window for the staistical test (default=10). 
}
   \item{diffnorm}{
This parameter defines which normalisation method is applied prior to testing for differential enrichment between conditions (default='tmm'). tmm, quantile and none are possible when diff.method=edgeR while rpkm and rms are possible when diff.method=ttest.
}
}

\value{
\item{Chr}{the chromosome of the ROI}
\item{Start}{the start position of the ROI}
\item{Stop}{the stop position of the ROI}
\item{CF}{the number of CpGs in the window}
\item{*counts}{a variable number of columns (according to the number of provided MEDIPS SETs) containing for each set the number of (extended/shifted) reads that overlap with the window.}
\item{*rpkm}{a variable number of columns (according to the number of provided MEDIPS SETs) containing for each set the rpkm value of the window.}
\item{*rms}{optional (if MeDIP=TRUE): a variable number of columns (according to the number of provided MEDIPS SETs) containing for each set the rms value of the window.}
\item{*counts}{optional (if INPUT SETs given): a variable number of columns (according to the number of provided INPUT SETs) containing for each set the number of (extended/shifted) reads that overlap with the window.}
\item{*rpkm}{optional (if INPUT SETs given): a variable number of columns (according to the number of provided INPUT SETs) containing for each set the rpkm value of the window.}
\item{MSets1.counts.mean}{optional (if more than one MEDIPS SET given): the mean count over all MEDIPS SETs at MSet1.}
\item{MSets1.rpkm.mean}{optional (if more than one MEDIPS SET given): the mean rpkm value over all MEDIPS SETs at MSet1.}
\item{MSets1.rms.mean}{optional (if more than one MEDIPS SET given): the mean rms value over all MEDIPS SETs at MSet1.}
\item{MSets2.counts.mean}{optional (if more than one MEDIPS SET given): the mean count over all MEDIPS SETs at MSet2.}
\item{MSets2.rpkm.mean}{optional (if more than one MEDIPS SET given): the mean rpkm value over all MEDIPS SETs at MSet2.}
\item{MSets2.rms.mean}{optional (if more than one MEDIPS SET given): the mean rms value over all MEDIPS SETs at MSet2.}
\item{ISets1.counts.mean}{optional (if more than one INPUT SET given): the mean count over all INPUT SETs at ISet1.}
\item{ISets1.rpkm.mean}{optional (if more than one INPUT SET given): the mean rpkm value over all INPUT SETs at ISet1.}
\item{ISets2.counts.mean}{optional (if more than one INPUT SET given): the mean count over all INPUT SETs at ISet2.}
\item{ISets2.rpkm.mean}{optional (if more than one INPUT SET given): the mean rpkm value over all INPUT SETs at ISet2.}
\item{edgeR.logFC}{optional (if diff.method=edgeR): log fold change between MSet1 and MSet2 as returned by edgeR.}
\item{edgeR.logCPM}{optional (if diff.method=edgeR): logCPM between MSet1 and MSet2 as returned by edgeR.}
\item{edgeR.p.value}{optional (if diff.method=edgeR): p.value as returned by edgeR.}
\item{edgeR.adj.p.value}{optional (if diff.method=edgeR): adjusted p.value as calculated by the p.adjust function using edgeR's p.values as input.}
\item{score.log2.ratio}{optional (if diff.method=ttest): log2 fold change between the means of the groups MSet1 and MSet2.}
\item{score.p.value}{optional (if diff.method=ttest): p.value as returned by the t.test function.}
\item{score.adj.p.value}{optional (if diff.method=ttest): adjusted p.value as calculated by the p.adjust function using the ttest p.values as input.}
\item{score}{optional (if diff.method=ttest): score = (-log10(score.p.value)*10)*log(score.log2.ratio)}
\item{CNV.log2.ratio}{optional (if two INPUT SETs given and CNV=TRUE): the log2 ratio for segments as calculated by the DNAcopy package.}
}
\author{
Lukas Chavez, Matthias Lienhard, Joern Dietrich
}
\examples{
library(MEDIPSData)
data(hESCs_MeDIP)
data(DE_MeDIP)
data(hESCs_Input)
data(DE_Input)
data(CS)

resultTable = MEDIPS.meth(MSet1 = hESCs_MeDIP, MSet2 = DE_MeDIP, CSet = CS, ISet1 = hESCs_Input, ISet2 = DE_Input, chr = "chr22", p.adj="bonferroni", diff.method="edgeR", CNV=FALSE, MeDIP=FALSE, diffnorm="tmm")
}

\name{MEDIPS-package}
\alias{MEDIPS-package}
\alias{MEDIPS}
\docType{package}
\title{
(MeD)IP-seq data analysis
}
\description{
MEDIPS was developed for analyzing data derived from methylated DNA immunoprecipitation (MeDIP) experiments followed by sequencing (MeDIP-seq). 
Nevertheless, several functionalities may be applied to other types of sequencing data (e.g. differential coverage or testing the saturation of ChIP-seq data). 
MEDIPS addresses several aspects in the context of MeDIP-seq data analysis including basic data processing, several quality controls, normalization, and identification of differential coverage.
}
\details{
\tabular{ll}{
Package: \tab MEDIPS\cr
Type: \tab Package\cr
License: \tab GPL (>=2)\cr
LazyLoad: \tab yes\cr
}
}
\author{
Lukas Chavez, Matthias Lienhard, Joern Dietrich

Maintainer: Lukas Chavez <lchavez@liai.org>
}
\references{
Chavez L, Jozefczuk J, Grimm C, Dietrich J, Timmermann B, Lehrach H, Herwig R, Adjaye J., Computational analysis of genome-wide DNA methylation during the differentiation of human embryonic stem cells along the endodermal lineage, Genome Res. 2010 Oct;20(10):1441-50. Epub 2010 Aug 27.
}
\keyword{ package }

\name{MEDIPS.selectSig}
\alias{MEDIPS.selectSig}
\title{
Selects windows which show significant differential coverage between two MEDIPS SETs from a resultTable (as returned by the function MEDIPS.meth).
}
\description{
Based on the results table returned by the MEDIPS.meth function,
the function selects windows which show significant differential coverage between the two groups of MEDIPS SETs.
Selection of significant windows follows according to the specification of the available parameters.
}
\usage{
MEDIPS.selectSig(results=NULL, p.value=0.01, adj=T, ratio=NULL, bg.counts=NULL, CNV=F)
}
\arguments{
  \item{results}{
specifies the result table derived from the MEDIPS.meth function.
}
  \item{p.value}{
this is the p.value threshold as calculated either by the ttest or edgeR method
}
  \item{adj}{
this parameter specifies whether the p.value or the adjusted p.values is considered
}
\item{ratio}{
this parameter sets an additional thresold for the ratio where the ratio is either score.log2.ratio or edgeR.logFC depending on the previously selected method.
Please note, the specified value will be transformed into log2 internally.
}
  \item{bg.counts}{
as an additional filter parameter, it is possible to require a minimal number of reads per window in at least one of the MEDIPS SET groups.
For this, the mean of counts per group is considered. The parameter bg.counts can either be a concrete integer or an appropriate column name of the result table.
By specifying a column name, the 0.95 quantile of the according genome wide count distribution is determined and used as a minimal background threshold 
(please note, only count columns are reasonable).  
}
  \item{CNV}{
The information on CNVs present in the samples of interest can be used for correcting differential coverage observed in the corresponding IP data (e.g. MeDIP or ChIP data).
In case Input data has been provided for both conditions, MEDIPS is capable of calculating genome wide CNV ratios by employing the package DNAcopy.
In case the parameter CNV is set to TRUE, MEDIPS will subtract the CNV ratio from the IP ratio. 
Subsequently, only genomic windows having a CNV corrected IP ratio higher than the specified ratio threshold (specification of the ratio parameter is required in this case) 
will be considered as windows with sufficient differential IP coverage.
}
}
\author{
Lukas Chavez, Matthias Lienhard
}
\examples{

library(MEDIPSData)
data(resultTable)

sig = MEDIPS.selectSig(results=resultTable, p.value=0.05, adj=TRUE, ratio=NULL, bg.counts=NULL, CNV=FALSE)

}

\name{MEDIPS.addCNV}
\alias{MEDIPS.addCNV}
\title{
Function to run a copy number variation analysis.
}
\description{
Function calculates a CNV analysis based on two INPUT SETs by employing the DNAcopy package.
The results are attached to a provided result table.
}
\usage{
MEDIPS.addCNV(ISet1, ISet2, results, cnv.Frame=1000)
}
\arguments{
  \item{ISet1}{
First group of INPUT SETs
}
  \item{ISet2}{
Second group of INPUT SETs
}
\item{results}{
result table as returned by the MEDIPS.meth function
}
\item{cnv.Frame}{
window size used for calculating CNVs. Can be of different size than the result table.
}
}
\value{
The result table with an additional column containing DNAcopy's log-ratio.
}
\author{
Joern Dietrich
}

\examples{
library(MEDIPSData)
library("BSgenome.Hsapiens.UCSC.hg19")

bam.file.hESCs.Input = system.file("extdata", "hESCs.Input.chr22.bam", package="MEDIPSData")
bam.file.DE.Input = system.file("extdata", "DE.Input.chr22.bam", package="MEDIPSData")

hESCs.Input = MEDIPS.createSet(file=bam.file.hESCs.Input, BSgenome="BSgenome.Hsapiens.UCSC.hg19", extend=250, shift=0, uniq=1e-3, window_size=100, chr.select="chr22")
DE.Input = MEDIPS.createSet(file=bam.file.DE.Input, BSgenome="BSgenome.Hsapiens.UCSC.hg19", extend=250, shift=0, uniq=1e-3, window_size=100, chr.select="chr22")

data(resultTable)

resultTable = MEDIPS.addCNV(cnv.Frame=10000, ISet1=hESCs.Input, ISet2=DE.Input, results=resultTable)
}

\name{MEDIPS.saturation}
\alias{MEDIPS.saturation}
\title{
Function calculates the saturation/reproducibility of the provided IP-Seq data.
}
\description{
The saturation analysis addresses the question, whether the number of short reads is sufficient to generate a saturated and reproducible coverage profile of the reference genome.
The main idea is that an insufficent number of short reads will not result in a saturated methylation profile. 
Only if there is a sufficient number of short reads, the resulting genome wide coverage profile will be reproducible by another independent set of a similar number of short reads.
}
\usage{
MEDIPS.saturation(file=NULL, BSgenome=NULL, nit=10, nrit=1, empty_bins=TRUE, rank=FALSE, extend=0, shift=0,  window_size=500, uniq=1e-3, chr.select=NULL, paired = F, isSecondaryAlignment = FALSE, simpleCigar=TRUE)
}
\arguments{
  \item{file}{
Path and file name of the IP data
}
  \item{BSgenome}{
The reference genome name as defined by BSgenome 
}  
  \item{nit}{
defines the number of subsets created from the full sets of available regions (default=10)
}
  \item{nrit}{
methods which randomly select data entries may be processed several times in order to obtain more stable results. 
By specifying the nrit parameter (default=1) it is possible to run the saturation analysis several times. 
The final results returned to the saturation results object are the averaged results of each random iteration step. 
}
  \item{empty_bins}{
can be either TRUE or FALSE (default TRUE). This parameter effects the way of calculating correlations between the resulting genome vectors. 
A genome vector consists of concatenated vectors for each included chromosome. The size of the vectors is defined by the bin_size parameter.
If there occur genomic bins which contain no overlapping regions, neither from the subsets of A nor from the subsets of B, 
these bins will be neglected when the paramter is set to FALSE.
}
  \item{rank}{
can be either TRUE or FALSE (default FALSE). This parameter also effects the way of calculating correlations between the resulting genome vectors.
If rank is set to TRUE, the correlation will be calculated for the ranks of the windows instead of considering the counts (Spearman correlation).
Setting this parameter to TRUE is a more robust approach that reduces the effect of possible occuring outliers (these are windows with a very high number of overlapping regions) to the correlation.
}
  \item{extend}{
defines the number of bases by which the region will be extended before the genome vector is calculated.
Regions will be extended along the plus or the minus strand as defined by their provided strand information.
Please note, the extend and shift parameter are mutual exclusive.
}
\item{shift}{
defines the number of bases by which the region will be shifted before the genome vector is calculated.
Regions will be shifted along the plus or the minus strand as defined by their provided strand information.
Please note, the extend and shift parameter are mutual exclusive.
}
  \item{window_size}{
defines the size of genome wide windows and therefore, the size of the genome vector. 
}
\item{uniq}{
The uniq parameter determines, if all reads mapping to exactly the same genomic position should be kept (uniq = 0), replaced by only one representative (uniq = 1), or if the number of stacked reads should be capped by a maximal number of stacked reads per genomic position determined by a poisson distribution of stacked reads genome wide and by a given p-value (1 > uniq > 0) (deafult: 1e-3). The smaller the p-value, the more reads at the same genomic position are potentially allowed.
}
\item{chr.select}{
specify a subset of chromosomes for which the saturation analysis is performed.
}
\item{paired}{
option for paired end reads
}
\item{isSecondaryAlignment}{
option to import only primary alignments.
}
\item{simpleCigar}{
option to import only alignments with simple Cigar string.
}
}
\value{
\item{distinctSets}{Contains the results of each iteration step (row-wise) of the saturation analysis.
The first column is the number of considered regions in each set, the second column is the resulting pearson correlation coefficient when comparing the two independent genome vectors.}
\item{estimation}{Contains the results of each iteration step (row-wise) of the estimated saturation analysis.
The first column is the number of considered regions in each set, the second column is the resulting pearson correlation coefficient when comparing the two independent genome vectors.}
\item{distinctSets}{the total number of available regions}
\item{maxEstCor}{contains the best pearson correlation (second column) obtained by considering the artifically doubled set of reads (first column)}
\item{distinctSets}{contains the best pearson correlation (second column) obtained by considering the total set of reads (first column)}
}
\author{
Lukas Chavez
}
\examples{

library(MEDIPSData)
library(BSgenome.Hsapiens.UCSC.hg19)
bam.file.hESCs.Rep1.MeDIP = system.file("extdata", "hESCs.MeDIP.Rep1.chr22.bam", package="MEDIPSData")

sr=MEDIPS.saturation(file=bam.file.hESCs.Rep1.MeDIP, BSgenome="BSgenome.Hsapiens.UCSC.hg19", uniq=1e-3, extend=250, shift=0, window_size=100, chr.select="chr22", nit=10, nrit=1, empty_bins=TRUE, rank=FALSE)

}

\name{MEDIPS.createSet}
\alias{MEDIPS.createSet}
\alias{getMObjectFromWIG}
\alias{readRegionsFile}
\alias{getPairedGRange}
\alias{scanBamToGRanges}

\title{
Creates a MEDIPS SET by reading a suitable input file
}
\description{
Reads the input file and calculates genome wide short read coverage (counts) at the specified window size.
After reading of the input file, the MEDIPS SET contains information about the input file name, 
the dependent organism, the chromosomes included in the input file, the length of the included chromosomes (automatically loaded), and the number of regions. 
}
\usage{
MEDIPS.createSet(file=NULL, extend=0, shift=0, window_size=300, BSgenome=NULL, uniq=1e-3, chr.select=NULL, paired = F, sample_name=NULL, isSecondaryAlignment = FALSE, simpleCigar=TRUE)
}
\arguments{
   \item{file}{
Path and file name of the input data
}
  \item{BSgenome}{
The reference genome name as defined by BSgenome 
}
  \item{extend}{
defines the number of bases by which the region will be extended before the genome vector is calculated.
Regions will be extended along the plus or the minus strand as defined by their provided strand information.
}
\item{shift}{
As an alternative to the extend parameter, the shift parameter can be specified. Here, the reads are not extended but shifted by the specified number of nucleotides with respect to the given strand infomation.
One of the two parameters extend or shift has to be 0. 
}
\item{uniq}{
The uniq parameter determines, if all reads mapping to exactly the same genomic position should be kept (uniq = 0), replaced by only one representative (uniq = 1), or if the number of stacked reads should be capped by a maximal number of stacked reads per genomic position determined by a poisson distribution of stacked reads genome wide and by a given p-value (1 > uniq > 0) (deafult: 1e-3). The smaller the p-value, the more reads at the same genomic position are potentially allowed.
}
\item{chr.select}{
only data at the specified chromosomes will be processed.
}
\item{window_size}{
defines the genomic resolution by which short read coverage is calculated. 
}
\item{paired}{
option for paired end reads
}
\item{sample_name}{
name of the sample to be stored with the MEDIPS SET.
}
\item{isSecondaryAlignment}{
option to import only primary alignments.
}
\item{simpleCigar}{
option to import only alignments with simple Cigar string.
}
}
\value{
An object of class MEDIPSset.
}
\author{
Lukas Chavez, Mathias Lienhard, Isaac Lopez Moyado
}
\examples{

library("BSgenome.Hsapiens.UCSC.hg19")
bam.file.hESCs.Rep1.MeDIP = system.file("extdata", "hESCs.MeDIP.Rep1.chr22.bam", package="MEDIPSData")

MSet=MEDIPS.createSet(file=bam.file.hESCs.Rep1.MeDIP, BSgenome="BSgenome.Hsapiens.UCSC.hg19", chr.select="chr22", extend=250, shift=0, uniq=1e-3)

}

\name{MEDIPS.correlation}
\alias{MEDIPS.correlation}
\title{
Calculates pairwise Pearson correlations between provided MEDIPS SETs
}
\description{
The function calculates genome wide Pearson correlations between all pairs of provided MEDIPS SETs.
}
\usage{
MEDIPS.correlation(MSets=NULL, plot = T, method="spearman")
}
\arguments{
  \item{MSets}{
a concatenated set of MEDIPS SETs
}
  \item{plot}{
if specified, the correlation will be depicted as a scatter plot
}
\item{method}{
default: spearman; alternatives: kendall, spearman
}
}
\value{
a correlation matrix
}
\author{
Lukas Chavez
}
\examples{

library(MEDIPSData)
data(hESCs_MeDIP)
data(DE_MeDIP)

correlation = MEDIPS.correlation(MSets=c(hESCs_MeDIP[[1]], DE_MeDIP[[1]]), plot = FALSE)

}

\name{MEDIPS.selectROIs}
\alias{MEDIPS.selectROIs}
\title{
Selects row-wise subsets of a result table as returned by the MEDIPS.meth function.
}
\description{
MEDIPS provides the functionality to select subsets of the result matrix returned by the MEDIPS.meth function according to any given set of regions of interest (ROIs).
}
\usage{
MEDIPS.selectROIs(results=NULL, rois=NULL, columns=NULL, summarize=NULL)
}
\arguments{
  \item{results}{
a result table as returned by the function MEDIPS.meth
}
  \item{rois}{
A matrix containing genomic coordinates of any regions of interest.
}
  \item{columns}{
Only selected columns will be returned as determined by the columns parameter.
It is possible to specify one or more concrete column names, please see an example below.
}
\item{summarize}{
By setting summarize=NULL (default) all windows included in the genomic ranges of the given ROIs will be returned.
As an alternative, it is possible to calculate mean (summarize = "avg") or sum (summarize = "sum") values over the individual windows included in each ROI,
or to select only the most significant window within each given ROI (summarize="minP").
}
}
\author{
Lukas Chavez, Matthias Lienhard
}
\examples{

library(MEDIPSData)
data(resultTable)

rois=data.frame(chr=c("chr22","chr22"), start=c(19136001, 19753401), stop=c(19136200, 19753500), ID=c("ID_1", "ID_2"))
columns=names(resultTable)[grep("counts|rpkm|logFC",names(resultTable))]
s = MEDIPS.selectROIs(results=resultTable, rois=rois, columns=columns, summarize=NULL)


}

\name{MEDIPS.mergeSets}
\alias{MEDIPS.mergeSets}
\title{
Creates one merged MEDIPS SET out of two.
}
\description{
A MEDIPS SET contains a genome vector which is the count coverage at genome wide windows.
Moreover, the MEDIPS SET stores the total number of reads given for calculating the genome vector.
Two MEDIPS SETs can be merged whenever they have been construcetd based on the same reference genome, the same set of chromosomes and for the same window size.
The returned MEDIPS SET will contain a genome vector where at each window the counts of both given MEDIPS SETs are added. 
In addtion, the total number of reads will be the sum of both given MEDIPS SETs.
Please note, several other attributes like the extend or shift value can be different in both of the given MEDIPS SETs and will be empty in the merged MEDIPS SET.
The merged MEDIPS SET will not contain any path to a concrete input file anymore and therefore, cannot be used for the MEDIPS.addCNV function anymore. 
}
\usage{
MEDIPS.mergeSets(MSet1=NULL, MSet2=NULL, name="Merged Set")
}
\arguments{
  \item{MSet1}{
  A MEDIPS SET object as created by the MEDIPS.createSet function
}
\item{MSet2}{
  A MEDIPS SET object as created by the MEDIPS.createSet function
}
\item{name}{
  The new sample name of the merged MEDIPS SET
}
}
\author{
Lukas Chavez
}
\examples{

library(MEDIPSData)
data(hESCs_Input)
data(DE_Input)

merged_Set = MEDIPS.mergeSets(hESCs_Input, DE_Input, name="Merged_input")

merged_Set

}

\name{MEDIPS.couplingVector}
\alias{MEDIPS.couplingVector}
\title{
Calculates the sequence pattern densities at genome wide windows.
}
\description{
The function calculates the local densities of a defined sequence pattern (e.g. CpGs)
and returns a COUPLING SET object which is necessary for normalizing MeDIP data.
}
\usage{
MEDIPS.couplingVector(pattern="CG", refObj=NULL)
}
\arguments{
  \item{pattern}{
defines the sequence pattern, e.g. CG for CpGs.
}
  \item{refObj}{
a MEDIPS Set or MEDIPS ROI Set that serves as reference for the genome and window parameters. 
}
}
\value{
A COUPLING SET object.
}
\author{
Lukas Chavez
}
\examples{

library("MEDIPSData")
library("BSgenome.Hsapiens.UCSC.hg19")

data(hESCs_MeDIP)
CS = MEDIPS.couplingVector(pattern="CG", refObj=hESCs_MeDIP)

}

\name{MEDIPS.CpGenrich}
\alias{MEDIPS.CpGenrich}
\title{
Calculates CpG enrichment of provided short reads compared to the reference genome.
}
\description{
As a quality check for the enrichment of CpG rich DNA fragments obtained by the immunoprecipitation step of a MeDIP experiment, this function provides the functionality to calculate CpG enrichment values. 
The main idea is to check, how strong the regions are enriched for CpGs compared to the reference genome.
For this, the function counts the number of Cs, the number of Gs, the number CpGs, and the total number of bases within the stated reference genome. 
Subsequently, the function calculates the relative frequency of CpGs and the observed/expected ratio of CpGs present in the reference genome.
Additionally, the function calculates the same for the DNA sequences underlying the given regions.
The final enrichment values result by dividing the relative frequency of CpGs (or the observed/expected value, respectively) of the regions by 
the relative frequency of CpGs (or the observed/expected value, respectively) of the reference genome.
}
\usage{
MEDIPS.CpGenrich(file=NULL, BSgenome=NULL, extend=0, shift=0, uniq=1e-3, chr.select=NULL, paired=F)
}
\arguments{
   \item{file}{
Path and file name of the input data
}
  \item{BSgenome}{
The reference genome name as defined by BSgenome 
}
  \item{extend}{
defines the number of bases by which the region will be extended before the genome vector is calculated.
Regions will be extended along the plus or the minus strand as defined by their provided strand information.
}
\item{shift}{
As an alternative to the extend parameter, the shift parameter can be specified. Here, the reads are not extended but shifted by the specified number of nucleotides with respect to the given strand infomation.
One of the two parameters extend or shift has to be 0. 
}
\item{uniq}{
The uniq parameter determines, if all reads mapping to exactly the same genomic position should be kept (uniq = 0), replaced by only one representative (uniq = 1), or if the number of stacked reads should be capped by a maximal number of stacked reads per genomic position determined by a poisson distribution of stacked reads genome wide and by a given p-value (1 > uniq > 0) (deafult: 1e-3).
}
\item{chr.select}{
only data at the specified chromosomes will be processed.
}
\item{paired}{
option for paired end reads
}
}
\value{
\item{regions.CG}{the numbe of CpGs within the regions}
\item{regions.C}{the number of Cs within the regions}
\item{regions.G}{the number of Gs within the regions}
\item{regions.relH}{the relative frequency of CpGs within the regions}
\item{regions.GoGe}{the observed/expected ratio of CpGs within the regions}
\item{genome.CG}{the numbe of CpGs within the reference genome}
\item{genome.C}{the number of Cs within the reference genome}
\item{genome.G}{the number of Gs within the reference genome}
\item{genome.relH}{the relative frequency of CpGs within the reference genome}
\item{genome.GoGe}{the observed/expected ratio of CpGs within the reference genome}
\item{enrichment.score.relH}{regions.relH/genome.relH}
\item{enrichment.score.GoGe}{regions.GoGe/genome.GoGe}
}
\author{
Joern Dietrich and Matthias Lienhard
}
\examples{

library(MEDIPSData)
library("BSgenome.Hsapiens.UCSC.hg19")
bam.file.hESCs.Rep1.MeDIP = system.file("extdata", "hESCs.MeDIP.Rep1.chr22.bam", package="MEDIPSData")

#er=MEDIPS.CpGenrich(file=bam.file.hESCs.Rep1.MeDIP, BSgenome="BSgenome.Hsapiens.UCSC.hg19", chr.select="chr22", extend=0, shift=0, uniq=1e-3)
}

\name{MEDIPS.plotSaturation}
\alias{MEDIPS.plotSaturation}
\title{
Function plots the results of the MEDIPS.saturationAnalysis function.
}
\description{
The results of the saturation analysis will be visualized by the function.
}
\usage{
MEDIPS.plotSaturation(saturationObj = NULL, main="Saturation analysis")
}
\arguments{
  \item{saturationObj}{
The saturation results object returned by the MEDIPS.saturationAnalysis function
}
\item{main}{
The title of the coverage plot.
}
}
\value{
The coverage plot will be visualized.
}
\author{
Lukas Chavez
}
\examples{

library(MEDIPSData)
library(BSgenome.Hsapiens.UCSC.hg19)
bam.file.hESCs.Rep1.MeDIP = system.file("extdata", "hESCs.MeDIP.Rep1.chr22.bam", package="MEDIPSData")

sr=MEDIPS.saturation(file=bam.file.hESCs.Rep1.MeDIP, BSgenome="BSgenome.Hsapiens.UCSC.hg19", uniq=1e-3, extend=250, shift=0, window_size=100, chr.select="chr22", nit=10, nrit=1, empty_bins=TRUE, rank=FALSE)
MEDIPS.plotSaturation(saturationObj = sr, main="Saturation analysis")

}
